
#include <vcl.h>
#pragma hdrstop

#include "ATViewerMsg.h"



#include <sysutils.hpp>
#include <forms.hpp>



#include "d2c_system.h"


bool ATViewerMessagesEnabled = true;
AnsiString MsgViewerCaption = "Viewer";
AnsiString MsgViewerShowCfm = "Format not known\x0d" "Click here to show binary dump";
AnsiString MsgViewerErrCannotFindFile = "File not found: \"%s\"";
AnsiString MsgViewerErrCannotFindFolder = "Folder not found: \"%s\"";
AnsiString MsgViewerErrCannotOpenFile = "Cannot open file: \"%s\"";
AnsiString MsgViewerErrCannotLoadFile = "Cannot load file: \"%s\"";
AnsiString MsgViewerErrCannotReadFile = "Cannot read file: \"%s\"";
AnsiString MsgViewerErrCannotReadStream = "Cannot read stream";
AnsiString MsgViewerErrCannotReadPos = "Read error at offset %s";
AnsiString MsgViewerErrImage = "Unknown image format";
AnsiString MsgViewerErrMedia = "Unknown multimedia format";
AnsiString MsgViewerErrInitControl = "Cannot initialize %s";
AnsiString MsgViewerErrCannotCopyData = "Cannot copy data to Clipboard";
AnsiString MsgViewerWlxException = "Exception in plugin \"%s\" in function \"%s\"";
AnsiString MsgViewerWlxParentNotSpecified = "Cannot load plugins: parent form not specified";
AnsiString MsgViewerAniTitle = "Title: ";
AnsiString MsgViewerAniCreator = "Creator: ";
AnsiString MsgViewerPageHint = "Previous/Next page\x0d" "Current page: %d of %d";



int __fastcall MsgBox( const WideString Msg, const WideString Title, int Flags, void* HWND )
{
  int result = 0;
  if ( ATViewerMessagesEnabled )
    //MessageBoxW supported under Win9x
    result = MessageBoxW( HWND, Msg.c_bstr(), Title.c_bstr(), Flags | MB_SETFOREGROUND | MB_TASKMODAL );
  else
    result = IDCANCEL;
  return result;
}


void __fastcall MsgInfo( const WideString Msg, void* HWND )
{
  MsgBox( Msg, MsgViewerCaption, MB_OK | MB_ICONINFORMATION, HWND );
}


void __fastcall MsgError( const WideString Msg, void* HWND )
{
  MsgBox( Msg, MsgViewerCaption, MB_OK | MB_ICONERROR, HWND );
}


void __fastcall MsgWarning( const WideString Msg, void* HWND )
{
  MsgBox( Msg, MsgViewerCaption, MB_OK | MB_ICONEXCLAMATION, HWND );
}
