
#include <vcl.h>
#pragma hdrstop

#include "main.h"




#include "ATxSProc.h"
#include "ATxFProc.h"
#include "ATxCodepages.h"



#define UFormView__0 ( System::Set< TATBinHexMode, vbmodeText, vbmodeUHex >() \
                     << TATBinHexMode ( 0 ) << TATBinHexMode ( 3 ) )
#define UFormView__1 ( System::Set< TATBinHexMode, vbmodeText, vbmodeUHex >() \
                     << TATBinHexMode ( 3 ) << TATBinHexMode ( 4 ) )


TFormView * FormView;
#pragma resource "*.DFM"

/*
procedure TFormView.LVExChange(
  Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  NS: TNamespace;
  S: WideString;
  OK: boolean;
begin
  with LVEx do
    if ValidateNameSpace(GetFirstSelected, NS) then
      begin
      S:= NS.NameForParsing;
      OK:= IsFileExist(S);

      if OK then
        {$ifdef STREAMS}
        begin
        //Free current stream
        if Assigned(FStream) then
          begin
          Viewer.OpenStream(nil, false);
          FStream.Free;
          FStream:= nil;
          end;
        //Create and open new stream
        try
          FStream:= TTntFileStream.Create(S, fmOpenRead or fmShareDenyNone);
          OK:= Viewer.OpenStream(FStream);
        except
          if Assigned(FStream) then
            begin
            FStream.Free;
            FStream:= nil;
            end;
          OK:= false;
        end;
        end;

        {$else}
        OK:= Viewer.Open(S);
        {$endif}
       
      Viewer.Visible:= OK;
      UpdateView(OK);
      end;
end;
*/


void __fastcall TFormView::chkModeTextClick( TObject * Sender )
{
  if ( ! FLoad ) 
  {
    Viewer->Mode = vbmodeText;
    UpdateView( true );
  }
}


void __fastcall TFormView::chkModeBinaryClick( TObject * Sender )
{
  if ( ! FLoad ) 
  {
    Viewer->Mode = vbmodeBinary;
    UpdateView( true );
  }
}


void __fastcall TFormView::chkModeHexClick( TObject * Sender )
{
  if ( ! FLoad ) 
  {
    Viewer->Mode = vbmodeHex;
    UpdateView( true );
  }
}


void __fastcall TFormView::chkModeUnicodeClick( TObject * Sender )
{
  if ( ! FLoad ) 
  {
    Viewer->Mode = vbmodeUnicode;
    UpdateView( true );
  }
}


void __fastcall TFormView::chkModeUHexClick( TObject * Sender )
{
  if ( ! FLoad ) 
  {
    Viewer->Mode = vbmodeUHex;
    UpdateView( true );
  }
}


void __fastcall TFormView::UpdateView( bool En )
{
  FLoad = true;
  chkModeText->Checked = Viewer->Mode == vbmodeText;
  chkModeBinary->Checked = Viewer->Mode == vbmodeBinary;
  chkModeHex->Checked = Viewer->Mode == vbmodeHex;
  chkModeUnicode->Checked = Viewer->Mode == vbmodeUnicode;
  chkModeUHex->Checked = Viewer->Mode == vbmodeUHex;
  chkModeText->Enabled = En;
  chkModeBinary->Enabled = En;
  chkModeHex->Enabled = En;
  chkModeUnicode->Enabled = En;
  chkModeUHex->Enabled = En;
  chkWordWrap->Enabled = En && ( UFormView__0.Contains(Viewer->Mode ) );
  chkOEM->Enabled = En && ! ( UFormView__1.Contains(Viewer->Mode ) );
  chkEnabled->Enabled = En;
  chkNonPrint->Enabled = En;
  FLoad = false;
}


void __fastcall TFormView::ViewerDrawLine( TObject * ASender, TCanvas * ACanvas, const WideString AStr, const WideString AStrAll, const TRect & ARect, const TPoint & ATextPnt, bool & ADone )
{
  // test
}


void __fastcall TFormView::FormShow( TObject * Sender )
{
  WideString fn;
  UpdateView( false );
/*
  fn:= SExtractFileDir(ParamStr(0));
  if IsDirExist(fn) then
    begin
    LVEx.RootFolder:= rfCustom;
    LVEx.RootFolderCustomPath:= fn;
    end;
    */
}


void __fastcall TFormView::Open1Click( TObject * Sender )
{
  bool OK;
  OK = false;
  if ( OpenDialog1->Execute()) 
    OK = Viewer->Open( OpenDialog1->FileName );
  Viewer->Visible = OK;
  UpdateView( OK );
}


void __fastcall TFormView::FormCreate( TObject * Sender )
{
  FLoad = false;
  Viewer = new TATBinHex(this);
  Viewer->Parent = this;
  Viewer->Align = alClient;
/*
  Panel1 = new TPanel1(this);
  Panel1->Parent = this;
  Panel1->Align = alClient;
  Panel1->Color = clWindow;
*/
  /*
  Viewer->Left = 2;
  Viewer->Top = 15;
  Viewer->Width = 318;
  Viewer->Height = 129;
  Viewer->Cursor = crIBeam;
  //Viewer->Align = alClient;
  Viewer->Visible = false;
		Viewer->BevelOuter = bvNone;
		Viewer->BorderStyle = bsSingle;
		Viewer->Caption = "No file loaded";
		Viewer->Color = clWindow;
		Viewer->Font->Charset = DEFAULT_CHARSET;
		Viewer->Font->Color = clWindowText;
		Viewer->Font->Height = -12;
		Viewer->Font->Name = "Courier New";
		//Viewer->Font.Style = []
		Viewer->ParentBackground = false;
		Viewer->ParentFont = false;
		Viewer->TabOrder = 0;
		Viewer->TabStop = true;
		Viewer->Visible = false;
		Viewer->FontOEM->Charset = OEM_CHARSET;
		Viewer->FontOEM->Color = clWindowText;
		Viewer->FontOEM->Height = -12;
		Viewer->FontOEM->Name = "Terminal";
		//Viewer->FontOEM.Style = []
		Viewer->FontFooter->Charset = DEFAULT_CHARSET;
		Viewer->FontFooter->Color = clBlack;
		Viewer->FontFooter->Height = -12;
		Viewer->FontFooter->Name = "Arial";
		//Viewer->FontFooter.Style = []
		Viewer->FontGutter->Charset = DEFAULT_CHARSET;
		Viewer->FontGutter->Color = clBlack;
		Viewer->FontGutter->Height = -12;
		Viewer->FontGutter->Name = "Courier New";
		//Viewer->FontGutter.Style = []
		Viewer->TextWidth = 65;
		Viewer->TextWidthHex = 12;
		Viewer->TextWidthFit = True;
		Viewer->TextWidthFitHex = True;
		Viewer->TextWidthFitUHex = True;
		Viewer->OnDrawLine = ViewerDrawLine;
	*/
//  TreeEx.VirtualExplorerListview:= LVEx; //For compatability with VST2.0 installed in IDE
}

void __fastcall TFormView::chkOEMClick( TObject * Sender )
{
  if ( chkOEM->Checked ) 
    Viewer->TextEncoding = vEncOEM;
  else
    Viewer->TextEncoding = vEncANSI;
}


void __fastcall TFormView::chkWordWrapClick( TObject * Sender )
{
  Viewer->TextWrap = chkWordWrap->Checked;
}


void __fastcall TFormView::chkEnabledClick( TObject * Sender )
{
  Viewer->Enabled = chkEnabled->Checked;
}


void __fastcall TFormView::chkNonPrintClick( TObject * Sender )
{
  Viewer->TextNonPrintable = chkNonPrint->Checked;
}
