
//{$define STREAMS} //See Readme.txt
#ifndef mainH
#define mainH

#include "windows.hpp"
#include "messages.hpp"
#include "sysutils.hpp"
#include "classes.hpp"
#include "graphics.hpp"
#include "controls.hpp"
#include "forms.hpp"
#include "dialogs.hpp"
#include "stdctrls.hpp"
#include "extctrls.hpp"
#include "ATBinHex.h"
#include "menus.hpp"
#include <Classes.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
//#include "Panel1.h"



class TFormView;




class TFormView: public TForm {
  typedef TForm inherited;
  __published :
  TMainMenu * MainMenu1;
  TMenuItem * File1;
  TMenuItem * Open1;
  TOpenDialog * OpenDialog1;
	TGroupBox *GroupBox2;
	TLabel *Label1;
	TLabel *Label2;
	TRadioButton *chkModeText;
	TRadioButton *chkModeBinary;
	TRadioButton *chkModeHex;
	TRadioButton *chkModeUnicode;
	TRadioButton *chkModeUHex;
	TCheckBox *chkOEM;
	TCheckBox *chkWordWrap;
	TCheckBox *chkEnabled;
	TCheckBox *chkNonPrint;
  void __fastcall chkModeBinaryClick( TObject * Sender );
  void __fastcall chkModeHexClick( TObject * Sender );
  void __fastcall chkModeUnicodeClick( TObject * Sender );
  void __fastcall chkModeTextClick( TObject * Sender );
  void __fastcall FormShow( TObject * Sender );
  void __fastcall FormCreate( TObject * Sender );
  void __fastcall chkWordWrapClick( TObject * Sender );
  void __fastcall chkOEMClick( TObject * Sender );
  void __fastcall chkEnabledClick( TObject * Sender );
  void __fastcall chkModeUHexClick( TObject * Sender );
  void __fastcall chkNonPrintClick( TObject * Sender );
  void __fastcall Open1Click( TObject * Sender );
  void __fastcall ViewerDrawLine( TObject * ASender, TCanvas * ACanvas, const WideString AStr, const WideString AStrAll, const TRect & ARect, const TPoint & ATextPnt, bool & ADone );
  private:
    /* Private declarations */
  bool FLoad;
  TATBinHex * Viewer;
  //TPanel1 * Panel1;
  public:
    /* Public declarations */
  void __fastcall UpdateView( bool En );
  public: inline __fastcall TFormView( TComponent * AOwner ) : inherited( AOwner ) {}
  public: inline __fastcall TFormView( HWND ParentWindow ) : inherited( ParentWindow ) {}
};


extern TFormView * FormView;

#endif //  UFormViewH