#ifndef ATxSHexH
#define ATxSHexH


#include "d2c_system.h"

//Conversion from hex encoded string (e.g. '10 20 AA FF': 4 chars) to normal string.
//Hex string must contain 2*N hex digits. Spaces are ignored.

bool __fastcall SHexToNormal( const String HexStr, String& ResStr );

//Conversion of string to hex form, digits are separated with spaces.

AnsiString __fastcall SToHex( const AnsiString S );

//Conversion from hex to Integer.

__int64 __fastcall HexToIntDef( const String S, const __int64 Default );

#endif //  ATxSHexH