
#include <vcl.h>
#pragma hdrstop

#include "ATBinHex.h"



#include <forms.hpp>
#include <printers.hpp>
#include "ATxSProc.h"
#include "ATxSHex.h"
#include "ATxFProc.h"
#include "ATxClipboard.h"
#include "ATViewerMsg.h"



#include "d2c_system.h"


/* Important constants: change with care */


// CB6 typedef Set<Controls__11, csAcceptsControls, csMenuEvents> TControlStyle;
// RAD6 typedef Set<Controls__31, csAcceptsControls, csAlignWithMargins>  TControlStyle;
#define ATBinHex__1 ( TControlStyle () \
					 << Controls__31 ( 6 ) )
//typedef Set<Classes__1, ssShift, ssDouble>  TShiftState;
#define ATBinHex__10 ( TShiftState () \
                     << Classes__1 ( 2 ) )
#define ATBinHex__11 ( TShiftState () \
                     << Classes__1 ( 2 ) )
#define ATBinHex__12 TShiftState ()
#define ATBinHex__13 TShiftState ()
#define ATBinHex__14 TShiftState ()
#define ATBinHex__15 TShiftState ()
#define ATBinHex__16 ( TShiftState () \
                     << Classes__1 ( 2 ) )
#define ATBinHex__17 ( TShiftState () \
                     << Classes__1 ( 2 ) )
#define ATBinHex__18 ( TShiftState () \
                     << Classes__1 ( 0 ) )
#define ATBinHex__19 ( TShiftState () \
                     << Classes__1 ( 2 ) )
#define ATBinHex__2 ( TFontStyles () \
                     << TFontStyle ( 2 ) )
#define ATBinHex__20 TShiftState ()
#define ATBinHex__21 ( TShiftState () \
                     << Classes__1 ( 0 ) )
#define ATBinHex__22 ( TShiftState () \
                     << Classes__1 ( 2 ) )
#define ATBinHex__23 TShiftState ()
#define ATBinHex__24 ( TShiftState () \
					 << Classes__1 ( 0 ) << Classes__1 ( 3 ) )
#define ATBinHex__25 ( System::Set < TATBinHexMode, vbmodeText, vbmodeUHex >() \
                     << TATBinHexMode ( 0 ) << TATBinHexMode ( 3 ) )
#define ATBinHex__26 ( System::Set < TATBinHexMode, vbmodeText, vbmodeUHex >() \
                     << TATBinHexMode ( 3 ) << TATBinHexMode ( 4 ) )
#define ATBinHex__27 ( System::Set < char, 0, 255 >() \
                     << char ( '\r' ) << char ( '\n' ) )
#define ATBinHex__6 TShiftState ()
#define ATBinHex__7 TShiftState ()
#define ATBinHex__8 TShiftState ()
#define ATBinHex__9 TShiftState ()
struct TStrPosRecord;
class TStrPositions;



const int cMaxLengthDefault = 300; //Default value of "Maximal line length".
                   //See MaxLengths property description.
                   //Don't set too large value, it affects default file buffer size.

const int cMaxLines = 150; //Maximal number of lines on screen supported.
                   //Don't set too large value because it affects file buffer size.
                   //Warning: It may be not enough for very high screen resolutions.
                   //150 should be enough for Height=1200, if we assume that minimal
                   //font height is 8.

/* Visual constants: may be changed freely */
                                  //User: Regex for URL and email


const char cReProt[] = "[a-z]{3,8}";
const char cReUrl[] = "\\b(" "[a-z]{3,8}" "://|www\\.)[\\w\\d\\.\\-\\?\\#\\+\\{\\}=~_$%;:&@,/]+";
const char cReEmail[] = "\\b[a-z\\d\\.\\-_]+@[a-z\\d\\.\\-]+\\.[a-z]+\\b";
const char cCharSpecial = '.';             //Draw: Char for control characters
                                  //Draw: Gutter:

const int cGutterWidth = 10;              //  gutter min width (px)

const int cGutterDotSize = 3;             //  gutter dot radius (px)

const int cGutterIndent = 2;              //  gutter indent (px, right of line num)

                                  //User: Line numbers

const int cLinesBufSizeMin = 1 * 1024;    //  buffer size: limits, default

const int cLinesBufSizeDef = 300 * 1024;
const int cLinesBufSizeMax = 20 * 1024 * 1024;
const int cLinesCountMin = 10;            //  lines max count: limits, default

const int cLinesCountDef = 2 * 1000;
const int cLinesCountMax = 100 * 1000;
const int cLinesStepMin = 1;              //  lines step limits

const int cLinesStepMax = 10;
                                  //Draw: "Show non-printable" option:

const char cCharNonPrintSpace = '\xb7';   //  - char for spaces

const char cCharNonPrintSpaceOEM = '\xfa';   //  - (for OEM font)

const char cCharNonPrintTab = '\xbb';   //  - char for tabs

const char cCharNonPrintTabOEM = '\xf9';   //  - (for OEM font)

const char cCharNonPrintCR = '\xb6';   //  - char for CRs

const char cCharNonPrintCROEM = '\xfe';   //  - (for OEM font)

const int cDrawOffsetMinX = 2;            //Draw: Small offset (px) between text and left-top control corner

const int cDrawOffsetMinY = 0;            //

const int cDrawOffsetBelowY = 2;          //Draw: Small offset (0-2 px) subtracted from client height

                                  //Draw: Hex mode: 

const char cHexOffsetSep = ':';            //  separator between offset and digits (string, may be empty!)

const bool cHexLinesShow = true;           //  enable vertical lines

const int cHexLinesWidth = 2;             //  width of vertical lines (px)

const int cHexMaxDigits = 64;             //User: hex mode max width (for mouse selection)

                                  //Auto-scroll feature (mouse is out of control area):

const int cMouseAutoScrollTime = 50;      //  - timer interval (ms)

const int cMouseAutoScrollSpeedX = 20;    //  - horz. speed (px/tick)

const int cMouseAutoScrollSpeedY = 1;     //  - vert. speed (lines/tick)

                                  //Nice scroll feature (middle mouse click):

const bool cMouseNiceScroll = true;        //  - enabled

const int cMouseNiceScrollTime = 100;     //  - timer interval (ms)

const int cMouseNiceScrollSpeedX = 8;     //  - horz. minimal speed (px/tick)

const int cMouseNiceScrollSpeedY = 1;     //  - vert. minimal speed (lines/tick)

const int cTabSizeMax = 16;               //User: Tabulation size limits (chars)

const int cTabSizeMin = 2;
const int cArrowScrollSize = 200;         //User: Keyboard scroll size (px) for Left/Right keys

const bool cSelectionByDoubleClick = true; //User: Feature: Double click selects current word

const bool cSelectionByTripleClick = true; //User: Feature: Triple click selects current line

const bool cSelectionByShiftClick = true;  //User: Feature: Click marks selection start, Shift+Click marks selection end

const int cSelectionRightIndent = 8;      //User: Minimal space (px) before selection start and control right border

const int cMaxShortLength = 256;          //User: Maximal length of string_ for SelTextShort/SelTextShortW properties

const int cMaxClipboardDataSizeMb = 16;   //User: Maximal data size (Mb) for copying to Clipboard

const int cMaxClipboardDataSizeMbMin = 8;      // (default, minimal, maximal)

const int cMaxClipboardDataSizeMbMax = 256;
const int cMaxFontSize = 72;              //User: Maximal font size for IncreaseFontSize method

const int cMaxSearchIndent = 80;          //User: Maximal vert/horz search indent (avg. chars)

const int cEncMenuOffsetY = 20;           //User: Offset of encodings menu above control center (px)

const bool cResizeFollowTail = true;       //User: Notepad feature: when control increases height, it follows file tail

                                  //Draw: Colors:

const int cColorDisabled = clGrayText;    //  text color for disabled state

const int cColorPrintBack = clWhite;      //  grayscale colors for printing

const int cColorPrintBackHex = clWhite;
const int cColorPrintText = clBlack;
const int cColorPrintTextHex1 = clBlack;
const int cColorPrintTextHex2 = clBlack;
const int cColorPrintLines = clGray;
const int cColorPrintError = clBlack;
const int cColorPrintURL = clGray;


/* Resources constants: don't change */


Graphics::TBitmap* FBitmapNiceScroll = NULL; //NiceScroll mode: bitmap that is drawn when mode is on



const int cBitmapNiceScrollRadius = 16;     //NiceScroll mode: bitmap is actually a circle of specified radius



const TCursor crNiceScrollNone = ((TCursor) - 30 ); //NiceScroll mode: cursor IDs

const TCursor crNiceScrollUp = ((TCursor) - 31 );
const TCursor crNiceScrollDown = ((TCursor) - 32 );
const TCursor crNiceScrollLeft = ((TCursor) - 33 );
const TCursor crNiceScrollRight = ((TCursor) - 34 );

  
/* Debug form */  


/* Helper functions */


void __fastcall SwapInt64( __int64& N1, __int64& N2 )
{
  __int64 n = 0;
  n = N1;
  N1 = N2;
  N2 = n;
}


void __fastcall InvertRect( TCanvas* ACanvas, const TRect& ARect )
{
  /*# Windows */::InvertRect( ACanvas->Handle, &ARect );
}


WideString __fastcall SConvertForOut( const WideString S, const TATBinHexOutputOptions& AOptions )
{
  WideString result;
  wchar_t chSp = L'\0', chTab = L'\0', chCR = L'\0';
  TStringTabOptions TabOptions;
  result = S;
  if ( AOptions.IsFontOem )
  {
    chSp = cCharNonPrintSpaceOEM;
    chTab = cCharNonPrintTabOEM;
    chCR = cCharNonPrintCROEM;
  }
  else
  {
    chSp = cCharNonPrintSpace;
    chTab = cCharNonPrintTab;
    chCR = cCharNonPrintCR;
  }
  if ( AOptions.ShowNonPrintable )
    SReplaceAllW( result, L" ", String( chSp ) );
  TabOptions.TabSize = AOptions.TabSize;
  TabOptions.TabPosition = 0;
  TabOptions.FontMonospaced = AOptions.IsFontFixed;
  TabOptions.NonPrintableShow = AOptions.ShowNonPrintable;
  TabOptions.NonPrintableChar = chTab;
  SReplaceTabsW( result, TabOptions );
  if ( AOptions.ShowNonPrintable && AOptions.ShowCR )
    result = result + WideString( chCR );
  return result;
}


void __fastcall STextOut( TCanvas* ACanvas, int x, int y, const WideString S )
{
  //TextOutW supported under Win9x
  TextOutW( ACanvas->Handle, x, y, ((PWChar) S.c_bstr()), S.Length( ) );
}


int __fastcall STextWidth( TCanvas* ACanvas, const WideString S )
{
  int result = 0;
  TSize Size;
  //GetTextExtentPoint32W supported under Win9x
  result = 0;
  if ( GetTextExtentPoint32W( ACanvas->Handle, ((PWChar) S.c_bstr()), S.Length( ), &Size ) )
    result = Size.cx;
  return result;
}


void __fastcall StringOut( TCanvas* ACanvas, int AX, int AY, const WideString AStr, const TATBinHexOutputOptions& AOptions )
{
  STextOut( ACanvas, AX, AY, SConvertForOut( AStr, AOptions ) );
}


int __fastcall StringWidth( TCanvas* ACanvas, const WideString AStr, const TATBinHexOutputOptions& AOptions )
{
  int result = 0;
  result = STextWidth( ACanvas, SConvertForOut( AStr, AOptions ) );
  return result;
}



typedef int TTextExtentEx [ MaxInt / sizeof( int ) - 1 + 1 ];
typedef int* PTextExtentEx;


bool __fastcall StringExtent( TCanvas* ACanvas, const WideString AStr, TATStringExtent& AExtent, const TATBinHexOutputOptions& AOptions )
{
  bool result = false;
  WideString S;
  TSize Size;
  int i = 0, j = 0;
  PTextExtentEx DX = NULL;
  int DxSize = 0;
  TStringTabOptions TabOptions;
  S = SConvertForOut( AStr, AOptions );
  DxSize = S.Length( ) * sizeof( int );
  GetMem( DX, DxSize );
  FillChar( DX, DxSize, 0 );
  if ( Win32Platform == VER_PLATFORM_WIN32_NT )
    result = GetTextExtentExPointW( ACanvas->Handle, S.c_bstr(), S.Length( ), 0, NULL, ((PInteger) DX ), &Size );
  else
    result = GetTextExtentExPointA( ACanvas->Handle, ((AnsiString) S ).c_str(), S.Length( ), 0, NULL, ((PInteger) DX ), &Size );

  //Copy extent information from Dx to AExtent, skipping tabs
  FillChar( AExtent, sizeof( AExtent ), 0 );
  if ( result )
  {
    j = 0;
    for ( int stop = AStr.Length( ), i = 1; i <= stop; i++)
    {
      j++;
      if ( AStr[i] == L'\x09' )
      {
        TabOptions.TabSize = AOptions.TabSize;
        TabOptions.TabPosition = j;
        TabOptions.FontMonospaced = AOptions.IsFontFixed;
        j += STabReplacement( TabOptions ).Length( ) - 1;
      }

      //The following assignment previosly shown stange AV under Chinese locale,
      //so additional check was added to fix this:
      if ( ( i <= /*# High( AExtent ) */ 2048 ) && ( j >= 1 ) && ( j <= S.Length( ) ) )
        AExtent[i] = DX[j];
    }
  }
  FreeMem( DX, -1 );
  return result;
}


bool __fastcall IsSeparator( wchar_t Ch )
{
  bool result = false;
  result = ( Ch == L' ' ) || ( Ch == L'\x09' ) || ( Ch == L'\\' );
  return result;
}


int __fastcall StringWrapPosition( const WideString S, int AMaxLen )
{
  int result = 0;
  int i = 0;
  for ( int stop = 1, i = IMin( AMaxLen + 1, S.Length( ) ); i >= stop; i--)
    if ( IsSeparator( S[i] ) )
    {
      result = i;
      return result;
    }
  result = AMaxLen;
  return result;
}


void __fastcall FontReadProperties( TCanvas* ACanvas, int& AHeight, char& AFirstChar, int& ADigitWidth, bool& AMonospaced )
{
  TTextMetricA Metric;
  if ( GetTextMetricsA( ACanvas->Handle, &Metric ) )
  {
    AHeight = Metric.tmHeight;
    AFirstChar = Metric.tmFirstChar;
  }
  else
  {
    AHeight = Abs( ACanvas->Font->Height );
    AFirstChar = Char( 0x20 );
  }
  ADigitWidth = ACanvas->TextWidth( "0" );
  AMonospaced = ACanvas->TextWidth( "W" ) == ACanvas->TextWidth( "." );
}


int __fastcall FontHeight( TCanvas* ACanvas )
{
  int result = 0;
  TTextMetricA Metric;
  if ( GetTextMetrics( ACanvas->Handle, &Metric ) )
    result = Metric.tmHeight;
  else
    result = Abs( ACanvas->Font->Height );
  return result;
}


int __fastcall BoolToSign( bool AValue )
{
  int result = 0;
  if ( AValue )
    result = 1;
  else
    result = - 1;
  return result;
}


bool __fastcall TextIncreaseFontSize( TFont* AFont, TCanvas* ACanvas, bool AIncrement )
{
  bool result = false;
  TCanvas* C = NULL;
  int CHeight = 0;
  result = false;
  C = new TCanvas;
  try
  {
    C->Handle = ACanvas->Handle;
    C->Font->Assign( AFont );
    CHeight = FontHeight( C );
    do
    {
      if ( AIncrement )
      {
        if ( C->Font->Size >= cMaxFontSize )
          break;
      }
      else
      {
        if ( C->Font->Size <= 1 )
          break;
      }
      C->Font->Size = C->Font->Size + BoolToSign( AIncrement );
      if ( FontHeight( C ) != CHeight )
      {
        AFont->Size = C->Font->Size;
        result = true;
        break;
      }
    }
    while ( ! ( false ) );
  }
  __finally
  {
    delete C;
    C = NULL;
  }
  return result;
}


/* TStrPositions */



struct TStrPosRecord {
  WideString str;
  TPoint Pnt;
  __int64 Pos;
};


typedef TStrPosRecord TStrPosArray [ 150/*# range 1..cMaxLines*/ ];
typedef int TStrPosHex [ 64/*# range 0..Pred(cHexMaxDigits)*/ ];

class TStrPositions: public TObject {
  typedef TObject inherited;
  private:
  int FNum;
  TStrPosArray FArray;
  TStrPosHex FHex;
  int FHexNum;
  int FHexLen;
  int FHexMargin;
  int FCharSize;
  public:
  __fastcall TStrPositions( );
  __fastcall virtual ~TStrPositions( );
  void __fastcall Clear( int ACharSize = 1 );
  void __fastcall Add( const WideString AStr, int AX, int AY, const __int64 APos );
  __int64 __fastcall GetPosFromCoord( TCanvas* ACanvas, int AX, int AY, const TATBinHexOutputOptions& AOptions, bool AStrict = false );
  bool __fastcall GetCoordFromPos( TCanvas* ACanvas, const __int64 APos, const TATBinHexOutputOptions& AOptions, int& AX, int& AY );
  int __fastcall GetScreenWidth( TCanvas* ACanvas, const TATBinHexOutputOptions& AOptions );
  void __fastcall AddHex( int APos, int AX, int ANum, int ALen );
  void __fastcall AddHexMargin( int AX );
};



void __fastcall TStrPositions::AddHex( int APos, int AX, int ANum, int ALen )
{
  FHexNum = IMin( ANum, cHexMaxDigits );
  FHexLen = ALen;
  if ( ( APos >= /*# Low( FHex ) */ 0 ) && ( APos <= /*# High( FHex ) */ 63 ) )
    FHex[APos] = AX;
}


void __fastcall TStrPositions::AddHexMargin( int AX )
{
  FHexMargin = AX;
}


__fastcall TStrPositions::TStrPositions( )
{
  // inherited::Create();
  FillChar( FArray, sizeof( FArray ), 0 );
  FillChar( FHex, sizeof( FHex ), 0 );
  FNum = 0;
  FHexNum = 0;
  FHexLen = 0;
  FHexMargin = 0;
  FCharSize = 1;
}


__fastcall TStrPositions::~TStrPositions( )
{
  Clear();
  // todo check:  inherited::Destroy;
}


void __fastcall TStrPositions::Clear( int ACharSize )
{
  int i = 0;
  for ( int stop = 1, i = FNum; i >= stop; i--)
    /*# with FArray[i] do */
    {
      TStrPosRecord& with0 = FArray[i - 1];
      {
        with0.str.Empty();
        with0.Pnt = Point( 0, 0 );
        with0.Pos = 0;
      }
    }
  FNum = 0;
  FHexNum = 0;
  FHexLen = 0;
  FHexMargin = 0;
  FillChar( FHex, sizeof( FHex ), 0 );
  FCharSize = ACharSize;
}


void __fastcall TStrPositions::Add( const WideString AStr, int AX, int AY, const __int64 APos )
{
  if ( FNum < /*# High( TStrPosArray ) */ 150 )
  {
    FNum++;
    /*# with FArray[FNum] do */
    {
      TStrPosRecord& with0 = FArray[FNum - 1];
      {
        with0.str = AStr;
        with0.Pnt = Point( AX, AY );
        with0.Pos = APos;
      }
    }
  }
}


__int64 __fastcall TStrPositions::GetPosFromCoord( TCanvas* ACanvas, int AX, int AY, const TATBinHexOutputOptions& AOptions, bool AStrict )
{
  __int64 result = 0;
  int YH = 0;
  int Num = 0, i = 0;
  TATStringExtent DX;
  result = - 1;
  if ( FNum == 0 )
    return result;  

  //Mouse upper than first line
  /*# with FArray[1] do */
  {
    TStrPosRecord& with0 = FArray[1 - 1];
    if ( AY < with0.Pnt.y )
    {
      if ( ! AStrict )
        result = with0.Pos;
      return result;
    }
  }

  //Get line number into Num
  YH = FontHeight( ACanvas );
  Num = 0;
  for ( int stop = FNum, i = 1; i <= stop; i++)
    /*# with FArray[i] do */
    {
      TStrPosRecord& with1 = FArray[i - 1];
      if ( ( AY >= with1.Pnt.y ) && ( AY < with1.Pnt.y + YH ) )
      {
        Num = i;
        break;
      }
    }

  //Mouse lower than last line
  if ( Num == 0 )
    /*# with FArray[FNum] do */
    {
      TStrPosRecord& with2 = FArray[FNum - 1];
      {
        if ( ! AStrict )
          result = with2.Pos + with2.str.Length( ) * FCharSize;
        return result;
      }
    }

  //Mouse over a line #Num
  /*# with FArray[Num] do */
  {
    TStrPosRecord& with3 = FArray[Num - 1];
    {
    //Mouse lefter than line
      if ( AX <= with3.Pnt.x )
      {  

      //Handle hex offsets
        if ( ( FHexNum > 0 ) && ( FHexMargin > 0 ) && ( AX <= FHexMargin ) )
        {
          for ( int stop = 0, i = Pred( FHexNum ); i >= stop; i--)
            if ( ( FHex[i] > 0 ) && ( AX >= FHex[i] + FHexLen / 2 ) )
            {
              result = with3.Pos + ( i + 1 ) * FCharSize;
              return result;
            }
        }
        if ( ! AStrict )
          result = with3.Pos;
        return result;
      }
      if ( StringExtent( ACanvas, with3.str, DX, AOptions ) )
      {
      //Mouse inside line
        for ( int stop = with3.str.Length( ), i = 1; i <= stop; i++)
        {
          if ( AX < with3.Pnt.x + ( DX[i - 1] + DX[i] ) / 2 )
          {
            result = with3.Pos + ( i - 1 ) * FCharSize;
            return result;
          }
        }

      //Mouse righter than line
        if ( ! AStrict )
          result = with3.Pos + with3.str.Length( ) * FCharSize;
      }
    }
  }
  return result;
}


bool __fastcall TStrPositions::GetCoordFromPos( TCanvas* ACanvas, const __int64 APos, const TATBinHexOutputOptions& AOptions, int& AX, int& AY )
{
  bool result = false;
  int i = 0;
  TATStringExtent DX;
  result = false;
  AX = 0;
  AY = 0;
  for ( int stop = FNum, i = 1; i <= stop; i++)
    /*# with FArray[i] do */
    {
      TStrPosRecord& with0 = FArray[i - 1];
      if ( ( APos >= with0.Pos ) && ( APos < with0.Pos + with0.str.Length( ) * FCharSize ) )
        if ( StringExtent( ACanvas, with0.str, DX, AOptions ) )
        {
          result = true;
          AX = with0.Pnt.x + DX[( APos - with0.Pos ) / FCharSize];
          AY = with0.Pnt.y;
          break;
        }
    }

  /*
  //Debug
  if not Result then
  begin
    S := '';
    for i := 1 to FNum do
      with FArray[i] do
        S := S + Format('%d:  Pos: %d', [i, Pos]) + #13;
    S := S + #13 + Format('APos: %d', [APos]);
    MsgError(S);
  end;
  */
  return result;
}


int __fastcall TStrPositions::GetScreenWidth( TCanvas* ACanvas, const TATBinHexOutputOptions& AOptions )
{
  int result = 0;
  int i = 0;
  int AWidth = 0;
  result = 0;
  for ( int stop = FNum, i = 1; i <= stop; i++)
    /*# with FArray[i] do */
    {
      TStrPosRecord& with0 = FArray[i - 1];
      {
        AWidth = with0.Pnt.x + StringWidth( ACanvas, with0.str, AOptions );
        ILimitMin( result, AWidth );
      }
    }
  return result;
}


/* TATBinHex */


void __fastcall TATBinHex::AllocBuffer( )
{
  FMaxLength = FMaxLengths[FMode];

  //Buffer contains 3 offsets: offset below + 2 offsets above view position
  FBufferMaxOffset = FMaxLength * cMaxLines * CharSize();
  FBufferAllocSize = 3 * FBufferMaxOffset;
  GetMem( FBuffer, FBufferAllocSize );
  FillChar( FBuffer, FBufferAllocSize, 0 );
}


__fastcall TATBinHex::TATBinHex( TComponent* AOwner )
: inherited( AOwner )

  //Init inherited properties
{
  TATBinHexMode n;
  Caption = "";
  Width = 200;
  Height = 150;
  BevelOuter = bvNone;
  BorderStyle = bsSingle;
  Color = clWindow;
  Cursor = crIBeam;
  ControlStyle = ControlStyle + ATBinHex__1;
  Font->Name = "Courier New";
  Font->Size = 10;
  Font->Color = clWindowText;

  //Init fields
  FMode = vbmodeText;
  FEncoding = vEncANSI;
  FTextWidth = 80;
  FTextWidthHex = 16;
  FTextWidthUHex = 8;
  FTextWidthFit = false;
  FTextWidthFitHex = false;
  FTextWidthFitUHex = false;
  FTextWrap = false;
  FTextNonPrintable = false;
  FTextOemSpecial = false;
  FTextGutter = false;
  FTextGutterWidth = cGutterWidth;
  FLinesShow = true;
  FLinesStep = 5;
  FLinesBufSize = cLinesBufSizeDef;
  FLinesData = NULL;
  FLinesNum = 0;
  FLinesCount = cLinesCountDef;
  FLinesExtUse = false;
  FLinesExtList = "";
  FTextColorHex = clNavy;
  FTextColorHex2 = clBlue;
  FTextColorHexBack = cATBinHexBkColor;
  FTextColorLines = clGray;
  FTextColorError = clRed;
  FTextColorGutter = clLtGray;
  FTextColorURL = clBlue;
  FSearchIndentVert = 5;
  FSearchIndentHorz = 5;
  FTabSize = 8;
  FPopupCommands = cATBinHexCommandSet;
  FEnabled2 = true;
  FAutoReload = false;
  FAutoReloadBeep = false;
  FAutoReloadFollowTail = true;
  FAutoReloadSimple = false;
  FAutoReloadSimpleTime = 1000;
  FUrlShow = true;
  InitURLs();
  FMaxLength = 0; //Initialized in AllocBuffer
  for ( int stop = /*# High(TATBinHexMode) */ 4, n = /*# Low(TATBinHexMode) */ 0; n <= stop; Inc( n ) )
    FMaxLengths[n] = cMaxLengthDefault;
  FMaxClipboardDataSizeMb = cMaxClipboardDataSizeMb;
  FHexOffsetLen = 8;
  FFontHeight = 8;
  FFontFirstChar = Char( 0x20 );
  FFontWidthDigits = 4;
  FFontMonospaced = false;
  FLockCount = 0;
  FMarginLeft = 10;
  FMarginTop = 10;
  FMarginRight = 10;
  FMarginBottom = 10;
  FPrintFooter = true;
  FOnSelectionChange = NULL;
  FOnOptionsChange = NULL;
  FOnScroll = NULL;
  FOnFileReload = NULL;
  FFileName.Empty();
  FStream = NULL;
  InitData();

  //Init objects
  FSearch = new TATStreamSearch( this );
  FSearchStarted = false;
  FFontOEM = new TFont;
  /*# with FFontOEM do */
  {
    FFontOEM->Name = "Terminal";
    FFontOEM->Size = 9;
    FFontOEM->Color = clWindowText;
    FFontOEM->Charset = OEM_CHARSET;
  }
  FFontFooter = new TFont;
  /*# with FFontFooter do */
  {
    FFontFooter->Name = "Arial";
    FFontFooter->Size = 9;
    FFontFooter->Color = clBlack;
    FFontFooter->Charset = DEFAULT_CHARSET;
  }
  FFontGutter = new TFont;
  /*# with FFontGutter do */
  {
    FFontGutter->Name = "Courier New";
    FFontGutter->Size = 9;
    FFontGutter->Color = clBlack;
    FFontGutter->Charset = DEFAULT_CHARSET;
  }
  FBitmap = new Graphics::TBitmap;
  /*# with FBitmap do */
  {
    FBitmap->Width = this->Width;
    FBitmap->Height = this->Height;
  }
  FTimerAutoScroll = new TTimer( this );
  /*# with FTimerAutoScroll do */
  {
    FTimerAutoScroll->Enabled = false;
    FTimerAutoScroll->Interval = cMouseAutoScrollTime;
    FTimerAutoScroll->OnTimer = TimerAutoScrollTimer;
  }
  FTimerNiceScroll = new TTimer( this );
  /*# with FTimerNiceScroll do */
  {
    FTimerNiceScroll->Enabled = false;
    FTimerNiceScroll->Interval = cMouseNiceScrollTime;
    FTimerNiceScroll->OnTimer = TimerNiceScrollTimer;
  }
  FStrings = new TStrPositions;

  //Init popup menu
  FMenuItemCopy = new TMenuItem( this );
  /*# with FMenuItemCopy do */
  {
    FMenuItemCopy->Caption = "Copy";
    FMenuItemCopy->OnClick = MenuItemCopyClick;
  }
  FMenuItemCopyHex = new TMenuItem( this );
  /*# with FMenuItemCopyHex do */
  {
    FMenuItemCopyHex->Caption = "Copy as hex";
    FMenuItemCopyHex->OnClick = MenuItemCopyHexClick;
  }
  FMenuItemCopyLink = new TMenuItem( this );
  /*# with FMenuItemCopyLink do */
  {
    FMenuItemCopyLink->Caption = "Copy link";
    FMenuItemCopyLink->OnClick = MenuItemCopyLinkClick;
  }
  FMenuItemSelectLine = new TMenuItem( this );
  /*# with FMenuItemSelectLine do */
  {
    FMenuItemSelectLine->Caption = "Select line";
    FMenuItemSelectLine->OnClick = MenuItemSelectLineClick;
  }
  FMenuItemSelectAll = new TMenuItem( this );
  /*# with FMenuItemSelectAll do */
  {
    FMenuItemSelectAll->Caption = "Select all";
    FMenuItemSelectAll->OnClick = MenuItemSelectAllClick;
  }
  FMenuItemEncMenu = new TMenuItem( this );
  /*# with FMenuItemEncMenu do */
  {
    FMenuItemEncMenu->Caption = "Encoding...";
    FMenuItemEncMenu->OnClick = MenuItemEncMenuClick;
  }
  FMenuItemSep1 = new TMenuItem( this );
  /*# with FMenuItemSep1 do */
  {
    FMenuItemSep1->Caption = "-";
  }
  FMenuItemSep2 = new TMenuItem( this );
  /*# with FMenuItemSep2 do */
  {
    FMenuItemSep2->Caption = "-";
  }
  FMenu = new TPopupMenu( this );
  /*# with FMenu do */
  {
    FMenu->Items->Add( FMenuItemCopy );
    FMenu->Items->Add( FMenuItemCopyHex );
    FMenu->Items->Add( FMenuItemCopyLink );
    FMenu->Items->Add( FMenuItemSep1 );
    FMenu->Items->Add( FMenuItemSelectLine );
    FMenu->Items->Add( FMenuItemSelectAll );
    FMenu->Items->Add( FMenuItemSep2 );
    FMenu->Items->Add( FMenuItemEncMenu );
    FMenu->OnPopup = UpdateMenu;
  }
  FMenuCodepages = NULL;
  FMenuCodepagesUn = NULL;
  PopupMenu = FMenu;

  //Init notification objects
  FNotif = new TATFileNotification( this );
  /*# with FNotif do */
  {
    FNotif->Options = ( TATFileNotifyOptions ()
                         << TATFileNotifyOption ( 0 ) << TATFileNotifyOption ( 4 ) << TATFileNotifyOption ( 3 ) );
    FNotif->OnChanged = NotifChanged;
  }
  FNotif2 = new TATFileNotificationSimple( this );
  /*# with FNotif2 do */
  {
    FNotif2->OnChanged = NotifChanged;
  } 

  //Init event handlers
  OnMouseWheelUp = MouseWheelUp;
  OnMouseWheelDown = MouseWheelDown;
  OnContextPopup = ContextPopup;
  OnExit = ExitProc;

  //Init debug form
}


__fastcall TATBinHex::~TATBinHex( )
{
  FreeData();
  delete FStrings;
  delete FBitmap;
  delete FFontOEM;
  delete FFontFooter;
  delete FFontGutter;
  // todo check:  inherited::Destroy;
}


void __fastcall TATBinHex::DrawGutterTo( Graphics::TBitmap* ABitmap )
{
  Assert(( ABitmap != NULL ), "Bitmap not assigned" );
  /*# with ABitmap do */
  if ( FTextGutter )
  {
    FTextGutterWidth = cGutterWidth;
    if ( ActiveLinesShow() )
    {
      ABitmap->Canvas->Font->Assign( FFontGutter );
      ILimitMin( FTextGutterWidth, ABitmap->Canvas->TextWidth( IntToStr( FLinesNum + 1 ) ) + cGutterIndent );
    }
    ABitmap->Canvas->Brush->Color = FTextColorGutter;
    ABitmap->Canvas->FillRect( Rect( 0, 0, FTextGutterWidth, ABitmap->Height ) );
  }
}


void __fastcall TATBinHex::DrawEmptyTo( Graphics::TBitmap* ABitmap, int APageWidth, int APageHeight, bool APrintMode )
{
  TColor AColorBack;
  Assert(( ABitmap != NULL ), "Bitmap not assigned" );
  if ( APrintMode )
    AColorBack = cColorPrintBack;
  else
    AColorBack = Color;
  /*# with ABitmap do */
  {
    ABitmap->Width = APageWidth;
    ABitmap->Height = APageHeight;
    ABitmap->Canvas->Brush->Color = AColorBack;
    ABitmap->Canvas->FillRect( Rect( 0, 0, ABitmap->Width, ABitmap->Height ) );
    DrawGutterTo( ABitmap );
    ABitmap->Canvas->Brush->Color = AColorBack;
  }
}


TATBinHexOutputOptions __fastcall TATBinHex::OutputOptions( bool AShowCR )
{
  TATBinHexOutputOptions result;
  FillChar( &result, sizeof( result ), 0 );
  result.ShowNonPrintable = FTextNonPrintable;
  result.ShowCR = AShowCR;
  result.IsFontOem = ActiveFont() == FFontOEM;
  result.IsFontFixed = FFontMonospaced;
  result.TabSize = FTabSize;
  return result;
}


void __fastcall TATBinHex::SelectLine( const WideString ALine, int AX, int AY, const __int64 AFilePos, bool ASelectAll, Graphics::TBitmap*& ABitmap, int& APageWidth, int& APageHeight, TObject*& AStringsObject, bool& APrintMode, const __int64& AFinalPos, int& ATextWidth, int& ATextWidthHex, int& ATextWidthUHex, __int64& AViewPageSize, bool& AViewAtEnd, TATStringExtent& DX, TColor& AColorBack, TColor& AColorBackHex, TColor& AColorText, TColor& AColorTextHex1, TColor& AColorTextHex2, TColor& AColorLines, TColor& AColorError, TColor& AColorURL )
{
  int Len = 0, yHeight = 0;
  __int64 nStart = 0, nEnd = 0;
  if ( ASelectAll )
    Len = 1;
  else
    Len = ALine.Length( );
  if ( ( FSelStart > AFilePos + ( Len - 1 ) * CharSize() ) || ( FSelStart + FSelLength - 1 * CharSize() < AFilePos ) )
    return;
  if ( ( AX >= FBitmap->Width ) || ( AY >= FBitmap->Height ) )
    return;
  yHeight = FFontHeight;
  if ( StringExtent( FBitmap->Canvas, ALine, DX, OutputOptions() ) )
  {
    if ( ASelectAll )
      InvertRect( FBitmap->Canvas, Rect( AX, AY, AX + DX[ALine.Length( )], AY + yHeight ) );
    else
    {
      nStart = ( FSelStart - AFilePos ) / CharSize();
      I64LimitMin( nStart, 0 );
      nEnd = ( FSelStart + FSelLength - AFilePos ) / CharSize();
      I64LimitMax( nEnd, ALine.Length( ) );
      InvertRect( FBitmap->Canvas, Rect( AX + DX[nStart], AY, AX + DX[nEnd], AY + yHeight ) );
    }
  }
}


void __fastcall TATBinHex::HilightLine( const WideString ALine, int AX, int AY, const __int64 AFilePos, Graphics::TBitmap*& ABitmap, int& APageWidth, int& APageHeight, TObject*& AStringsObject, bool& APrintMode, const __int64& AFinalPos, int& ATextWidth, int& ATextWidthHex, int& ATextWidthUHex, __int64& AViewPageSize, bool& AViewAtEnd, TATStringExtent& DX, TColor& AColorBack, TColor& AColorBackHex, TColor& AColorText, TColor& AColorTextHex1, TColor& AColorTextHex2, TColor& AColorLines, TColor& AColorError, TColor& AColorURL )
{
  __int64 nStart = 0, nEnd = 0;
  int i = 0;
  if ( StringExtent( FBitmap->Canvas, ALine, DX, OutputOptions() ) )
    for ( int stop = /*# High( FUrlArray ) */ 500, i = /*# Low( FUrlArray ) */ 1; i <= stop; i++)
      /*# with FUrlArray[i] do */
      {
        ATBinHex__0& with0 = FUrlArray[i - 1];
        {
          if ( with0.FString.IsEmpty())
            break;
          if ( ( ( with0.FPos - AFilePos ) / CharSize() <= ALine.Length( ) ) && ( ( with0.FPos - AFilePos ) / CharSize() + with0.FString.Length( ) >= 0 ) )
          {
            nStart = ( with0.FPos - AFilePos ) / CharSize();
            I64LimitMin( nStart, 0 );
            nEnd = ( with0.FPos - AFilePos ) / CharSize() + with0.FString.Length( );
            I64LimitMax( nEnd, ALine.Length( ) );

            /*
            FBitmap.Canvas.Pen.Color := clRed;
            FBitmap.Canvas.Brush.Style := bsClear;
            FBitmap.Canvas.Rectangle(Rect(
              AX + Dx[nStart], AY, AX + Dx[nEnd], AY + FFontHeight));
            */
            FBitmap->Canvas->Font->Color = AColorURL;
            FBitmap->Canvas->Font->Style = ActiveFont()->Style + ATBinHex__2;
            StringOut( FBitmap->Canvas, AX + DX[nStart], AY, ALine.SubString( nStart + 1, nEnd - nStart ), OutputOptions() );
            FBitmap->Canvas->Font->Color = AColorText;
            FBitmap->Canvas->Font->Style = ActiveFont()->Style;
          }
        }
      }
}


TColor __fastcall TATBinHex::ActiveColor( TColor AColor, Graphics::TBitmap*& ABitmap, int& APageWidth, int& APageHeight, TObject*& AStringsObject, bool& APrintMode, const __int64& AFinalPos, int& ATextWidth, int& ATextWidthHex, int& ATextWidthUHex, __int64& AViewPageSize, bool& AViewAtEnd, TATStringExtent& DX, TColor& AColorBack, TColor& AColorBackHex, TColor& AColorText, TColor& AColorTextHex1, TColor& AColorTextHex2, TColor& AColorLines, TColor& AColorError, TColor& AColorURL )
{
  TColor result;
  if ( Enabled )
    result = AColor;
  else
    result = cColorDisabled;
  return result;
}


void __fastcall TATBinHex::DrawTo( Graphics::TBitmap* ABitmap, int APageWidth, int APageHeight, TObject* AStringsObject, bool APrintMode, const __int64 AFinalPos, int& ATextWidth, int& ATextWidthHex, int& ATextWidthUHex, __int64& AViewPageSize, bool& AViewAtEnd )
{
  TATStringExtent DX; //TATStringExtent is huge, so this isn't SelectLine local.
                       //Otherwise it slows down on Win9x.
          //Actual colors used for drawing

  TColor AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL;
  TStrPositions* AStrings = NULL;
  int x = 0, y = 0, Y2 = 0;
  __int64 APos = 0, APosEnd = 0, ACurrentPos = 0;
  AnsiString LineA;
  WideString LineW, LineText;
  int APosTextX = 0, APosTextY = 0;
  int ALines = 0, ACols = 0;
  int ALineNum = 0;
  int i = 0, j = 0;
  char Ch = '\0';
  wchar_t wCh = L'\0';
  bool WithCR = false, WithDot = false;
  bool PosOk = false, ADone = false;
  PosOk = ( FBufferPos >= 0 ) && ( FBufferPos <= PosLast() ) && ( FViewPos >= FBufferPos ) && ( FViewPos <= FBufferPos + 2 * FBufferMaxOffset );
  Assert( PosOk, Format( String( "Positions out of range: DrawTo\x0d" ) + "BufferPos: %d, ViewPos: %d, BufMaxOffset: %d", ARRAYOFCONST(( FBufferPos, FViewPos, FBufferMaxOffset )) ) );
  if ( ! PosOk )
    return;
  ATextWidth = FTextWidth;
  ATextWidthHex = FTextWidthHex;
  ATextWidthUHex = FTextWidthUHex;
  AViewPageSize = 0;
  AViewAtEnd = false;
  if ( APrintMode )
  {
    AColorBack = cColorPrintBack;
    AColorBackHex = cColorPrintBackHex;
    AColorText = cColorPrintText;
    AColorTextHex1 = cColorPrintTextHex1;
    AColorTextHex2 = cColorPrintTextHex2;
    AColorLines = cColorPrintLines;
    AColorError = cColorPrintError;
    AColorURL = cColorPrintURL;
  }
  else
  {
    AColorBack = Color;
    AColorBackHex = FTextColorHexBack;
    AColorText = ActiveColor( ActiveFont()->Color, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
    AColorTextHex1 = ActiveColor( FTextColorHex, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
    AColorTextHex2 = ActiveColor( FTextColorHex2, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
    AColorLines = ActiveColor( FTextColorLines, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
    AColorError = ActiveColor( FTextColorError, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
    AColorURL = ActiveColor( FTextColorURL, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
  }
  DrawEmptyTo( ABitmap, APageWidth, APageHeight, APrintMode );
  AStrings = ((TStrPositions*) AStringsObject );
  if (( AStrings != NULL ) )
    AStrings->Clear( CharSize() );
  /*# with ABitmap do */
  {
    ABitmap->Canvas->Font = ActiveFont();
    ABitmap->Canvas->Font->Color = AColorText;
    FontReadProperties( ABitmap->Canvas, FFontHeight, FFontFirstChar, FFontWidthDigits, FFontMonospaced );
    if ( FTextWidthFit )
      SetTextWidthTo( ColsNumFit( ABitmap ), ATextWidth );
    if ( FTextWidthFitHex )
      SetTextWidthHexTo( ColsNumHexFit( ABitmap ), ATextWidthHex );
    if ( FTextWidthFitUHex )
      SetTextWidthUHexTo( ColsNumUHexFit( ABitmap ), ATextWidthUHex );

    //Calculate fixed page size. In Text/Unicode modes it will be recalculated
    //and will contain variable page size.
    ALines = LinesNum( ABitmap );
    ACols = ColsNum( ABitmap );
    AViewPageSize = ALines * ACols;
    if ( FFileOK )
    {
      switch ( FMode )
      {
        case vbmodeText: case vbmodeUnicode:
        {
          APos = FViewPos;
          for ( int stop = IMin( ALines + 1, cMaxLines ), i = 1; i <= stop; i++)
          {
              //Find line
            APosEnd = FindLinePos( APos, vdirDown, LineW, false );
            WithCR = LineWithCR( APos, LineW );
            WithDot = LineWithGutterDot( APos );

              //Draw line
            LineText = LineW;
            APosTextX = DrawOffsetX();
            APosTextY = DrawOffsetY() + ( i - 1 ) * FFontHeight;
            ADone = false;
            if ( ! APrintMode )
            {
              ABitmap->Canvas->Font->Color = AColorText;
              ABitmap->Canvas->Brush->Color = AColorBack;
              DoDrawLine( ABitmap->Canvas, LineText, APos, Rect( 0, APosTextY, ClientWidth, APosTextY + FFontHeight ), Point( APosTextX, APosTextY ), ADone );
            }
            if ( ! ADone )
            {
                /*
                //(not finished)
                //To not output BOM ($FFFE, $FEFF) characters:
                if IsModeUnicode then
                  if (APos = 0) and (LineText <> '') then
                    if (LineText[1] = #$FEFF) or (LineText[1] = #$FFFE) then
                    begin
                      Delete(LineText, 1, 1);
                      APos := 2;
                    end;
                    */
              StringOut( ABitmap->Canvas, APosTextX - FHViewPos, APosTextY, LineText, OutputOptions( WithCR ) );
              HilightLine( LineText, APosTextX - FHViewPos, APosTextY, APos, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
              SelectLine( LineText, APosTextX - FHViewPos, APosTextY, APos, false, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
              if (( AStrings != NULL ) )
                AStrings->Add( LineText, APosTextX - FHViewPos, APosTextY, APos );
              DoDrawLine2( ABitmap->Canvas, LineText, Point( APosTextX - FHViewPos, APosTextY ), OutputOptions( WithCR ) );
            }

              //Draw gutter dot
            if ( FTextGutter )
            {
              ABitmap->Canvas->Brush->Color = FTextColorGutter;
              ABitmap->Canvas->FillRect( Rect( 0, APosTextY, FTextGutterWidth, APosTextY + FFontHeight ) );
              if ( WithDot )
              {
                ALineNum = FindLineNum( APos );
                if ( ActiveLinesShow() && ( ALineNum > 0 ) && ( ALineNum % FLinesStep == 0 ) )
                {
                  ABitmap->Canvas->Font->Assign( FFontGutter );
                  ABitmap->Canvas->TextOut( ( FTextGutterWidth - ABitmap->Canvas->TextWidth( IntToStr( ALineNum ) ) - cGutterIndent ), ( FFontHeight - ABitmap->Canvas->TextHeight( "0" ) ) / 2 + APosTextY, IntToStr( ALineNum ) );
                  ABitmap->Canvas->Font->Assign( ActiveFont() );
                }
                else
                {
                  ABitmap->Canvas->Brush->Color = AColorBack;
                  ABitmap->Canvas->Pen->Color = AColorText;
                  ABitmap->Canvas->Pen->Width = 1;
                  ABitmap->Canvas->Ellipse( FTextGutterWidth / 2 - cGutterDotSize, APosTextY + FFontHeight / 2 - cGutterDotSize, FTextGutterWidth / 2 + cGutterDotSize, APosTextY + FFontHeight / 2 + cGutterDotSize );
                }
              }
              ABitmap->Canvas->Brush->Color = AColorBack;
            }

              //Move to the next line
            APos = APosEnd;

              //Calculate the following flags only for fully visible lines
            if ( i <= ALines )
            {
                //Calculate variable page size
                //(it is next/last position minus view position)
              if ( APos >= 0 )
                AViewPageSize = APos - FViewPos;
              else
                AViewPageSize = FFileSize - FViewPos;

                //Calculate "at the end" flag
              AViewAtEnd = APos < 0;
            }

              //Stop at the EOF
            if ( APos < 0 )
              break;

              //Stop after AFinalPos
            if ( ( AFinalPos >= 0 ) && ( APos > AFinalPos ) )
              break;
          }
        }
        break;
        case vbmodeHex:
        {
          for ( int stop = IMin( ALines + 1, cMaxLines ), i = 1; i <= stop; i++)
          {
            ACurrentPos = FViewPos + ( i - 1 ) * ATextWidthHex;
            APos = ACurrentPos - FBufferPos;

              //Stop at the EOF
            if ( FBufferPos + APos >= FFileSize )
              break;

              //Stop after AFinalPos
            if ( ( AFinalPos >= 0 ) && ( ACurrentPos > AFinalPos ) )
              break;
            y = DrawOffsetY() + ( i - 1 ) * FFontHeight;
            Y2 = y + FFontHeight;

              //Draw offset
            x = DrawOffsetX();
            LineA = IntToHex( FBufferPos + APos, FHexOffsetLen ) + cHexOffsetSep;
            ABitmap->Canvas->Font->Color = AColorText;
            StringOut( ABitmap->Canvas, x - FHViewPos, y, LineA, OutputOptions() );

              //Draw hex background
            x += ( LineA.Length( ) + 1/*space*/ ) * FFontWidthDigits;
            ABitmap->Canvas->Brush->Color = AColorBackHex;
            ABitmap->Canvas->FillRect( Rect( x - FHViewPos, y, x - FHViewPos + FFontWidthDigits * ( ATextWidthHex * 3 + 2 ), Y2 + ( cHexLinesWidth / 2 ) ) );

              //Draw hex digits
            x += FFontWidthDigits;
            for ( int stop = ATextWidthHex - 1, j = 0; j <= stop; j++)
            {
              APosEnd = FBufferPos + APos + j;
              if ( APosEnd < FFileSize )
              {
                if ( ( j % 4 ) < 2 )
                  ABitmap->Canvas->Font->Color = AColorTextHex1;
                else
                  ABitmap->Canvas->Font->Color = AColorTextHex2;
                LineW = GetHex( APosEnd );
                StringOut( ABitmap->Canvas, x - FHViewPos, y, LineW, OutputOptions() );
                SelectLine( LineW, x - FHViewPos, y, FBufferPos + APos + j, true, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );

                  //Save hex offsets
                ((TStrPositions*) FStrings )->AddHex( j, x - FHViewPos, ATextWidthHex, 3 * FFontWidthDigits );

                  //Inc hex offset
                x += 3 * FFontWidthDigits; //3 spaces per byte
                if ( j == ( ATextWidthHex / 2 - 1 ) )
                  x += FFontWidthDigits; //Space in the middle
              }
            }

              //Draw text
            x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 3/*3 spaces*/ + ATextWidthHex * 3 ) * FFontWidthDigits;
            ((TStrPositions*) FStrings )->AddHexMargin( x );
            x += FFontWidthDigits;
            ABitmap->Canvas->Brush->Color = AColorBack;
            ABitmap->Canvas->Font->Color = AColorText;
            LineW.Empty();
            for ( int stop = ATextWidthHex - 1, j = 0; j <= stop; j++)
            {
              APosEnd = FBufferPos + APos + j;
              if ( APosEnd < FFileSize )
                LineW = LineW + WideString( GetChar( APosEnd ) );
            }
            LineText = DecodeString( LineW );
            APosTextX = x;
            APosTextY = y;
            StringOut( ABitmap->Canvas, APosTextX - FHViewPos, APosTextY, LineText, OutputOptions() );
            SelectLine( LineText, APosTextX - FHViewPos, APosTextY, FBufferPos + APos, false, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
            if (( AStrings != NULL ) )
              AStrings->Add( LineText, APosTextX - FHViewPos, APosTextY, FBufferPos + APos );

              //Draw lines
            if ( cHexLinesShow )
            {
              ABitmap->Canvas->Pen->Color = AColorLines;
              ABitmap->Canvas->Pen->Width = cHexLinesWidth;
              x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 1/*1 space*/ ) * FFontWidthDigits;
              ABitmap->Canvas->MoveTo( x - FHViewPos, y );
              ABitmap->Canvas->LineTo( x - FHViewPos, Y2 );
              x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 2/*2 spaces*/ + ( ATextWidthHex / 2 ) * 3 ) * FFontWidthDigits;
              ABitmap->Canvas->MoveTo( x - FHViewPos, y );
              ABitmap->Canvas->LineTo( x - FHViewPos, Y2 );
              x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 3/*3 spaces*/ + ATextWidthHex * 3 ) * FFontWidthDigits;
              ABitmap->Canvas->MoveTo( x - FHViewPos, y );
              ABitmap->Canvas->LineTo( x - FHViewPos, Y2 );
            }
          }
          DrawGutterTo( ABitmap );
          AViewAtEnd = FViewPos >= ( FFileSize - ALines * ACols );
        }
        break;
        case vbmodeUHex:
        {
          for ( int stop = IMin( ALines + 1, cMaxLines ), i = 1; i <= stop; i++)
          {
            ACurrentPos = FViewPos + ( i - 1 ) * ATextWidthUHex * 2;
            APos = ACurrentPos - FBufferPos;

              //Stop at the EOF
            if ( FBufferPos + APos >= FFileSize )
              break;

              //Stop after AFinalPos
            if ( ( AFinalPos >= 0 ) && ( ACurrentPos > AFinalPos ) )
              break;
            y = DrawOffsetY() + ( i - 1 ) * FFontHeight;
            Y2 = y + FFontHeight;

              //Draw offset
            x = DrawOffsetX();
            LineA = IntToHex( FBufferPos + APos, FHexOffsetLen ) + cHexOffsetSep;
            ABitmap->Canvas->Font->Color = AColorText;
            StringOut( ABitmap->Canvas, x - FHViewPos, y, LineA, OutputOptions() );

              //Draw hex background
            x += ( LineA.Length( ) + 1/*space*/ ) * FFontWidthDigits;
            ABitmap->Canvas->Brush->Color = AColorBackHex;
            ABitmap->Canvas->FillRect( Rect( x - FHViewPos, y, x - FHViewPos + FFontWidthDigits * ( ATextWidthUHex * 5 + 2 ), Y2 + ( cHexLinesWidth / 2 ) ) );

              //Draw hex digits
            x += FFontWidthDigits;
            for ( int stop = ATextWidthUHex - 1, j = 0; j <= stop; j++)
            {
              APosEnd = FBufferPos + APos + 2 * j;
              if ( APosEnd + 1 < FFileSize )
              {
                if ( ( j % 4 ) < 2 )
                  ABitmap->Canvas->Font->Color = AColorTextHex1;
                else
                  ABitmap->Canvas->Font->Color = AColorTextHex2;
                LineW = GetHex( APosEnd );
                StringOut( ABitmap->Canvas, x - FHViewPos, y, LineW, OutputOptions() );
                SelectLine( LineW, x - FHViewPos, y, FBufferPos + APos + 2 * j, true, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );

                  //Save hex offset
                ((TStrPositions*) FStrings )->AddHex( j, x - FHViewPos, ATextWidthUHex, 5 * FFontWidthDigits );

                  //Inc hex offset
                x += 5 * FFontWidthDigits; //5 spaces per word
                if ( j == ( ATextWidthUHex / 2 - 1 ) )
                  x += FFontWidthDigits; //Space in the middle
              }
            }

              //Draw text
            x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 3/*3 spaces*/ + ATextWidthUHex * 5 ) * FFontWidthDigits;
            ((TStrPositions*) FStrings )->AddHexMargin( x );
            x += FFontWidthDigits;
            ABitmap->Canvas->Brush->Color = AColorBack;
            ABitmap->Canvas->Font->Color = AColorText;
            LineW.Empty();
            for ( int stop = ATextWidthUHex - 1, j = 0; j <= stop; j++)
            {
              APosEnd = FBufferPos + APos + 2 * j;
              if ( APosEnd + 1 < FFileSize )
                LineW = LineW + WideString( GetChar( APosEnd ) );
            }
            LineText = DecodeString( LineW );
            APosTextX = x;
            APosTextY = y;
            StringOut( ABitmap->Canvas, APosTextX - FHViewPos, APosTextY, LineText, OutputOptions() );
            SelectLine( LineText, APosTextX - FHViewPos, APosTextY, FBufferPos + APos, false, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
            if (( AStrings != NULL ) )
              AStrings->Add( LineText, APosTextX - FHViewPos, APosTextY, FBufferPos + APos );

              //Draw lines
            if ( cHexLinesShow )
            {
              ABitmap->Canvas->Pen->Color = AColorLines;
              ABitmap->Canvas->Pen->Width = cHexLinesWidth;
              x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 1/*1 space*/ ) * FFontWidthDigits;
              ABitmap->Canvas->MoveTo( x - FHViewPos, y );
              ABitmap->Canvas->LineTo( x - FHViewPos, Y2 );
              x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 2/*2 spaces*/ + ( ATextWidthUHex / 2 ) * 5 ) * FFontWidthDigits;
              ABitmap->Canvas->MoveTo( x - FHViewPos, y );
              ABitmap->Canvas->LineTo( x - FHViewPos, Y2 );
              x = DrawOffsetX() + ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 3/*3 spaces*/ + ATextWidthUHex * 5 ) * FFontWidthDigits;
              ABitmap->Canvas->MoveTo( x - FHViewPos, y );
              ABitmap->Canvas->LineTo( x - FHViewPos, Y2 );
            }
          }
          DrawGutterTo( ABitmap );
          AViewAtEnd = FViewPos >= ( FFileSize - ALines * ACols );
        }
        break;
        case vbmodeBinary:
        {
          for ( int stop = IMin( ALines + 1, cMaxLines ), i = 1; i <= stop; i++)
          {
            ACurrentPos = FViewPos + ( i - 1 ) * ATextWidth;
            APos = ACurrentPos - FBufferPos;

              //Stop at the EOF
            if ( FBufferPos + APos >= FFileSize )
              break;

              //Stop after AFinalPos
            if ( ( AFinalPos >= 0 ) && ( ACurrentPos > AFinalPos ) )
              break;
            LineW.Empty();
            for ( int stop = ATextWidth - 1, j = 0; j <= stop; j++)
            {
              APosEnd = FBufferPos + APos + j;
              if ( APosEnd < FFileSize )
                LineW = LineW + WideString( GetChar( APosEnd ) );
            }
            LineText = DecodeString( LineW );
            APosTextX = DrawOffsetX();
            APosTextY = DrawOffsetY() + ( i - 1 ) * FFontHeight;
            StringOut( ABitmap->Canvas, APosTextX - FHViewPos, APosTextY, LineText, OutputOptions() );
            SelectLine( LineText, APosTextX - FHViewPos, APosTextY, FBufferPos + APos, false, ABitmap, APageWidth, APageHeight, AStringsObject, APrintMode, AFinalPos, ATextWidth, ATextWidthHex, ATextWidthUHex, AViewPageSize, AViewAtEnd, DX, AColorBack, AColorBackHex, AColorText, AColorTextHex1, AColorTextHex2, AColorLines, AColorError, AColorURL );
            if (( AStrings != NULL ) )
              AStrings->Add( LineText, APosTextX - FHViewPos, APosTextY, FBufferPos + APos );
          }
          DrawGutterTo( ABitmap );
          AViewAtEnd = FViewPos >= ( FFileSize - ALines * ACols );
        }
        break;
      } //case FMode
    } //if FFileOK
    else
      //Handle read error
    {
      LineA = Format( MsgViewerErrCannotReadPos, ARRAYOFCONST(( IntToHex(FViewPos,FHexOffsetLen) )) );
      x = ( ABitmap->Width - StringWidth( ABitmap->Canvas, LineA, OutputOptions() ) ) / 2;
      y = ( ABitmap->Height - FFontHeight ) / 2;
      ILimitMin( x, DrawOffsetX() );
      ILimitMin( y, DrawOffsetY() );
      ABitmap->Canvas->Font->Color = AColorError;
      StringOut( ABitmap->Canvas, x, y, LineA, OutputOptions() );
    }
  }
}


void __fastcall TATBinHex::Redraw( )
{
  if ( FEnabled2 ) //Enabled2 enables control redrawing
    try
    {
      Lock();

      //If file is empty, clear and quit
      if ( IsFileEmpty() )
      {
        HideScrollbars();
        DrawEmptyTo( FBitmap, ClientWidth, ClientHeight, false );
        Paint();
        return;
      }

      //Do drawing
      DrawTo( FBitmap, ClientWidth, ClientHeight, FStrings, false, - 1, FTextWidth, FTextWidthHex, FTextWidthUHex, FViewPageSize, FViewAtEnd ); //AStringsObject
 //APrintMode
 //AFinalPos not needed


      /*
      //Debug for TStrPositions.GetCoordFromPos:
      if TStrPositions(FStrings).GetCoordFromPos(FBitmap.Canvas, 60, FTabSize, IsAnsiDecode, DebugX, DebugY) then
      begin
        FBitmap.Canvas.Pen.Color := clRed;
        FBitmap.Canvas.MoveTo(DebugX, DebugY);
        FBitmap.Canvas.LineTo(DebugX, DebugY + 20);
      end;
      */

      //Update scrollbars and force paint
      UpdateVertScrollbar();
      UpdateHorzScrollbar();
      Paint();
    }
    __finally
    {
      Unlock();
    }
}


void __fastcall TATBinHex::HideScrollbars( )
{
  TScrollInfo si;
  FillChar( &si, sizeof( si ), 0 );
  /*# with si do */
  {
    si.cbSize = sizeof( si );
    si.fMask = SIF_ALL;
  }
  SetScrollInfo( Handle, SB_VERT, &si, true );
  SetScrollInfo( Handle, SB_HORZ, &si, true );
}


void __fastcall TATBinHex::UpdateVertScrollbar( )
{
  bool AHide = false;
  __int64 APageSize = 0, ACols = 0, ALines = 0, AMax = 0, APos = 0, APage = 0;
  TScrollInfo si;
  //Calculate "page size":
  ACols = ColsNum();
  ALines = LinesNum();
  APageSize = ALines * ACols;

  //debug
  ////Application.MainForm.Caption :=
  ////  Format('FileSize: %d, PageSize: %d', [FFileSize, FViewPageSize]);

  //Hide scrollbar in the following cases:
  AHide = ( ! FFileOK ) ||  // - Read error occurs
  ( IsFileEmpty() ) ||  // - File is empty
  ( IsModeVariable() && ( FViewPos == 0 ) && ( FFileSize <= FViewPageSize ) );
                      // - File too small
  if ( AHide )
  {
    AMax = 0;
    APos = 0;
    APage = 0;
  }
  else
  {
    AMax = FFileSize / ACols;
    I64LimitMin( AMax, 4 ); //Limit for small files
    I64LimitMax( AMax, MAXSHORT );
    APos = AMax * FViewPos / FFileSize;
    I64LimitMax( APos, AMax );
    APage = AMax * APageSize / FFileSize;
    I64LimitMin( APage, 1 );
    if ( APage >= AMax )
      APage = AMax + 1;
    I64LimitMax( APage, MAXSHORT );

    //Disable variable pagesize in Text mode,
    //otherwise pagesize will be small and unusable:
    if ( IsModeVariable() )
      APage = 0;
  }
  FillChar( &si, sizeof( si ), 0 );
  /*# with si do */
  {
    si.cbSize = sizeof( si );
    si.fMask = SIF_ALL;
    si.nMin = 0;
    si.nMax = AMax;
    si.nPage = APage;
    si.nPos = APos;
  }
  SetScrollInfo( Handle, SB_VERT, &si, true );
}


void __fastcall TATBinHex::UpdateHorzScrollbar( )
{
  bool AHide = false;
  int AMax = 0, APage = 0, APos = 0, AWidth = 0;
  TScrollInfo si;
  //Hide scrollbar in the following cases:
  AHide = ( ! FFileOK ) || // - Read error occurs
  ( IsFileEmpty() ) || // - File is empty
  ( IsModeVariable() && FTextWrap ) ||
                     // - Variable modes when TextWrap is on
  ( ( FMode == vbmodeBinary ) && FTextWidthFit && FFontMonospaced );
                     // - Binary mode when TextWidthFit is on and font is monospaced
  if ( AHide )
  {
    AMax = 0;
    APage = 0;
    APos = 0;
  }
  else
  {
    AWidth = IMax( HPosWidth(), FHViewPos + ClientWidth ); 
    //Remember max width, so scrollbar won't disappear
    ILimitMin( FHViewWidth, AWidth );
    AMax = FHViewWidth;
    APage = ClientWidth + 1;
    APos = FHViewPos;
  }
  FillChar( &si, sizeof( si ), 0 );
  /*# with si do */
  {
    si.cbSize = sizeof( si );
    si.fMask = SIF_ALL;
    si.nMin = 0;
    si.nMax = AMax;
    si.nPage = APage;
    si.nPos = APos;
  }
  SetScrollInfo( Handle, SB_HORZ, &si, true );
}


void __fastcall TATBinHex::Resize( )
{
  //Notepad feature: when control increases height and
  //file was at the end, then file is scrolled again to the end.
  if ( cResizeFollowTail )
    if ( ( ClientHeight > FClientHeight ) && FViewAtEnd )
      PosEnd();

  //Update last height
  FClientHeight = ClientHeight;
  Redraw();
}


void __fastcall TATBinHex::Paint( )
{
  Canvas->Draw( 0, 0, FBitmap );
  DrawNiceScroll();
}


__int64 __fastcall TATBinHex::PosBefore( const __int64 APos, TATLineType ALineType, TATDirection ADir )
{
  __int64 result = 0;
  WideString Separators [ 3 /*# TATLineType */ ];
  Separators[0] = L"\x0d\x0a";
  Separators[1] = L" !\"#$%&'()*+,-./:;<=>?@[\\]^`{|}~\x0d\x0a\x09";
  Separators[2] = L" ()<>{}\"'\x0d\x0a\x09";
  __int64 PosTemp = 0;
  int i = 0;
  result = APos;
  NormalizePos( result );
  PosTemp = result;
  for ( int stop = cMaxLengthSel, i = 1; i <= stop; i++)
  {
    NextPos( PosTemp, ADir, 1 );
    if ( ( PosBad( PosTemp ) ) || ( Separators[ALineType].Pos( WideString( GetChar( PosTemp ) ) ) > 0 ) )
      break;
    result = PosTemp;
  }
  return result;
}


void __fastcall TATBinHex::SelectLineAtPos( const __int64 APos, TATLineType ALineType )
{
  __int64 APosStart = 0, APosEnd = 0;
  APosStart = PosBefore( APos, ALineType, vdirUp );
  APosEnd = PosBefore( APos, ALineType, vdirDown );
  SetSelection( APosStart, APosEnd - APosStart + CharSize(), false, true, true );
}


WideString __fastcall TATBinHex::StringAtPos( const __int64 APos )
{
  WideString result;
  __int64 APosStart = 0, APosEnd = 0;
  AnsiString S;
  result.Empty();
  APosStart = PosBefore( APos, vbLineAll, vdirUp );
  APosEnd = PosBefore( APos, vbLineAll, vdirDown );
  if ( PosBad( APosStart ) || PosBad( APosEnd ) )
    return result;
  SetString( S, (char*) ( &FBuffer[APosStart - FBufferPos] ), APosEnd - APosStart + CharSize() );
  if ( !S.IsEmpty())
    if ( IsModeUnicode() )
      result = SetStringW( &S[1], S.Length( ), IsUnicodeBE() );
    else
      result = SCodepageToUnicode( S, FEncoding );
  return result;
}


void __fastcall TATBinHex::DblClick( )
{
  if ( FMouseStartDbl < 0 )
    return;
  FMouseDblClick = true;
  FMouseTriClick = false;
  FMouseTriTime = 0;
  if ( cSelectionByDoubleClick )
    SelectLineAtPos( FMouseStartDbl, vbLineWord );
}


void __fastcall TATBinHex::ContextPopup( TObject* Sender, const TPoint& MousePos, bool& Handled )
{
  FMousePopupPos = MousePos;
}


bool __fastcall TATBinHex::SourceAssigned( )
{
  bool result = false;
  switch ( FFileSourceType )
  {
    case vfSrcFile:
      result = ( !FFileName.IsEmpty()) && ( FFileHandle != INVALID_HANDLE_VALUE );
    break;
    case vfSrcStream:
      result =( FStream != NULL );
    break;
  default:
    result = false;
  }
  return result;
}


bool __fastcall TATBinHex::ReadSource( const __int64 APos, void* ABuffer, DWORD ABufferSize, DWORD& AReadSize )
{
  bool result = false;
  TInt64Rec APosRec;
  result = false;
  FillChar( ABuffer, ABufferSize, 0 );
  Assert(( ABuffer != NULL ), "Buffer not allocated: ReadSource" );
  Assert( SourceAssigned(), "Source not assigned: ReadSource" );
  switch ( FFileSourceType )
  {
    case vfSrcFile:
    {
      APosRec = *((TInt64Rec*) &APos );
	  SetFilePointer( FFileHandle, APosRec.Lo, (long*) &APosRec.Hi, FILE_BEGIN );
      result = ReadFile( FFileHandle, ABuffer, ABufferSize, &AReadSize, NULL );
    }
    break;
    case vfSrcStream:
      try
      {
        FStream->Position = APos;
        AReadSize = FStream->Read( ABuffer, ABufferSize );
        result = true;
      }
      catch(...)
      {
      }
    break;
  }
  return result;
}


void __fastcall TATBinHex::MsgReadError( )
{
  switch ( FFileSourceType )
  {
    case vfSrcFile:
    {
      WideString ATBinHex__3[ 1 ];
      ATBinHex__3[ 0 ] = FFileName;
      MsgError( SFormatW( MsgViewerErrCannotReadFile, ATBinHex__3, 1 ), 0 );
    }
    break;
    case vfSrcStream:
      MsgError( MsgViewerErrCannotReadStream, 0 );
    break;
  }
}


bool __fastcall TATBinHex::MsgReadRetry( )
{
  bool result = false;
  switch ( FFileSourceType )
  {
    case vfSrcFile:
    {
      WideString ATBinHex__4[ 1 ];
      ATBinHex__4[ 0 ] = FFileName;
      result = ( MsgBox( SFormatW( MsgViewerErrCannotReadFile, ATBinHex__4, 1 ), MsgViewerCaption, MB_RETRYCANCEL | MB_ICONERROR, 0 ) ) == IDRETRY;
    }
    break;
    case vfSrcStream:
      result = ( MsgBox( MsgViewerErrCannotReadStream, MsgViewerCaption, MB_RETRYCANCEL | MB_ICONERROR, 0 ) ) == IDRETRY;
    break;
  default:
    result = false;
  }
  return result;
}


void __fastcall TATBinHex::MsgOpenError( )
{
{
  WideString ATBinHex__5[ 1 ];
  ATBinHex__5[ 0 ] = FFileName;
  MsgError( SFormatW( MsgViewerErrCannotOpenFile, ATBinHex__5, 1 ), 0 );
}
}


void __fastcall TATBinHex::ReadBuffer( const __int64 APos )
{
  DWORD ARead = 0;
  int ABufSize = 0;
  if ( SourceAssigned() )
    if ( ! ( ( APos >= FBufferPos ) && ( APos < FBufferPos + 2 * FBufferMaxOffset ) ) )
    {
      FBufferPos = APos - FBufferMaxOffset;
      I64LimitMin( FBufferPos, 0 );
      NormalizePos( FBufferPos );
      do
      {
        FFileOK = ReadSource( FBufferPos, FBuffer, FBufferAllocSize, ARead );
        if ( FFileOK )
          break;
        if ( ! MsgReadRetry() )
          return;
      }
      while ( ! ( false ) );
      ReadUnicodeFmt();
      if ( ActiveLinesShow() )
        if ( FBufferPos <= FLinesBufSize )
        {
          ABufSize = I64Min( FLinesBufSize, FBufferPos + FBufferAllocSize );
          CountLines( ABufSize );
        }
      if ( FUrlShow )
        FindURLs( ARead );
      else
        InitURLs();
    }
}


bool __fastcall TATBinHex::Open( const WideString AFileName, bool ARedraw )
{
  bool result = false;
  result = true;
  if ( FFileName != AFileName )
  {
    FFileName = AFileName;
    result = LoadFile( true );
    if ( ARedraw )
      Redraw();
  }
  return result;
}


bool __fastcall TATBinHex::OpenStream( TStream* AStream, bool ARedraw )
{
  bool result = false;
  result = true;
  if ( FStream != AStream )
  {
    FStream = AStream;
    result = LoadStream();
    if ( ARedraw )
      Redraw();
  }
  return result;
}


int __fastcall TATBinHex::LinesNum( Graphics::TBitmap* ABitmap )
{
  int result = 0;
  int AHeight = 0;
  if (( ABitmap != NULL ) )
    AHeight = ABitmap->Height;
  else
    AHeight = FBitmap->Height;
  result = ( AHeight - DrawOffsetY() - cDrawOffsetBelowY ) / FFontHeight;
  ILimitMin( result, 0 );
  ILimitMax( result, cMaxLines );
  return result;
}


int __fastcall TATBinHex::ColsNumFit( Graphics::TBitmap* ABitmap )
{
  int result = 0;
  int AWidth = 0;
  if (( ABitmap != NULL ) )
    AWidth = ABitmap->Width;
  else
    AWidth = FBitmap->Width;
  result = ( AWidth - DrawOffsetX() ) / FFontWidthDigits;
  ILimitMin( result, cMinLength );
  ILimitMax( result, FMaxLength );
  return result;
}


int __fastcall TATBinHex::ColsNumHexFit( Graphics::TBitmap* ABitmap )
{
  int result = 0;


  //Take 4 spaces for each byte:

  const int cSpacesPerChar = 4;
  result = ( ColsNumFit( ABitmap ) - ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 4/*4 inner spaces*/ ) ) / cSpacesPerChar;
  ILimitMin( result, cMinLength );
  ILimitMax( result, FMaxLength );
  return result;
}


int __fastcall TATBinHex::ColsNumUHexFit( Graphics::TBitmap* ABitmap )
{
  int result = 0;


  //Take (6 + ~0.8) = ~7 spaces for each word
  //(~0.8 because wide ieroglyphs take about ~1.8 spaces).
  //Take 6 as it looks nicer:

  const int cSpacesPerChar = 6;
  result = ( ColsNumFit( ABitmap ) - ( FHexOffsetLen + sizeof( cHexOffsetSep ) + 4/*4 inner spaces*/ ) ) / cSpacesPerChar;
  ILimitMin( result, cMinLength );
  ILimitMax( result, FMaxLength );
  return result;
}


int __fastcall TATBinHex::ColsNum( Graphics::TBitmap* ABitmap )
{
  int result = 0;
  switch ( FMode )
  {
    case vbmodeBinary:
      result = FTextWidth;
    break;
    case vbmodeHex:
      result = FTextWidthHex;
    break;
    case vbmodeUHex:
      result = FTextWidthUHex * CharSize();
    break;
  default:
    result = CharSize(); //Stub for variable modes
  }
  return result;
}


bool __fastcall TATBinHex::PosBad( const __int64 APos )
{
  bool result = false;
  result = ! ( ( APos >= 0 ) && ( APos <= PosLast() ) && ( APos - FBufferPos >= 0 ) && ( APos - FBufferPos < FBufferAllocSize ) );
  return result;
}

//Max position regarding page size.
//Used only in Binary/Hex modes.


__int64 __fastcall TATBinHex::PosMax( )
{
  __int64 result = 0;
  int ACols = 0;
  ACols = ColsNum();
  result = FFileSize / ACols * ACols;
  if ( result == FFileSize )
    result -= ACols;
  result -= ( LinesNum() - 1 ) * ACols;
  I64LimitMin( result, 0 );
  return result;
}

//Max position at the very end of file.



__int64 __fastcall TATBinHex::PosLast( )
{
  __int64 result = 0;
  result = FFileSize;
  NormalizePos( result );
  result -= CharSize();
  I64LimitMin( result, 0 );
  return result;
}


//If we are at CR-LF middle (at LF) move up to CR:



void __fastcall TATBinHex::PosFixCRLF( __int64& APos )
{
  if ( IsModeVariable() && ( GetChar( APos ) == L'\x0a' ) && ( GetChar( APos - CharSize() ) == L'\x0d' ) )
    NextPos( APos, vdirUp, 1 );
}


//Used (with one exception) only in Binary/Hex modes.



void __fastcall TATBinHex::PosAt( const __int64 APos, bool ARedraw )
{
  int ACols = 0;
  if ( ( APos != FViewPos ) && ( APos >= 0 ) )
  {
    FViewPos = APos;
    I64LimitMax( FViewPos, PosLast() );
    ACols = ColsNum();
    FViewPos = FViewPos / ACols * ACols;
    ReadBuffer( FViewPos );
    if ( ARedraw )
      Redraw();
  }
}

//Used only in Binary/Hex modes.



void __fastcall TATBinHex::PosDec( const __int64 n )
{
  if ( FViewPos - n >= 0 )
    PosAt( FViewPos - n, true );
  else
    PosBegin();
}

//Used only in Binary/Hex modes.



void __fastcall TATBinHex::PosInc( const __int64 n )
{
  if ( FViewPos < PosMax() )
    PosAt( FViewPos + n, true );
}


void __fastcall TATBinHex::PosLineUp( int ALines )
{
  PosLineUp( FViewAtEnd, ALines );
}


void __fastcall TATBinHex::PosLineDown( int ALines )
{
  PosLineDown( FViewAtEnd, ALines );
}


void __fastcall TATBinHex::PosLineUp( bool AViewAtEnd, int ALines )
{
  if ( IsModeVariable() )
    PosNextLine( ALines, vdirUp, AViewAtEnd );
  else
    PosDec( ALines * ColsNum() );
}


void __fastcall TATBinHex::PosLineDown( bool AViewAtEnd, int ALines )
{
  if ( IsModeVariable() )
    PosNextLine( ALines, vdirDown, AViewAtEnd );
  else
    PosInc( ALines * ColsNum() );
}


void __fastcall TATBinHex::PosPageUp( )
{
  PosLineUp( LinesNum() );
}


void __fastcall TATBinHex::PosPageDown( )
{
  PosLineDown( LinesNum() );
}


void __fastcall TATBinHex::PosBegin( )
{
  HPosAt( 0, false );
  PosAt( 0, true );
}


void __fastcall TATBinHex::PosEndTry( )
{
  HPosAt( 0, false );
  if ( IsModeVariable() )
    PosNextLineFrom( FFileSize, LinesNum(), vdirUp, false, true );
  else
    PosAt( PosMax(), true );
}


void __fastcall TATBinHex::PosEnd( )
{
  //First scroll to end. If then scrollbar appears (the last line can be long),
  //then we need to scroll to end **again*. 
  PosEndTry();
  if ( ! FViewAtEnd )
    PosEndTry();
}


int __fastcall TATBinHex::GetPosPercent( )
{
  int result = 0;
  if ( IsFileEmpty() )
    result = 0;
  else
    result = FViewPos * 100 / FFileSize;
  return result;
}


void __fastcall TATBinHex::SetPosPercent( int APos )
{
  if ( APos <= 0 )
    PosBegin();
  else
    if ( APos >= 100 )
      PosEnd();
    else
      SetPosOffset( FFileSize * APos / 100 );
}


__int64 __fastcall TATBinHex::GetPosOffset( )
{
  __int64 result = 0;
  result = FViewPos;
  return result;
}


void __fastcall TATBinHex::SetPosOffset( const __int64 APos )
{
  if ( APos <= 0 )
    PosBegin();
  else
    if ( APos >= PosLast() )
      PosEnd();
    else
    {
      if ( IsModeVariable() )
        PosNextLineFrom( APos, 1, vdirUp, true, true );/*APassiveMove*/
      else
        PosAt( APos, true );
    }
}


void __fastcall TATBinHex::InitData( )
{
  FFileHandle = INVALID_HANDLE_VALUE;
  FFileSize = 0;
  FFileOK = true;
  FFileUnicodeFmt = vbUnicodeFmtUnknown;
  FFileSourceType = vfSrcNone;
  FBuffer = NULL;
  FBufferMaxOffset = 0;
  FBufferAllocSize = 0;
  FBufferPos = 0;
  if (( FLinesData != NULL ) )
    FreeMem( FLinesData, -1 );
  FLinesData = NULL;
  FLinesNum = 0;
  FViewPos = 0;
  FViewAtEnd = false;
  FViewPageSize = 0;
  FHViewPos = 0;
  FHViewWidth = 0;
  FSelStart = 0;
  FSelLength = 0;
  FMouseDown = false;
  FMouseStart = - 1;
  FMouseStartShift = - 1;
  FMouseStartDbl = - 1;
  FMouseDblClick = false;
  FMouseTriClick = false;
  FMouseTriTime = 0;
  FMousePopupPos = Point( - 1, - 1 );
  FMouseRelativePos = vmPosInner;
  FMouseNiceScroll = false;
  FMouseNiceScrollPos = Point( 0, 0 );
  FClientHeight = 0;
}


void __fastcall TATBinHex::FreeData( )
{
  switch ( FFileSourceType )
  {
    case vfSrcFile:
      FSearch->Filename.Empty();
    break;
    case vfSrcStream:
      FSearch->Stream = NULL;
    break;
  }
  FSearchStarted = false;
  if ( FFileHandle != INVALID_HANDLE_VALUE )
  {
    CloseHandle( FFileHandle );
    FFileHandle = INVALID_HANDLE_VALUE;
  }
  if (( FBuffer != NULL ) )
  {
    FreeMem( FBuffer, -1 );
    FBuffer = NULL;
    FBufferMaxOffset = 0;
    FBufferAllocSize = 0;
  }
  InitData();
  FTimerAutoScroll->Enabled = false;
  FTimerNiceScroll->Enabled = false;
}


bool __fastcall TATBinHex::LoadFile( bool ANewFile )
{
  bool result = false;
  __int64 OldViewPos = 0;
  int OldViewHPos = 0;
  bool OldAtEnd = false;
  __int64 OldSelStart = 0, OldSelLength = 0;
  bool NeedToRestorePos = false;
  result = false;
  if ( ANewFile || ( ! FAutoReload ) )
  {
    FNotif->Stop();
    FNotif2->Timer->Enabled = false;
  }
  OldViewPos = FViewPos;
  OldViewHPos = FHViewPos;
  OldAtEnd = FViewAtEnd;
  OldSelStart = FSelStart;
  OldSelLength = FSelLength;
  NeedToRestorePos = ! ANewFile;
  FreeData();
  if ( FFileName.IsEmpty())
  {
    result = true;
    return result;
  }
  FFileHandle = FFileOpen( FFileName );
  if ( FFileHandle == INVALID_HANDLE_VALUE )
  {
    MsgOpenError();
    return result;
  }
  FFileSize = FGetFileSize( FFileHandle );
  if ( FFileSize < 0 )
  {
    CloseHandle( FFileHandle );
    FFileHandle = INVALID_HANDLE_VALUE;
    FFileSize = 0;
    return result;
  }
  FFileSourceType = vfSrcFile;
  AllocBuffer();
  ReadBuffer();
  InitHexOffsetLen();

  //Restore selection
  if ( NeedToRestorePos )
    SetSelection( OldSelStart, OldSelLength, false, false, false );/*No scroll*//*No event*//*No redraw*/
  if ( FAutoReload )
  {
    //Restore pos, with tailing
    if ( NeedToRestorePos )
      if ( FAutoReloadFollowTail && OldAtEnd )
      {
        PosEnd();
        NeedToRestorePos = false; //don't restore later
      }

    //Start watching
    if ( FAutoReloadSimple )
    {
      FNotif2->Timer->Enabled = false;
      FNotif2->Timer->Interval = FAutoReloadSimpleTime;
      FNotif2->Filename = FFileName;
      FNotif2->Timer->Enabled = true;
    }
    else
    {
      FNotif->Filename = FFileName;
      FNotif->Start();
    }
  }
  if ( NeedToRestorePos )
  {
    SetPosOffset( OldViewPos );
    HPosAt( OldViewHPos, true );
  }
  result = true;
  return result;
}


bool __fastcall TATBinHex::LoadStream( )
{
  bool result = false;
  result = true;
  FNotif->Stop();
  FNotif2->Timer->Enabled = false;
  FreeData();
  if ( !( FStream != NULL ) )
    return result;
  FFileSize = FStream->Size;
  FFileSourceType = vfSrcStream;
  AllocBuffer();
  ReadBuffer();
  InitHexOffsetLen();
  return result;
}


void __fastcall TATBinHex::InitHexOffsetLen( )
{
  if ( IsFileEmpty() )
    FHexOffsetLen = 0;
  else
  {
    FHexOffsetLen = Trunc( Ln( ((long double) ( FFileSize + 0.0 ) ) ) / Ln( 16.0 ) ) + 1;
    ILimitMin( FHexOffsetLen, 8 );
    if ( ( FHexOffsetLen % 2 ) > 0 )
      FHexOffsetLen++;
  }
}


void __fastcall TATBinHex::SetMode( TATBinHexMode AMode )
{
  FMode = AMode;
  MouseNiceScroll = false;
  switch ( FFileSourceType )
  {
    case vfSrcFile:
      LoadFile( false );
    break;
    case vfSrcStream:
      LoadStream();
    break;
  }
  if ( SourceAssigned() )
    Redraw();
}


void __fastcall TATBinHex::SetTextEncoding( TATEncoding AValue )
{
  if ( AValue != FEncoding )
  {
    FEncoding = AValue;
    Redraw();
  }
}


void __fastcall TATBinHex::SetTextWidthTo( int AValue, int& AField )
{
  AField = AValue;
  ILimitMin( AField, cMinLength );
  ILimitMax( AField, FMaxLengths[vbmodeBinary] );
}


void __fastcall TATBinHex::SetTextWidth( int AValue )
{
  SetTextWidthTo( AValue, FTextWidth );
}


void __fastcall TATBinHex::SetTextWidthHexTo( int AValue, int& AField )
{
  AField = AValue;
  ILimitMin( AField, cMinLength );
  ILimitMax( AField, FMaxLengths[vbmodeHex] );
  AField = AField / 4 * 4;
  ILimitMin( AField, cMinLength );
}


void __fastcall TATBinHex::SetTextWidthUHexTo( int AValue, int& AField )
{
  AField = AValue;
  ILimitMin( AField, cMinLength );
  ILimitMax( AField, FMaxLengths[vbmodeUHex] );
  AField = AField / 4 * 4;
  ILimitMin( AField, cMinLength );
}


void __fastcall TATBinHex::SetTextWidthHex( int AValue )
{
  SetTextWidthHexTo( AValue, FTextWidthHex );
}


void __fastcall TATBinHex::SetTextWidthUHex( int AValue )
{
  SetTextWidthUHexTo( AValue, FTextWidthUHex );
}


void __fastcall TATBinHex::SetTextWidthFit( bool AValue )
{
  FTextWidthFit = AValue;
}


void __fastcall TATBinHex::SetTextWidthFitHex( bool AValue )
{
  if ( AValue != FTextWidthFitHex )
  {
    FTextWidthFitHex = AValue;
    if ( ! FTextWidthFitHex )
      FTextWidthHex = 16;
  }
}


void __fastcall TATBinHex::SetTextWidthFitUHex( bool AValue )
{
  if ( AValue != FTextWidthFitUHex )
  {
    FTextWidthFitUHex = AValue;
    if ( ! FTextWidthFitUHex )
      FTextWidthUHex = 8;
  }
}


void __fastcall TATBinHex::SetTextWrap( bool AValue )
{
  if ( AValue != FTextWrap )
  {
    FTextWrap = AValue;
    if ( FTextWrap )
      HPosAt( 0, false );
    Redraw();
  }
}


void __fastcall TATBinHex::SetSearchIndentVert( int AValue )
{
  FSearchIndentVert = AValue;
  ILimitMin( FSearchIndentVert, 0 );
  ILimitMax( FSearchIndentVert, cMaxSearchIndent );
}


void __fastcall TATBinHex::SetSearchIndentHorz( int AValue )
{
  FSearchIndentHorz = AValue;
  ILimitMin( FSearchIndentHorz, 0 );
  ILimitMax( FSearchIndentHorz, cMaxSearchIndent );
}


void __fastcall TATBinHex::SetFontOEM( TFont* AValue )
{
  FFontOEM->Assign( AValue );
}


void __fastcall TATBinHex::SetFontFooter( TFont* AValue )
{
  FFontFooter->Assign( AValue );
}


void __fastcall TATBinHex::SetFontGutter( TFont* AValue )
{
  FFontGutter->Assign( AValue );
}


void __fastcall TATBinHex::WMGetDlgCode( TMessage& Message )
{
  Message.Result = DLGC_WANTARROWS;
}


void __fastcall TATBinHex::WMEraseBkgnd( TMessage& Message )
{
  Message.Result = 1;
}


void __fastcall TATBinHex::WMVScroll( TWMVScroll& Message )
{
  int ACols = 0;
  __int64 AMax = 0, ANew = 0;
  bool ADisable = false;
  switch ( Message.ScrollCode )
  {
    case SB_TOP:
      PosBegin();
    break;
    case SB_BOTTOM:
      PosEnd();
    break;
    case SB_LINEUP:
      PosLineUp();
    break;
    case SB_LINEDOWN:
      PosLineDown();
    break;
    case SB_PAGEUP:
      PosPageUp();
    break;
    case SB_PAGEDOWN:
      PosPageDown();
    break;
    case SB_THUMBPOSITION: case SB_THUMBTRACK:
    {
      ACols = ColsNum();
      AMax = FFileSize / ACols;
      I64LimitMin( AMax, 1 );
      I64LimitMax( AMax, MAXSHORT );
      ANew = FFileSize * Message.Pos / AMax;

        //For small issue, when file position jumps at the EOF:
        //Disable scroll past the last visible line.
      ADisable = FViewAtEnd && ( ANew >= FViewPos );
      if ( ! ADisable )
        SetPosOffset( ANew );
    }
    break;
  }
  Message.Result = 0;
  DoScroll();
}


void __fastcall TATBinHex::WMHScroll( TWMHScroll& Message )
{
  switch ( Message.ScrollCode )
  {
    case SB_TOP:
      HPosBegin();
    break;
    case SB_BOTTOM:
      HPosEnd();
    break;
    case SB_LINELEFT:
      HPosLeft();
    break;
    case SB_LINERIGHT:
      HPosRight();
    break;
    case SB_PAGELEFT:
      HPosPageLeft();
    break;
    case SB_PAGERIGHT:
      HPosPageRight();
    break;
    case SB_THUMBPOSITION: case SB_THUMBTRACK:
      HPosAt( Message.Pos, true );
    break;
  }
  Message.Result = 0;
  DoScroll();
}


void __fastcall TATBinHex::KeyDown( WORD& key, TShiftState Shift )
{
  MouseNiceScroll = false;

  //PgDn: page down
  if ( ( key == VK_NEXT ) && ( Shift == ATBinHex__6 ) )
  {
    PosPageDown();
    key = 0;
    return;
  }

  //PgUp: page up
  if ( ( key == VK_PRIOR ) && ( Shift == ATBinHex__7 ) )
  {
    PosPageUp();
    key = 0;
    return;
  }

  //Down: down one line
  if ( ( key == VK_DOWN ) && ( Shift == ATBinHex__8 ) )
  {
    PosLineDown();
    key = 0;
    return;
  }

  //Up: up one line
  if ( ( key == VK_UP ) && ( Shift == ATBinHex__9 ) )
  {
    PosLineUp();
    key = 0;
    return;
  }

  //Ctrl+Home: begin of file
  if ( ( key == VK_HOME ) && ( Shift == ATBinHex__10 ) )
  {
    PosBegin();
    key = 0;
    return;
  }

  //Ctrl+End: end of file
  if ( ( key == VK_END ) && ( Shift == ATBinHex__11 ) )
  {
    PosEnd();
    key = 0;
    return;
  }

  //Left: ~200 px left
  if ( ( key == VK_LEFT ) && ( Shift == ATBinHex__12 ) )
  {
    HPosLeft();
    key = 0;
    return;
  }

  //Right: ~200 px right
  if ( ( key == VK_RIGHT ) && ( Shift == ATBinHex__13 ) )
  {
    HPosRight();
    key = 0;
    return;
  }

  //Home: leftmost position
  if ( ( key == VK_HOME ) && ( Shift == ATBinHex__14 ) )
  {
    HPosBegin();
    key = 0;
    return;
  }

  //End: rightmost position
  if ( ( key == VK_END ) && ( Shift == ATBinHex__15 ) )
  {
    HPosEnd();
    key = 0;
    return;
  }

  //Ctrl+A: select all
  if ( ( key == int( 'A' ) ) && ( Shift == ATBinHex__16 ) )
  {
    SelectAll();
    key = 0;
    return;
  }

  //Ctrl+C, Ctrl+Ins: copy to clipboard
  if ( ( ( key == int( 'C' ) ) || ( key == VK_INSERT ) ) && ( Shift == ATBinHex__17 ) )
  {
    CopyToClipboard();
    key = 0;
    return;
  }
  inherited::KeyDown( key, Shift );
}


void __fastcall TATBinHex::CopyToClipboard( bool AAsHex )
{
  AnsiString StrA;
  WideString StrW;
  try
  {
    if ( IsModeUnicode() )
    {
      StrW = GetSelTextW();
      SReplaceZerosW( StrW );
      SCopyToClipboardW( StrW );
    }
    else
    {
      StrA = GetSelTextRaw();
      if ( AAsHex )
        StrA = SToHex( StrA );
      else
        SReplaceZeros( StrA );
      SCopyToClipboard( StrA, FEncoding );
    }
  }
  catch(...)
  {
    MsgError( MsgViewerErrCannotCopyData, 0 );
  }
}


AnsiString __fastcall TATBinHex::GetSelTextRaw( int AMaxSize )
{
  AnsiString result;
  AnsiString ABuffer;
  int ABlockSize = 0;
  DWORD ABytesRead = 0;
  result = "";
  if ( FSelLength > 0 )
  {
    if ( AMaxSize > 0 )
      ABlockSize = I64Min( FSelLength, AMaxSize );
    else
      ABlockSize = I64Min( FSelLength, FMaxClipboardDataSizeMb * 1024 * 1024 );
    ABuffer.SetLength( ABlockSize );
    if ( ! ReadSource( FSelStart, &ABuffer[1], ABlockSize, ABytesRead ) )
    {
      MsgReadError();
      return result;
    }
    ABuffer.SetLength( ABytesRead );
    result = ABuffer;
  }
  return result;
}


AnsiString __fastcall TATBinHex::GetSelText( )
{
  AnsiString result;
  Assert( ! IsModeUnicode(), "SelText is called in Unicode mode" );
  result = GetSelTextRaw();
  result = SCodepageToUnicode( result, FEncoding );
  return result;
}


AnsiString __fastcall TATBinHex::GetSelTextShort( )
{
  AnsiString result;
  Assert( ! IsModeUnicode(), "SelText is called in Unicode mode" );
  result = GetSelTextRaw( cMaxShortLength * CharSize() );
  result = SCodepageToUnicode( result, FEncoding );
  return result;
}


WideString __fastcall TATBinHex::GetSelTextW( )
{
  WideString result;
  AnsiString S;
  Assert( IsModeUnicode(), "SelTextW is called in non-Unicode mode" );
  S = GetSelTextRaw();
  if ( S.IsEmpty())
    result.Empty();
  else
    result = SetStringW( &S[1], S.Length( ), IsUnicodeBE() );
  return result;
}


WideString __fastcall TATBinHex::GetSelTextShortW( )
{
  WideString result;
  AnsiString S;
  Assert( IsModeUnicode(), "SelTextW is called in non-Unicode mode" );
  S = GetSelTextRaw( cMaxShortLength * CharSize() );
  if ( S.IsEmpty())
    result.Empty();
  else
    result = SetStringW( &S[1], S.Length( ), IsUnicodeBE() );
  return result;
}


void __fastcall TATBinHex::SetSelection( const __int64 AStart, const __int64 ALength, bool AScroll, bool AFireEvent, bool ARedraw )
{
  bool ASelChanged = false;
  if ( ( AStart >= 0 ) && ( AStart <= PosLast() ) && ( ALength >= 0 ) )
  {
    ASelChanged = ( AStart != FSelStart ) || ( ALength != FSelLength );
    if ( ASelChanged )
    {
      FSelStart = AStart;
      FSelLength = ALength;
      NormalizePos( FSelStart );
      NormalizePos( FSelLength );
      I64LimitMax( FSelLength, PosLast() - FSelStart + CharSize() );
    }
    if ( AScroll )
      Scroll( AStart, FSearchIndentVert, FSearchIndentHorz, false );
    if ( ARedraw )
      Redraw();
    if ( ASelChanged && AFireEvent )
      DoSelectionChange();
  }
}


void __fastcall TATBinHex::Scroll( const __int64 APos, int AIndentVert, int AIndentHorz, bool ARedraw )
{
  __int64 ANewPos = 0;
  int ACols = 0, APosX = 0, APosY = 0;
  //Scroll vertically (redraw if needed)
  if ( IsModeVariable() )
  {
    PosNextLineFrom( APos, AIndentVert + 1, vdirUp, false, true );
  }
  else
  {
    ACols = ColsNum();
    ANewPos = APos / ACols * ACols;
    ANewPos -= ACols * AIndentVert;
    I64LimitMin( ANewPos, 0 );
    PosAt( ANewPos, true );
  }

  //Scroll horizontally (redraw if needed and allowed)
  if ( ((TStrPositions*) FStrings )->GetCoordFromPos( FBitmap->Canvas, APos, OutputOptions(), APosX, APosY ) )
  {
    if ( ! ( ( APosX >= DrawOffsetX() ) && ( APosX < ClientWidth - cSelectionRightIndent ) ) )
      HPosAt( APosX - DrawOffsetX() + FHViewPos - AIndentHorz * FFontWidthDigits, ARedraw );
  }
}


void __fastcall TATBinHex::SelectAll( )
{
  SetSelection( 0, FFileSize, false, true, true );
}


void __fastcall TATBinHex::SelectNone( bool AFireEvent )
{
  SetSelection( 0, 0, false, AFireEvent, true );
}


void __fastcall TATBinHex::MouseWheelUp( TObject* Sender, TShiftState Shift, const TPoint& MousePos, bool& Handled )
{
  if ( Shift == ATBinHex__18 )
    HPosLeft();
  else
    if ( Shift == ATBinHex__19 )
      IncreaseFontSize( true );
    else
      if ( Shift == ATBinHex__20 )
        PosLineUp( Mouse->WheelScrollLines );
  Handled = true;
}


void __fastcall TATBinHex::MouseWheelDown( TObject* Sender, TShiftState Shift, const TPoint& MousePos, bool& Handled )
{
  if ( Shift == ATBinHex__21 )
    HPosRight();
  else
    if ( Shift == ATBinHex__22 )
      IncreaseFontSize( false );
    else
      if ( Shift == ATBinHex__23 )
        PosLineDown( Mouse->WheelScrollLines );
  Handled = true;
}


__int64 __fastcall TATBinHex::MousePosition( int AX, int AY, bool AStrict )
{
  __int64 result = 0;
  result = ((TStrPositions*) FStrings )->GetPosFromCoord( FBitmap->Canvas, AX, AY, OutputOptions(), AStrict );
  return result;
}


void __fastcall TATBinHex::MouseDown( TMouseButton Button, TShiftState Shift, int x, int y )
{
  __int64 AMouseStartNew = 0;
  SetFocus();
  if ( MouseNiceScroll )
  {
    MouseNiceScroll = false;
    return;
  }
  switch ( Button )
  {
    case mbMiddle:
      if ( cMouseNiceScroll )
      {
        FMouseNiceScrollPos = Point( x, y );
        MouseNiceScroll = true;
      }
    break;
    case mbLeft:
    {
      AMouseStartNew = MousePosition( x, y, false );
      if ( Shift == ATBinHex__24 )
      {
          //Shift+click
        if ( cSelectionByShiftClick )
          SetSelection( I64Max( I64Min( AMouseStartNew, FMouseStartShift ), 0 ), Abs( AMouseStartNew - FMouseStartShift ), false, true, true );
      }
      else
      {
        if ( FMouseTriClick && ( GetTickCount() - FMouseTriTime <= GetDoubleClickTime() ) )
        {
            //Triple click
          FMouseDblClick = false;
          FMouseTriClick = false;
          FMouseTriTime = 0;
          if ( cSelectionByTripleClick )
            SelectLineAtPos( FMouseStartDbl, vbLineAll );
        }
        else
        {
          if ( FMouseDblClick )
          {
              //Double click (already handled in DblClick)
            FMouseDblClick = false;
            FMouseTriClick = true;
            FMouseTriTime = GetTickCount();
          }
          else
          {
              //Single click (not second click of double click!)
            SelectNone( false );
          }
        }
        FMouseDown = true;
        FMouseStart = AMouseStartNew;
        FMouseStartShift = FMouseStart;
        FMouseStartDbl = FMouseStart - CharSize();
        FMouseDblClick = false;
      }
    }
    break;
  }
}


void __fastcall TATBinHex::MouseMoveAction( int AX, int AY )
{
  __int64 APosStart = 0, APosEnd = 0;
  APosStart = FMouseStart;
  if ( APosStart < 0 )
    return;
  APosEnd = MousePosition( AX, AY, false );
  if ( APosEnd < 0 )
    return;
  if ( APosStart > APosEnd )
    SwapInt64( APosStart, APosEnd );
  SetSelection( APosStart, APosEnd - APosStart, false, false, true );/*No event*/
}


void __fastcall TATBinHex::MouseMove( TShiftState Shift, int x, int y )
{
  //Show URL cursor (when not NiceScroll)
  if ( ! MouseNiceScroll )
    if/*AStrict*/ ( IsPosURL( MousePosition( x, y, true ) ) )
      Cursor = crHandPoint;
    else
      Cursor = crIBeam;

  //If cursor is out of client area,
  //start FTimerAutoScroll which will do the scrolling
  if ( FMouseDown )
  {
    if ( y <= DrawOffsetY() )
    {
      FMouseRelativePos = vmPosUpper;
      FTimerAutoScroll->Enabled = true;
      return;
    }
    if ( y >= ClientHeight - 1 )
    {
      FMouseRelativePos = vmPosLower;
      FTimerAutoScroll->Enabled = true;
      return;
    }
    if ( x <= DrawOffsetX() )
    {
      FMouseRelativePos = vmPosLefter;
      FTimerAutoScroll->Enabled = true;
      return;
    }
    if ( x >= ClientWidth - 1 )
    {
      FMouseRelativePos = vmPosRighter;
      FTimerAutoScroll->Enabled = true;
      return;
    }

    //Else stop timer and perform needed actions
    FMouseRelativePos = vmPosInner;
    FTimerAutoScroll->Enabled = false;
    MouseMoveAction( x, y );
  }
  else
  {
    FTimerAutoScroll->Enabled = false;
  }
}


void __fastcall TATBinHex::MouseUp( TMouseButton Button, TShiftState Shift, int x, int y )
{
  if ( Button == mbLeft )
  {
    //Mouse released where pressed:
    if ( MousePosition( x, y, false ) == FMouseStart )
      DoClickURL( FMouseStart );
    FMouseDown = false;
    FMouseStart = - 1;
    FTimerAutoScroll->Enabled = false;
    DoSelectionChange();
  }
}


void __fastcall TATBinHex::TimerAutoScrollTimer( TObject* Sender )
{
  int y = 0;
  y = ScreenToClient( Mouse->CursorPos ).y;
  switch ( FMouseRelativePos )
  {
    case vmPosUpper:
    {
      PosLineUp( cMouseAutoScrollSpeedY );
      MouseMoveAction( 0, - 1 );
    }
    break;
    case vmPosLower:
    {
      PosLineDown( cMouseAutoScrollSpeedY );
      MouseMoveAction( 0, ClientHeight + 1 );
    }
    break;
    case vmPosLefter:
    {
      HPosDec( cMouseAutoScrollSpeedX );
      MouseMoveAction( - 1, y );
    }
    break;
    case vmPosRighter:
    {
      HPosInc( cMouseAutoScrollSpeedX );
      MouseMoveAction( ClientWidth + 1, y );
    }
    break;
  }
}


void __fastcall TATBinHex::TimerNiceScrollTimer( TObject* Sender )
{
  TPoint Pnt;
  int SpeedX = 0, SpeedY = 0;
  Pnt = ScreenToClient( Mouse->CursorPos );
  Pnt.x -= FMouseNiceScrollPos.x;
  Pnt.y -= FMouseNiceScrollPos.y;

  //Perform the scroll only when cursor is out of initial bitmap circle
  if ( Sqrt( Sqr( Pnt.y ) + Sqr( Pnt.x ) ) > cBitmapNiceScrollRadius )
  {
    //Scroll speed should be proportional to the distance between cursor and bitmap center
    SpeedX = Abs( Pnt.x ) / cBitmapNiceScrollRadius * cMouseNiceScrollSpeedX;
    SpeedY = Abs( Pnt.y ) / cBitmapNiceScrollRadius * cMouseNiceScrollSpeedY;

    //Top quarter
    if ( ( Pnt.y <= 0 ) && ( Abs( Pnt.y ) >= Abs( Pnt.x ) ) )
    {
      Cursor = crNiceScrollUp;
      PosLineUp( SpeedY );
      return;
    }

    //Bottom quarter
    if ( ( Pnt.y >= 0 ) && ( Abs( Pnt.y ) >= Abs( Pnt.x ) ) )
    {
      Cursor = crNiceScrollDown;
      PosLineDown( SpeedY );
      return;
    }

    //Right quarter
    if ( ( Pnt.x >= 0 ) && ( Abs( Pnt.x ) >= Abs( Pnt.y ) ) )
    {
      Cursor = crNiceScrollRight;
      HPosInc( SpeedX );
      return;
    }

    //Left quarter
    if ( ( Pnt.x <= 0 ) && ( Abs( Pnt.x ) >= Abs( Pnt.y ) ) )
    {
      Cursor = crNiceScrollLeft;
      HPosDec( SpeedX );
      return;
    }
  }
  Cursor = crNiceScrollNone;
}


void __fastcall TATBinHex::CreateParams( TCreateParams& Params )
{
  inherited::CreateParams( Params );
  Params.Style = Params.Style | WS_VSCROLL | WS_HSCROLL;
}


void __fastcall TATBinHex::MenuItemCopyClick( TObject* Sender )
{
  CopyToClipboard();
}


void __fastcall TATBinHex::MenuItemCopyHexClick( TObject* Sender )
{
  CopyToClipboard( true );
}


void __fastcall TATBinHex::MenuItemCopyLinkClick( TObject* Sender )
{
  AnsiString S;
  S = PosURL( MousePosition( FMousePopupPos.x, FMousePopupPos.y, true ) );
  if ( !S.IsEmpty())
    SCopyToClipboard( S, vEncANSI );
}


void __fastcall TATBinHex::MenuItemSelectAllClick( TObject* Sender )
{
  SelectAll();
}


void __fastcall TATBinHex::MenuItemEncMenuClick( TObject* Sender )
{
  TPoint P;
  P = Mouse->CursorPos;
  TextEncodingsMenu( P.x, P.y );
}


void __fastcall TATBinHex::MenuItemSelectLineClick( TObject* Sender )
{
  __int64 P = 0;
  /*# with FMousePopupPos do */
  if ( ( FMousePopupPos.x >= 0 ) && ( FMousePopupPos.y >= 0 ) )
  {
    P = MousePosition( FMousePopupPos.x, FMousePopupPos.y, false );
    if ( P >= 0 )
      SelectLineAtPos( P, vbLineAll );
  }
}


void __fastcall TATBinHex::UpdateMenu( TObject* Sender )
{
  bool En = false;
  En = ! IsFileEmpty();
  FMenuItemCopy->Enabled = En && ( FSelLength > 0 );
  FMenuItemCopyHex->Enabled = En && ( FSelLength > 0 ) && ( FMode == vbmodeHex );
  FMenuItemCopyLink->Enabled = En && IsPosURL( MousePosition( FMousePopupPos.x, FMousePopupPos.y, true ) );
  FMenuItemSelectLine->Enabled = En;
  FMenuItemSelectAll->Enabled = En && ! ( ( FSelStart == 0 ) && ( FSelLength >= NormalizedPos( FFileSize ) ) );
  FMenuItemEncMenu->Enabled = En;
  FMenuItemCopy->Visible = FPopupCommands.Contains(vpCmdCopy );
  FMenuItemCopyHex->Visible = FPopupCommands.Contains(vpCmdCopyHex );
  FMenuItemCopyLink->Visible = FPopupCommands.Contains(vpCmdCopyLink );
  FMenuItemSelectLine->Visible = FPopupCommands.Contains(vpCmdSelectLine );
  FMenuItemSelectAll->Visible = FPopupCommands.Contains(vpCmdSelectAll );
  FMenuItemEncMenu->Visible = FPopupCommands.Contains(vpCmdEncMenu );
}


void __fastcall TATBinHex::ReadUnicodeFmt( )
{
  WORD ABuffer //2-byte Unicode signature
  = 0;
  DWORD ABytesRead = 0;
  if ( FFileUnicodeFmt == vbUnicodeFmtUnknown )
  {
    FFileUnicodeFmt = vbUnicodeFmtLE;
    if ( SourceAssigned() && ( FFileSize >= 2 ) )
    {
      if ( ReadSource( 0, &ABuffer, sizeof( ABuffer ), ABytesRead ) && ( ABytesRead >= 2 ) && ( ABuffer == 0xFFFE ) )
        FFileUnicodeFmt = vbUnicodeFmtBE;
    }
  }
}


void __fastcall TATBinHex::HPosAt( int APos, bool ARedraw )
{
  ILimitMin( APos, 0 );
  ILimitMax( APos, HPosMax() );
  if ( APos != FHViewPos )
  {
    FHViewPos = APos;
    if ( ARedraw )
      Redraw();
  }
}


void __fastcall TATBinHex::HPosInc( int n )
{
  HPosAt( FHViewPos + n, true );
}


void __fastcall TATBinHex::HPosDec( int n )
{
  HPosAt( FHViewPos - n, true );
}


void __fastcall TATBinHex::HPosBegin( )
{
  HPosAt( 0, true );
}


void __fastcall TATBinHex::HPosEnd( )
{
  HPosAt( MaxInt, true );
}


void __fastcall TATBinHex::HPosLeft( )
{
  HPosDec( cArrowScrollSize );
}


void __fastcall TATBinHex::HPosRight( )
{
  HPosInc( cArrowScrollSize );
}


void __fastcall TATBinHex::HPosPageLeft( )
{
  HPosDec( ClientWidth );
}


void __fastcall TATBinHex::HPosPageRight( )
{
  HPosInc( ClientWidth );
}


int __fastcall TATBinHex::HPosWidth( )
{
  int result = 0;
  result = ((TStrPositions*) FStrings )->GetScreenWidth( FBitmap->Canvas, OutputOptions() ) + FHViewPos;
  return result;
}


int __fastcall TATBinHex::HPosMax( )
{
  int result = 0;
  result = HPosWidth() - ClientWidth;
  ILimitMin( result, 0 );
  return result;
}


//Note: AStartPos may be equal to FFileSize (without -CharSize).



__int64 __fastcall TATBinHex::PrevPos( const __int64 APos, const __int64& AStartPos, TATDirection& ADir, WideString& ALine, bool& APassiveMove, __int64& xResult )
{
  __int64 result = 0;
  result = APos - CharSize();
  return result;
}


bool __fastcall TATBinHex::PrevLine( __int64& APos, const __int64& AStartPos, TATDirection& ADir, WideString& ALine, bool& APassiveMove, __int64& xResult )
{
  bool result = false;
  int Len2 = 0;
  result = true;
  PosFixCRLF( APos );
  if ( PosBad( PrevPos( APos, AStartPos, ADir, ALine, APassiveMove, xResult ) ) )
    return result;
  Len2 = FindLineLength( PrevPos( APos, AStartPos, ADir, ALine, APassiveMove, xResult ), ADir, ALine );
  result = ( Len2 > 0 );
  if ( result )
    NextPos( APos, ADir, Len2 );
  return result;
}


__int64 __fastcall TATBinHex::FindLinePos( const __int64 AStartPos, TATDirection ADir, WideString& ALine, bool APassiveMove )
  //

{
  __int64 result = 0;


  //

  //

  int Len = 0;
  if ( AStartPos < 0 )
  {
    result = - 1;
    return result;
  }
  result = AStartPos;
  NormalizePos( result );
  PosFixCRLF( result );
  Len = FindLineLength( result, ADir, ALine );

  //-------- Move up
  if ( ADir == vdirUp )
  {
    //handle APassiveMove
    if ( Len <= 1 )
      if ( APassiveMove )
      {
        if ( Len == 0 )
          PrevLine( result, AStartPos, ADir, ALine, APassiveMove, result );
        return result;
      }

    //if at line middle, then move to start and exit
    if ( Len > 1 )
    {
      NextPos( result, ADir, Len - 1 );
      if ( PosBad( result ) )
        result = - 1;
      return result;
    }

    //if at the line start
    if ( Len == 1 )
    {
      NextPos( result, ADir, 1 );
      if ( PosBad( result ) )
      {
        result = - 1;
        return result;
      }
    }
    if ( PrevLine( result, AStartPos, ADir, ALine, APassiveMove, result ) )
      return result;
    if ( Len == 0 )
    {
      NextPos( result, ADir, 1 );
      if ( PrevLine( result, AStartPos, ADir, ALine, APassiveMove, result ) )
        return result;
    }
  }
  else

  //-------- Move down
  {
    //Move to CR
    NextPos( result, ADir, Len );

    //Skip CR
    switch ( GetChar( result ) )
    {
      case '\x0d':
      {
        NextPos( result, ADir, 1 );
        if ( GetChar( result ) == L'\x0a' )
          NextPos( result, ADir, 1 );
      }
      break;
      case '\x0a':
      {
        NextPos( result, ADir, 1 );
      }
      break;
    }
  }
  if ( PosBad( result ) )
    result = - 1;
  return result;
}

//Note: AStartPos may be equal to FFileSize (without -1).



int __fastcall TATBinHex::FindLineLength( const __int64 AStartPos, TATDirection ADir, WideString& ALine )
{
  int result = 0;
  int AMaxWidth = 0, i = 0;
  __int64 APos = 0;
  TATStringExtent DX;
  wchar_t wCh = L'\0';
  result = 0;
  ALine.Empty();
  if ( AStartPos < 0 )
    return result;
  APos = AStartPos;
  NormalizePos( APos );
  if ( ADir == vdirUp )
  {
    I64LimitMax( APos, PosLast() );
    if ( PosBad( APos ) )
      return result;
  }
  for ( int stop = FMaxLength, i = 1; i <= stop; i++)
  {
    if ( PosBad( APos ) )
      break;
    wCh = GetChar( APos );
    if ( SCharCR( wCh ) )
      break;
    ALine = ALine + WideString( wCh );
    result++;
    NextPos( APos, ADir, 1 );
  }
  if ( FTextWrap && ( result > 0 ) )
  {
    AMaxWidth = FBitmap->Width - DrawOffsetX();
    if ( StringWidth( FBitmap->Canvas, ALine, OutputOptions() ) > AMaxWidth )
      if ( StringExtent( FBitmap->Canvas, ALine, DX, OutputOptions() ) )
      {
        result = 1;
        for ( int stop = 1, i = ALine.Length( ); i >= stop; i--)
          if ( DX[i] <= AMaxWidth )
          {
            result = StringWrapPosition( ALine, i );
            break;
          }
        ALine.SetLength( result );
        SDelLastSpaceW( ALine );
      }
  }
  ALine = DecodeString( ALine );
  return result;
}


void __fastcall TATBinHex::PosNextLineFrom( const __int64 AStartPos, int ALinesNum, TATDirection ADir, bool APassiveMove, bool ARedraw )
{
  __int64 ANewPos = 0;
  WideString ALine;
  int i = 0;
  ANewPos = AStartPos;
  NormalizePos( ANewPos );
  NextPos( ANewPos, ADir, ALinesNum * FMaxLength );
  I64LimitMin( ANewPos, 0 );
  I64LimitMax( ANewPos, PosLast() );
  ReadBuffer( ANewPos );
  ANewPos = AStartPos;
  NormalizePos( ANewPos );
  for ( int stop = ALinesNum, i = 1; i <= stop; i++)
    ANewPos = FindLinePos( ANewPos, ADir, ALine, APassiveMove );
  if ( ANewPos < 0 )
  {
    if ( ADir == vdirDown )
    {
      ANewPos = FindLinePos( FFileSize, vdirUp, ALine, false );
      I64LimitMin( ANewPos, 0 );
    }
    else
      ANewPos = 0;
  }
  FViewPos = ANewPos;
  ReadBuffer( FViewPos );
  if ( ARedraw )
    Redraw();
}


void __fastcall TATBinHex::PosNextLine( int ALinesNum, TATDirection ADir, bool AViewAtEnd )
{
  if ( AViewAtEnd && ( ADir == vdirDown ) )
    return;
  PosNextLineFrom( FViewPos, ALinesNum, ADir, false, true );
}


int __fastcall TATBinHex::CharSize( )
{
  int result = 0;
  int cSizes [ 5 /*# TATBinHexMode */ ];
  cSizes[0] = 1;
  cSizes[1] = 1;
  cSizes[2] = 1;
  cSizes[3] = 2;
  cSizes[4] = 2;
  result = cSizes[FMode];
  return result;
}


bool __fastcall TATBinHex::IsFileEmpty( )
{
  bool result = false;
  result = FFileSize < CharSize();
  return result;
}


bool __fastcall TATBinHex::IsModeVariable( )
{
  bool result = false;
  result = ATBinHex__25.Contains(FMode );
  return result;
}


bool __fastcall TATBinHex::IsModeUnicode( )
{
  bool result = false;
  result = ATBinHex__26.Contains(FMode );
  return result;
}


bool __fastcall TATBinHex::IsUnicodeBE( )
{
  bool result = false;
  result = FFileUnicodeFmt == vbUnicodeFmtBE;
  return result;
}


void __fastcall TATBinHex::NormalizePos( __int64& APos )
{
  if ( IsModeUnicode() )
    APos = APos / 2 * 2;
}


__int64 __fastcall TATBinHex::NormalizedPos( const __int64 APos )
{
  __int64 result = 0;
  result = APos;
  NormalizePos( result );
  return result;
}


void __fastcall TATBinHex::NextPos( __int64& APos, TATDirection ADir, int AChars )
{
  if ( ADir == vdirDown )
    APos += AChars * CharSize();
  else
    APos -= AChars * CharSize();
}


wchar_t __fastcall TATBinHex::GetChar( const __int64 ACharPos )
{
  wchar_t result = L'\0';
  __int64 APos = 0;
  char Ch = '\0';
  result = L'\x00';
  if ( IsFileEmpty() )
    return result;
  if ( ( ACharPos >= 0 ) && ( ACharPos <= PosLast() ) )
  {
    APos = ACharPos - FBufferPos;
    Assert( ( APos >= 0 ) && ( APos < FBufferAllocSize ), "Buffer position out of range: GetChar" );
    if ( IsModeUnicode() )
    {
      if ( IsUnicodeBE() )
        result = ((wchar_t) ( int( FBuffer[APos + 1] ) + ( int( FBuffer[APos] ) << 8 ) ) );
      else
        result = ((wchar_t) ( int( FBuffer[APos] ) + ( int( FBuffer[APos + 1] ) << 8 ) ) );
    }
    else
    {
      Ch = FBuffer[APos];
      result = ((wchar_t) int( Ch ) ); //DecodeString used later
    }
  }
  if ( ( ! IsModeVariable() ) && ( result == L'\x09' ) )
    result = cCharSpecial;
  else
    if ( ( int( result ) < int( FFontFirstChar ) ) && ( ( ! IsModeVariable() ) || ( ( result != L'\x0d' ) && ( result != L'\x0a' ) && ( result != L'\x09' ) ) ) )
      result = cCharSpecial;
  return result;
}

//decode string from GetChar encoding



WideString __fastcall TATBinHex::DecodeString( const WideString S )
{
  WideString result;
  AnsiString SS;
  int i = 0;
  if ( IsModeUnicode() )
    result = S;
  else
  {
    SS = "";
    for ( int stop = S.Length( ), i = 1; i <= stop; i++)
      SS = SS + ((char) int( S[i] ) );
    if ( ( FEncoding == vEncOEM ) && FTextOemSpecial )
      result = SCodepageToUnicode( SS, vEncANSI );
    else
      result = SCodepageToUnicode( SS, FEncoding );
  }
  return result;
}


WideString __fastcall TATBinHex::GetHex( const __int64 ACharPos )
{
  WideString result;
  __int64 APos = 0;
  result.Empty();
  if ( ( ACharPos >= 0 ) && ( ACharPos <= PosLast() ) )
  {
    APos = ACharPos - FBufferPos;
    Assert( ( APos >= 0 ) && ( APos < FBufferAllocSize ), "Buffer position out of range: GetHex" );
    result = IntToHex( int( FBuffer[APos] ), 2 ); //Hex of current byte
    if ( IsModeUnicode() ) //Add hex of next byte
      if ( APos + 1 < FBufferAllocSize ) //Range check
        result = IntToHex( int( FBuffer[APos + 1] ), 2 ) + result;
  }
  return result;
}


TFont* __fastcall TATBinHex::ActiveFont( )
{
  TFont* result = NULL;
  if ( ( ! IsModeUnicode() ) && ( FEncoding == vEncOEM ) && FTextOemSpecial )
    result = FFontOEM;
  else
    result = Font;
  return result;
}


void __fastcall TATBinHex::Lock( )
{
  FLockCount++;
}


void __fastcall TATBinHex::Unlock( )
{
  FLockCount--;
}


bool __fastcall TATBinHex::Locked( )
{
  bool result = false;
  result = FLockCount > 0;
  return result;
}


void __fastcall TATBinHex::NotifChanged( TObject* Sender )
{
  if ( ! Locked() )
    try
    {
      Lock();
      if ( ! IsFileExist( FFileName ) )
      {
        //File is deleted:
        FFileName.Empty();
        LoadFile( true );
      }
      else
      {
        //File is changed:
        LoadFile( false );
      }
      Redraw();
      if ( FAutoReloadBeep )
        MessageBeep( MB_ICONEXCLAMATION );
    }
    __finally
    {
      Unlock();
    }
  DoFileReload();
}


void __fastcall TATBinHex::DoFileReload( )
{
  if (( FOnFileReload != NULL ) )
    FOnFileReload( this );
}


void __fastcall TATBinHex::SetAutoReload( bool AValue )
{
  if ( FAutoReload != AValue )
  {
    FAutoReload = AValue;
    if ( !FFileName.IsEmpty())
      if ( FAutoReloadSimple )
      {
        FNotif2->Timer->Enabled = false;
        FNotif2->Timer->Interval = FAutoReloadSimpleTime;
        FNotif2->Filename = FFileName;
        FNotif2->Timer->Enabled = FAutoReload;
      }
      else
      {
        FNotif->Enabled = false;
        FNotif->Filename = FFileName;
        FNotif->Enabled = FAutoReload;
      }
  }
}


void __fastcall TATBinHex::DoSelectionChange( )
{
  if (( FOnSelectionChange != NULL ) )
    FOnSelectionChange( this );
}


void __fastcall TATBinHex::SetTabSize( int AValue )
{
  FTabSize = AValue;
  ILimitMin( FTabSize, cTabSizeMin );
  ILimitMax( FTabSize, cTabSizeMax );
}


int __fastcall TATBinHex::GetMaxLengths( TATBinHexMode AIndex )
{
  int result = 0;
  result = FMaxLengths[AIndex];
  return result;
}


void __fastcall TATBinHex::SetMaxLengths( TATBinHexMode AIndex, int AValue )
{
  ILimitMin( AValue, cMinLength );
  ILimitMax( AValue, cMaxLength );
  FMaxLengths[AIndex] = AValue;
  SetTextWidth( FTextWidth );
  SetTextWidthHex( FTextWidthHex );
  SetTextWidthUHex( FTextWidthUHex );
}


bool __fastcall TATBinHex::IncreaseFontSize( bool AIncrement )
{
  bool result = false;
  result = TextIncreaseFontSize( ActiveFont(), Canvas, AIncrement );
  if ( result )
  {
    Redraw();
    DoOptionsChange();
  }
  return result;
}


TATStreamSearchProgress __fastcall TATBinHex::GetOnSearchProgress( )
{
  TATStreamSearchProgress result;
  result = FSearch->OnProgress;
  return result;
}


void __fastcall TATBinHex::SetOnSearchProgress( TATStreamSearchProgress AValue )
{
  FSearch->OnProgress = AValue;
}


__int64 __fastcall TATBinHex::GetSearchResultStart( )
{
  __int64 result = 0;
  result = FSearch->FoundStart;
  return result;
}


__int64 __fastcall TATBinHex::GetSearchResultLength( )
{
  __int64 result = 0;
  result = FSearch->FoundLength;
  return result;
}


WideString __fastcall TATBinHex::GetSearchString( )
{
  WideString result;
  result = FSearch->SearchString;
  return result;
}


bool __fastcall TATBinHex::FindFirst( const WideString AText, TATStreamSearchOptions AOptions )
{
  bool result = false;
  TATEncoding AStreamEncoding;
  __int64 AStartPos = 0;
  Assert( SourceAssigned(), "Source not assigned: FindFirst" );

  //Handle encoding:
  if ( IsModeUnicode() )
  {
    if ( IsUnicodeBE() )
      AStreamEncoding = vEncUnicodeBE;
    else
      AStreamEncoding = vEncUnicodeLE;
  }
  else
  {
    AStreamEncoding = FEncoding;
  }

  //Handle "Origin" option:
  if ( ! ( AOptions.Contains(asoFromPage ) ) )
  {
    AStartPos = 0; //0 is valid for both directions
  }
  else
  {
    if ( ! ( AOptions.Contains(asoBackward ) ) )
      AStartPos = FViewPos; //Forward: page start position
    else
      AStartPos = FViewPos + FViewPageSize; //Backward: page end position
  }
  try
  {
    switch ( FFileSourceType )
    {
      case vfSrcFile:
        FSearch->Filename = FFileName;
      break;
      case vfSrcStream:
        FSearch->Stream = FStream;
      break;
    }
    FSearchStarted = true;
  }
  catch(...)
  {
    MsgOpenError();
    result = false;
    return result;
  }
  result = FSearch->FindFirst( AText, AStartPos, AStreamEncoding, AOptions );
  return result;
}


bool __fastcall TATBinHex::FindNext( bool AFindPrevious )
{
  bool result = false;
  Assert( SourceAssigned(), "Source not assigned: FindNext" );
  Assert( FSearchStarted, "Search not started: FindNext" );
  result = FSearch->FindNext( AFindPrevious );
  return result;
}


void __fastcall TATBinHex::SetMaxClipboardDataSizeMb( int AValue )
{
  ILimitMin( AValue, cMaxClipboardDataSizeMbMin );
  ILimitMax( AValue, cMaxClipboardDataSizeMbMax );
  FMaxClipboardDataSizeMb = AValue;
}


void __fastcall TATBinHex::DoOptionsChange( )
{
  if (( FOnOptionsChange != NULL ) )
    FOnOptionsChange( this );
}


void __fastcall TATBinHex::DoScroll( )
{
  if (( FOnScroll != NULL ) )
    FOnScroll( this );
}


void __fastcall TATBinHex::SetEnabled( bool AValue )
{
  inherited::SetEnabled( AValue );
  Redraw();
}


void __fastcall TATBinHex::SetEnabled2( bool AValue )
{
  if ( AValue )
  {
    FEnabled2 = AValue;
    Enabled = AValue;
  }
  else
  {
    Enabled = AValue;
    FEnabled2 = AValue;
  }
}


void __fastcall TATBinHex::SetMouseNiceScroll( bool AValue )
{
  if ( FMouseNiceScroll != AValue )
  {
    FMouseNiceScroll = AValue;
    FTimerNiceScroll->Enabled = AValue;
    Cursor = crIBeam;
    Redraw();
  }
}


void __fastcall TATBinHex::DrawNiceScroll( )
{
  if ( MouseNiceScroll )
    Canvas->Draw( FMouseNiceScrollPos.x - cBitmapNiceScrollRadius, FMouseNiceScrollPos.y - cBitmapNiceScrollRadius, FBitmapNiceScroll );
}


void __fastcall TATBinHex::ExitProc( TObject* Sender )
{
  MouseNiceScroll = false;
}

//--------------------------------------------------------



TATUnicodeFormat cUnicodeFormatList [ 2 /*# Boolean */ ];
void cUnicodeFormatListInit( )
{
  cUnicodeFormatList[0] = vbUnicodeFmtLE;
  cUnicodeFormatList[1] = vbUnicodeFmtBE;
}


void __fastcall TATBinHex::TextEncodingsMenu( int AX, int AY )
{
  TATEncoding AEnc;
  TMenuItem* AItem = NULL;
  bool ANewFamily = false, ANewRow = false;
  int i = 0;
  if ( IsModeUnicode() )
  //1) Unicode encodings menu (LE, BE)
  {
    //Create menu
    if ( !( FMenuCodepagesUn != NULL ) )
    {
      FMenuCodepagesUn = new TPopupMenu( this );
      FMenuCodepagesUn->Alignment = paCenter;
      for ( int stop = /*# High(TATEncoding) */ 75, AEnc = /*# Low(TATEncoding) */ 0; AEnc <= stop; Inc( AEnc ) )
        if ( cATUnicodeEncodings.Contains(AEnc ) )
        {
          AItem = new TMenuItem( this );
          AItem->Enabled = true;
          AItem->Caption = CodepageName( AEnc );
          AItem->RadioItem = true;
          AItem->OnClick = EncodingMenuUnItemClick;
          AItem->Tag = int( AEnc == vEncUnicodeBE );
          FMenuCodepagesUn->Items->Add( AItem );
        }
    }

    //Show menu
    /*# with FMenuCodepagesUn do */
    {
      for ( int stop = FMenuCodepagesUn->Items->Count - 1, i = 0; i <= stop; i++)
        FMenuCodepagesUn->Items->Items[i]->Checked = FileUnicodeFormat == cUnicodeFormatList[((bool) FMenuCodepagesUn->Items->Items[i]->Tag )];
      FMenuCodepagesUn->Popup( AX, AY );
    }
  }
  else
  //2) 1-byte encodings menu (ANSI, OEM...)
  {
    //Create menu
    if ( !( FMenuCodepages != NULL ) )
    {
      FMenuCodepages = new TPopupMenu( this );
      FMenuCodepages->Alignment = paCenter;
      for ( int stop = /*# High(TATEncoding) */ 75, AEnc = /*# Low(TATEncoding) */ 0; AEnc <= stop; Inc( AEnc ) )
        if ( ! ( cATUnicodeEncodings.Contains(AEnc ) ) )
        {
          ANewFamily = ( AEnc > /*# Low(TATEncoding) */ 0 ) && ( cATEncodings[AEnc].Family != cATEncodings[Pred( AEnc )].Family );
          ANewRow = ( cATEncodingNewRow.Contains(cATEncodings[AEnc].Family ) );
          if ( ANewFamily && ! ANewRow )
          {
            AItem = new TMenuItem( this );
            AItem->Caption = "-";
            FMenuCodepages->Items->Add( AItem );
          }
          AItem = new TMenuItem( this );
          AItem->Enabled = IsCodepageSupported( AEnc );
          AItem->Caption = CodepageName( AEnc );
          AItem->RadioItem = true;
          AItem->OnClick = EncodingMenuItemClick;
          AItem->Tag = int( AEnc );
          if ( ANewFamily && ANewRow )
			AItem->Break = mbBarBreak;
          FMenuCodepages->Items->Add( AItem );
        }
    }

    //Show menu
    /*# with FMenuCodepages do */
    {
      for ( int stop = FMenuCodepages->Items->Count - 1, i = 0; i <= stop; i++)
        FMenuCodepages->Items->Items[i]->Checked = FMenuCodepages->Items->Items[i]->Tag == int( FEncoding );
      FMenuCodepages->Popup( AX, AY );
    }
  }
  Application->ProcessMessages();
}


void __fastcall TATBinHex::SetFileUnicodeFmt( TATUnicodeFormat AValue )
{
  FFileUnicodeFmt = AValue;
  if ( IsModeUnicode() )
    Redraw();
}


void __fastcall TATBinHex::EncodingMenuItemClick( TObject* Sender )
{
  if ( dynamic_cast< TMenuItem* >( Sender ) )
  {
    SetTextEncoding( ((TATEncoding) ( ( TMenuItem* ) Sender )->Tag ) );
    DoOptionsChange();
  }
}


void __fastcall TATBinHex::EncodingMenuUnItemClick( TObject* Sender )
{
  if ( dynamic_cast< TMenuItem* >( Sender ) )
  {
    SetFileUnicodeFmt( cUnicodeFormatList[((bool) ( ( TMenuItem* ) Sender )->Tag )] );
    DoOptionsChange();
  }
}


AnsiString __fastcall TATBinHex::GetTextEncodingName( )
{
  AnsiString result;
  if ( IsModeUnicode() )
  {
    if ( FileUnicodeFormat == vbUnicodeFmtLE )
      result = CodepageName( vEncUnicodeLE );
    else
      result = CodepageName( vEncUnicodeBE );
  }
  else
    result = CodepageName( FEncoding );
  return result;
}


void __fastcall TATBinHex::Reload( )
{
  Assert( SourceAssigned(), "Source not assigned: Reload" );
  SetMode( FMode );
}


void __fastcall TATBinHex::SetTextOemSpecial( bool AValue )
{
  if ( FTextOemSpecial != AValue )
  {
    FTextOemSpecial = AValue;
    Redraw();
  }
}


void __fastcall TATBinHex::SetTextUrlHilight( bool AValue )
{
  if ( FUrlShow != AValue )
  {
    FUrlShow = AValue;
    Redraw();
  }
}


void __fastcall TATBinHex::SetTextNonPrintable( bool AValue )
{
  if ( FTextNonPrintable != AValue )
  {
    FTextNonPrintable = AValue;
    Redraw();
  }
}

//Determine, is ALine, found at position APos, ended with CR/LF



bool __fastcall TATBinHex::LineWithCR( const __int64 APos, const WideString ALine )
{
  bool result = false;
  __int64 P = 0;
  P = APos + ALine.Length( ) * CharSize();
  result = ( ! PosBad( P ) ) && SCharCR( GetChar( P ) );
  return result;
}

//Determine, is position APos starts a new line



bool __fastcall TATBinHex::LineWithGutterDot( const __int64 APos )
{
  bool result = false;
  __int64 P = 0;
  P = APos - CharSize();
  result = PosBad( P ) || SCharCR( GetChar( P ) );
  return result;
}


void __fastcall TATBinHex::SetTextPopupCaption( TATPopupCommand AIndex, const AnsiString AValue )
{
  switch ( AIndex )
  {
    case vpCmdCopy:
      FMenuItemCopy->Caption = AValue;
    break;
    case vpCmdCopyHex:
      FMenuItemCopyHex->Caption = AValue;
    break;
    case vpCmdCopyLink:
      FMenuItemCopyLink->Caption = AValue;
    break;
    case vpCmdSelectLine:
      FMenuItemSelectLine->Caption = AValue;
    break;
    case vpCmdSelectAll:
      FMenuItemSelectAll->Caption = AValue;
    break;
    case vpCmdEncMenu:
      FMenuItemEncMenu->Caption = AValue;
    break;
  }
}


int __fastcall TATBinHex::DrawOffsetX( )
{
  int result = 0;
  result = cDrawOffsetMinX;
  if ( FTextGutter )
    result += FTextGutterWidth;
  return result;
}


int __fastcall TATBinHex::DrawOffsetY( )
{
  int result = 0;
  result = cDrawOffsetMinY;
  return result;
}


void __fastcall TATBinHex::SetTextGutter( bool AValue )
{
  if ( FTextGutter != AValue )
  {
    FTextGutter = AValue;
  }
}


//--------------------------------------
//Printing code is in separate file:
 
/*
ATBinHex printing code.
File must be included in ATBinHex.pas.
*/


AnsiString __fastcall TATBinHex::PrinterCaption( )
{
  AnsiString result;
  if ( !FFileName.IsEmpty())
    result = MsgViewerCaption + " - " + SExtractFileName( FFileName );
  else
    result = MsgViewerCaption;
  return result;
}


WideString __fastcall TATBinHex::PrinterFooter( int APageNumber )
{
  WideString result;
  if ( !FFileName.IsEmpty())
    result = SExtractFileName( FFileName ) + L" - " + IntToStr( APageNumber );
  else
    result = IntToStr( APageNumber );
  return result;
}


int __fastcall PrinterPageWidth( )
{
  int result = 0;
  result = Trunc( double( Printer()->PageWidth ) / ( double( GetDeviceCaps( Printer()->Handle, LOGPIXELSX ) ) / Screen->PixelsPerInch ) );
  return result;
}


int __fastcall PrinterPageHeight( )
{
  int result = 0;
  result = Trunc( double( Printer()->PageHeight ) / ( double( GetDeviceCaps( Printer()->Handle, LOGPIXELSY ) ) / Screen->PixelsPerInch ) );
  return result;
}


TRect __fastcall TATBinHex::MarginsRectPx( int ATargetWidth, int ATargetHeight, int ATargetPPIX, int ATargetPPIY )
{
  TRect result;
  const double cUnitIn = 2.54 * 10;
  result = Rect( Trunc( double( FMarginLeft ) / cUnitIn * ATargetPPIX ), Trunc( double( FMarginTop ) / cUnitIn * ATargetPPIY ), ATargetWidth - Trunc( double( FMarginRight ) / cUnitIn * ATargetPPIX ), ATargetHeight - Trunc( double( FMarginBottom ) / cUnitIn * ATargetPPIY ) );
  return result;
}


TRect __fastcall TATBinHex::MarginsRectRealPx( )
{
  TRect result;
  result = MarginsRectPx( Printer()->PageWidth, Printer()->PageHeight, GetDeviceCaps( Printer()->Handle, LOGPIXELSX ), GetDeviceCaps( Printer()->Handle, LOGPIXELSY ) );
  return result;
}


/*
//Old printing procedure: prints the same in Text/Binary/Hex modes
//and doesn't support Unicode modes at all.
procedure TATBinHex.PrintOld;
const
  BlockSize = 64 * 1024;
var
  Buffer: array[0 .. BlockSize - 1] of AnsiChar;
  PosStart, PosEnd: Int64;
  BytesRead: DWORD;
  SBuffer: AnsiString;
  LenAll, Len: Int64;
  f: TextFile;
begin
  Printer.Canvas.Font := Self.Font;
    //Not ActiveFont! We always use ANSI font here, because Windows
    //doesn't allow to print by OEM fonts in most cases
    //(it substitutes other font instead of a given one).

  if ACopies > 0 then
    Printer.Copies := ACopies
  else
    Printer.Copies := 1;

  if ACaption <> '' then
    Printer.Title := ACaption
  else
    Printer.Title := PrinterCaption;

  if ASelectionOnly then
  begin
    PosStart := FSelStart;
    PosEnd := FSelStart + FSelLength - 1;
  end
  else
  begin
    PosStart := 0;
    PosEnd := PosLast;
  end;

  try
    AssignPrn(f);
    Rewrite(f);
    try
      repeat
        if not ReadSource(PosStart, @Buffer, BlockSize, BytesRead) then
        begin
          MsgReadError;
          Exit
        end;

        LenAll := PosEnd - PosStart + 1;
        Len := LenAll;
        I64LimitMax(Len, BytesRead);
        SetString(SBuffer, Buffer, Len);

        //OEM decoding:
        if FEncoding = vencOEM then
          SBuffer := ToANSI(SBuffer);

        Write(f, SBuffer);

        Inc(PosStart, BlockSize);
      until (BytesRead < BlockSize) or (LenAll <= BytesRead);
    finally
      CloseFile(f);
    end;
  except
  end;
end;
*/


const int cFooterColor = clWhite;


void __fastcall TATBinHex::DrawFooter( TCanvas* ACanvas, const TRect& ARect, int& APageWidth, int& APageHeight, TPrintRange& APrintRange, int& AFromPage, int& AToPage, int& APageNumber )
{
  WideString AText;
  int ALeft = 0;
  AText = PrinterFooter( APageNumber );
  ACanvas->Brush->Color = cFooterColor;
  ACanvas->FillRect( ARect );
  ACanvas->Font->Assign( FontFooter );
  ALeft = ( ARect.Right + ARect.Left - STextWidth( ACanvas, AText ) ) / 2;
  ILimitMin( ALeft, ARect.Left );
  STextOut( ACanvas, ALeft, ARect.Top, AText );
}


void __fastcall TATBinHex::DrawRect( TCanvas* ACanvas, const TRect& ARect, int& APageWidth, int& APageHeight, TPrintRange& APrintRange, int& AFromPage, int& AToPage, int& APageNumber )
{
  ACanvas->Brush->Style = bsClear;
  ACanvas->Pen->Color = clBlack;
  ACanvas->Pen->Style = psDash;
  ACanvas->Rectangle( ARect );
}


int __fastcall TATBinHex::FooterHeightSrc( TCanvas*& ACanvas, int& APageWidth, int& APageHeight, TPrintRange& APrintRange, int& AFromPage, int& AToPage, int& APageNumber )
{
  int result = 0;
  TCanvas* C = NULL;
  C = new TCanvas;
  try
  {
    C->Handle = this->Handle;
    C->Font->Assign( FontFooter );
    result = Trunc( FontHeight( C ) * 1.2 );
  }
  __finally
  {
    delete C;
  }
  return result;
}


void __fastcall TATBinHex::PrintTo( TCanvas* ACanvas, //ACanvas may be assigned only for Print Preview
int APageWidth, int APageHeight, TPrintRange APrintRange, int AFromPage, int AToPage )
{
  int APageNumber
  //
  = 0;
  //

  //

  //

  __int64 APosStart = 0, APosEnd = 0, APosOld = 0, ASelStartOld = 0, ASelLengthOld = 0;
  __int64 AViewPageSize = 0;
  bool AViewAtEnd = false;
  Graphics::TBitmap* ABitmap = NULL,* ABitmapOld = NULL;
  bool ATextWrapOld = false, ATextNonPrintOld = false, ATextGutterOld = false;
  TRect AMarginsRect;
  int ADrawWidth = 0, ADrawHeight = 0, AFooterHeightSrc = 0, AFooterHeightReal = 0;
  bool APrintPreview = false, APrintThisPage = false;
  if ( APrintRange == prSelection )
  {
    APosStart = FSelStart;
    APosEnd = FSelStart + FSelLength - CharSize();
  }
  else
  {
    APosStart = 0;
    APosEnd = PosLast();
  }

  //Calc margins
  AMarginsRect = MarginsRectPx( APageWidth, APageHeight, Screen->PixelsPerInch, Screen->PixelsPerInch );
  ADrawWidth = AMarginsRect.Right - AMarginsRect.Left;
  ADrawHeight = AMarginsRect.Bottom - AMarginsRect.Top;
  AFooterHeightSrc = FooterHeightSrc(ACanvas, APageWidth, APageHeight, APrintRange, AFromPage, AToPage, APageNumber);
  ADrawHeight -= AFooterHeightSrc;

  //Initialize
  Enabled2 = false; //During printing even redraw is not allowed
                     //(it will break some properties)
  ABitmap = new Graphics::TBitmap;
  ABitmap->PixelFormat = pf24bit;
  APageNumber = 1;

  //Prepare for printing:
  // - scroll to block start
  // - clear selection
  // - set WordWrap = True
  // - set NonPrintable = False
  // - set Gutter = False
  // - change active bitmap to working one
  APosOld = PosOffset;
  ASelStartOld = SelStart;
  ASelLengthOld = SelLength;
  ATextWrapOld = TextWrap;
  ATextNonPrintOld = TextNonPrintable;
  ATextGutterOld = TextGutter;
  ABitmapOld = FBitmap;
  PosOffset = APosStart;
  SetSelection( 0, 0, false, false, true );
  FTextWrap = true;
  FTextNonPrintable = false;
  FTextGutter = false;
  FBitmap = ABitmap;
  try
  {
    do
    {
      DrawTo( ABitmap, ADrawWidth, ADrawHeight, NULL, true, APosEnd, FTextWidth, FTextWidthHex, FTextWidthUHex, AViewPageSize, AViewAtEnd ); //AStringsObject not needed
 //APrintMode
 //AFinalPos
      APrintPreview =( ACanvas != NULL );
      APrintThisPage = ( APrintRange != prPageNums ) || ( APageNumber >= AFromPage );
      if ( APrintThisPage )
      { //Drawing begin
        if ( APrintPreview )
        {
          ACanvas->Brush->Style = bsSolid;
          ACanvas->Draw( AMarginsRect.Left, AMarginsRect.Top, ABitmap );
          DrawFooter( ACanvas, Rect( AMarginsRect.Left, AMarginsRect.Bottom - AFooterHeightSrc, AMarginsRect.Right, AMarginsRect.Bottom ), APageWidth, APageHeight, APrintRange, AFromPage, AToPage, APageNumber );
          DrawRect( ACanvas, AMarginsRect, APageWidth, APageHeight, APrintRange, AFromPage, AToPage, APageNumber );
          break; //Don't preview other pages
        }
        else
        {
          AMarginsRect = MarginsRectRealPx();
          AFooterHeightReal = Trunc( AFooterHeightSrc * ( double( GetDeviceCaps( Printer()->Handle, LOGPIXELSY ) ) / Screen->PixelsPerInch ) );
          Printer()->Canvas->StretchDraw( Rect( AMarginsRect.Left, AMarginsRect.Top, AMarginsRect.Right, AMarginsRect.Bottom - AFooterHeightReal ), ABitmap );
          DrawFooter( Printer()->Canvas, Rect( AMarginsRect.Left, AMarginsRect.Bottom - AFooterHeightReal, AMarginsRect.Right, AMarginsRect.Bottom ), APageWidth, APageHeight, APrintRange, AFromPage, AToPage, APageNumber );

          //DrawRect(Printer.Canvas, AMarginsRect); //d
        }
      } //Drawing end

      //If EOF reached then stop
      if ( AViewAtEnd )
        break;
      if ( ! FFileOK )
        break;

      //Move page down
      APageNumber++;
      PosLineDown( AViewAtEnd, LinesNum( ABitmap ) );

      //If page is below the selection then stop
      switch ( APrintRange )
      {
        case prPageNums:
          if ( APageNumber > AToPage )
            break;
        break;
      default:
        if ( FViewPos > APosEnd )
          break;
      }

      //Change printer page
      if ( APrintThisPage )
        if ( ! APrintPreview )
          Printer()->NewPage();
    }
    while ( ! ( false ) );
  }
  __finally
  {
    //Restore saved properties
    FBitmap = ABitmapOld;
    FTextWrap = ATextWrapOld;
    FTextNonPrintable = ATextNonPrintOld;
    FTextGutter = ATextGutterOld;
    SetSelection( ASelStartOld, ASelLengthOld, false, false, true );
    PosOffset = APosOld;

    //Finalize
    delete ABitmap;
    Enabled2 = true;
  }
}


void __fastcall TATBinHex::Print( TPrintRange APrintRange, int AFromPage, int AToPage, int ACopies, const AnsiString ACaption )
{
  if ( ACopies > 0 )
    Printer()->Copies = ACopies;
  else
    Printer()->Copies = 1;
  if ( !ACaption.IsEmpty())
    Printer()->Title = ACaption;
  else
    Printer()->Title = PrinterCaption();
  Printer()->BeginDoc();
  PrintTo( NULL, PrinterPageWidth(), PrinterPageHeight(), APrintRange, AFromPage, AToPage );
  Printer()->EndDoc();
}


void __fastcall TATBinHex::PrintPreview( )
{
} 


//--------------------------------------



char __fastcall TATBinHex::AChar( const __int64 APos, int& ABufSize, bool& xResult, char*& Buf, __int64& aoffset )
{
  char result = '\0';
  result = '\x00';
  if ( IsModeUnicode() )
  {
      //We need to get only #13, #10 (when other byte = #0)
      //so we don't need WideChar
    if ( IsUnicodeBE() )
    {
      if ( Buf[APos] == '\x00' )
        result = Buf[APos + 1];
    }
    else
    {
      if ( Buf[APos + 1] == '\x00' )
        result = Buf[APos];
    }
  }
  else
    result = Buf[APos];
  return result;
}


void __fastcall TATBinHex::AInc( int& ABufSize, bool& result, char*& Buf, __int64& aoffset )
{
  aoffset += CharSize();
}


bool __fastcall TATBinHex::CountLines( int ABufSize )
{
  bool result = false;
  char* Buf = NULL;
  __int64 aoffset
  //------------
  = 0;
  //------------

  //------------

  __int64 Pos1 = 0, Pos2 = 0;
  DWORD Read = 0;
  FLinesNum = 0;
  if (( FLinesData != NULL ) )
    FreeMem( FLinesData, -1 );
  GetMem( FLinesData, sizeof( int ) * FLinesCount );
  GetMem( Buf, ABufSize );
  try
  {
    result = ReadSource( 0, Buf, ABufSize, Read );
    if ( result )
    {
      aoffset = 0;
      Pos1 = ((__int64) Read ) - CharSize();
      Pos2 = ((__int64) Read ) - 2 * CharSize();
      NormalizePos( Pos1 );
      NormalizePos( Pos2 );
      do
      {
        while ( ( aoffset < Pos1 ) && ( ! ( ATBinHex__27.Contains(AChar( aoffset, ABufSize, result, Buf, aoffset ) ) ) ) )
          AInc(ABufSize, result, Buf, aoffset); //Go to #13, #10
        if ( ( aoffset < Pos2 ) && ( AChar( aoffset, ABufSize, result, Buf, aoffset ) == '\x0d' ) && ( AChar( aoffset + CharSize(), ABufSize, result, Buf, aoffset ) == '\x0a' ) )
          AInc(ABufSize, result, Buf, aoffset); //Additionally skip #13#10
        AInc(ABufSize, result, Buf, aoffset);

        //Break if EOF
        if ( aoffset > Pos1 )
          break;
        if ( FLinesNum >= Pred( FLinesCount ) )
          break;
        FLinesNum++;
        FLinesData[FLinesNum] = aoffset;
      }
      while ( ! ( false ) );
    }
  }
  __finally
  {
    FreeMem( Buf, -1 );
  }
  return result;
}

//-------------------------------
//Get offset by line number.
//To find current line, call with ALine = 0, AFindLine = True.


bool __fastcall TATBinHex::GetLineNumberOffset( int ALine, bool AFindLine, int& ACurrentLine, __int64& aoffset )
{
  bool result = false;
  int i = 0;
  ACurrentLine = 0;
  aoffset = 0;
  result = FLinesNum > 0;
  if ( result )
    if ( AFindLine )
    {
      for ( int stop = FLinesNum, i = /*# Low( TIntegerArray ) */ 1; i <= stop; i++)
        if ( FLinesData[i] > FViewPos )
        {
          ACurrentLine = i;
          break;
        }
    }
    else
    {
      if ( ALine <= 1 )
        aoffset = 0;
      else
        if ( ALine > FLinesNum )
          aoffset = FLinesData[FLinesNum];
        else
          aoffset = FLinesData[ALine - 1];
    }
  return result;
}


//-------------------------------



void __fastcall TATBinHex::SetPosLine( int ALine )
{
  int ACurLine = 0;
  __int64 aoffset = 0;
  //Count lines always
  CountLines( FLinesBufSize );
  if ( GetLineNumberOffset( ALine, false, ACurLine, aoffset ) )
    SetPosOffset( aoffset );
}


int __fastcall TATBinHex::GetPosLine( )
{
  int result = 0;
  int ACurLine = 0;
  __int64 aoffset = 0;
  //Count lines if they weren't counted
  if ( FLinesNum == 0 )
    CountLines( FLinesBufSize );
  GetLineNumberOffset( 0, true, ACurLine, aoffset );
  result = ACurLine;
  return result;
}

//----------------------------



int __fastcall TATBinHex::FindLineNum( const __int64 aoffset )
{
  int result = 0;
  int i = 0;
  result = 0;
  if ( aoffset == 0 )
    result = 1;
  else
    for ( int stop = FLinesNum, i = /*# Low( TIntegerArray ) */ 1; i <= stop; i++)
      if ( FLinesData[i] == aoffset )
      {
        result = i + 1;
        break;
      }
  return result;
}

//----------------------------



void __fastcall TATBinHex::SetLinesBufSize( int AValue )
{
  FLinesBufSize = AValue;
  ILimitMin( FLinesBufSize, cLinesBufSizeMin );
  ILimitMax( FLinesBufSize, cLinesBufSizeMax );
}


void __fastcall TATBinHex::SetLinesCount( int AValue )
{
  FLinesCount = AValue;
  ILimitMin( FLinesCount, cLinesCountMin );
  ILimitMax( FLinesCount, cLinesCountMax );
}


void __fastcall TATBinHex::SetLinesStep( int AValue )
{
  FLinesStep = AValue;
  ILimitMin( FLinesStep, cLinesStepMin );
  ILimitMax( FLinesStep, cLinesStepMax );
}

//----------------------------



bool __fastcall TATBinHex::ActiveLinesShow( )
{
  bool result = false;
  result = IsModeVariable() && FTextGutter && FLinesShow && ( ( ! FLinesExtUse ) || ( SFileExtensionMatch( FFileName, FLinesExtList ) ) );
  return result;
}


void __fastcall TATBinHex::DoDrawLine( TCanvas* ACanvas, const WideString AStr, const __int64 APos, const TRect& ARect, const TPoint& ATextPnt, bool& ADone )
{
  if (( FOnDrawLine != NULL ) )
    FOnDrawLine( this, ACanvas, SConvertForOut( AStr, OutputOptions( false ) ), StringAtPos( APos ), ARect, ATextPnt, ADone );
}


void __fastcall TATBinHex::DoDrawLine2( TCanvas* ACanvas, const WideString AStr, const TPoint& APnt, const TATBinHexOutputOptions& AOptions )
{
  if (( FOnDrawLine2 != NULL ) )
    FOnDrawLine2( this, ACanvas, SConvertForOut( AStr, OutputOptions( false ) ), APnt, AOptions );
}


void __fastcall TATBinHex::DoClickURL( const __int64 AMousePos )
{
  AnsiString S;
  if (( FOnClickURL != NULL ) )
  {
    S = PosURL( AMousePos );
    if ( !S.IsEmpty())
    {
      if ( ! ( ( S.Pos( "://" ) > 0 ) || ( S.Pos( "www." ) == 1 ) ) )
        S = String( "mailto:" ) + S;
      FOnClickURL( this, S );
    }
  }
}


void __fastcall TATBinHex::InitURLs( )
{
  int i = 0;
  for ( int stop = /*# High( FUrlArray ) */ 500, i = /*# Low( FUrlArray ) */ 1; i <= stop; i++)
    /*# with FUrlArray[i] do */
    {
      ATBinHex__0& with0 = FUrlArray[i - 1];
      {
        with0.FString = "";
        with0.FPos = 0;
      }
    }
}


void __fastcall TATBinHex::FindURLs( DWORD ABufSize )
{
}


AnsiString __fastcall TATBinHex::PosURL( const __int64 APos )
{
  AnsiString result;
  int i = 0;
  result = "";
  if ( APos >= 0 )
    for ( int stop = /*# High( FUrlArray ) */ 500, i = /*# Low( FUrlArray ) */ 1; i <= stop; i++)
      /*# with FUrlArray[i] do */
      {
        ATBinHex__0& with0 = FUrlArray[i - 1];
        {
          if ( with0.FString.IsEmpty())
            break;
          if ( ( APos >= with0.FPos ) && ( APos < with0.FPos + with0.FString.Length( ) * CharSize() ) )
          {
            result = with0.FString;
            break;
          }
        }
      }
  return result;
}


bool __fastcall TATBinHex::IsPosURL( const __int64 APos )
{
  bool result = false;
  result = !PosURL( APos ).IsEmpty();
  return result;
}


/* Registration */


void __fastcall Register( )
{
  TComponentClass classes[ 2 ] = { __classid( TATBinHex) };
  RegisterComponents( "Samples" , classes,  1 );
}

/* Initialization */

void ATBinHex_initialization()
{
  FBitmapNiceScroll = new Graphics::TBitmap;
  /*# with FBitmapNiceScroll do */
  {
	FBitmapNiceScroll->LoadFromResourceName( (unsigned int) HInstance, "AB_MOVE" );
    FBitmapNiceScroll->Transparent = true;
  }
  /*# with Screen do */
  {
    Screen->Cursors[crNiceScrollNone] = LoadCursor( HInstance, "AB_MOVE" );
    Screen->Cursors[crNiceScrollUp] = LoadCursor( HInstance, "AB_MOVE_U" );
    Screen->Cursors[crNiceScrollDown] = LoadCursor( HInstance, "AB_MOVE_D" );
    Screen->Cursors[crNiceScrollLeft] = LoadCursor( HInstance, "AB_MOVE_L" );
    Screen->Cursors[crNiceScrollRight] = LoadCursor( HInstance, "AB_MOVE_R" );
  }
}

void ATBinHex_finalization()
{
  delete FBitmapNiceScroll;
  FBitmapNiceScroll = NULL;
}

class ATBinHex_unit
{
public:
ATBinHex_unit()
{
  ATBinHex_initialization();
  cUnicodeFormatListInit();
}
~ATBinHex_unit(){ ATBinHex_finalization(); }
};
ATBinHex_unit _ATBinHex_unit;
