
#include <vcl.h>
#pragma hdrstop

#include "ATxCodepages.h"



#include <sysutils.hpp>



#include "d2c_system.h"


System::Set < TATEncodingFamily, EncFamSystem, EncFamUnicode > cATEncodingNewRow = ATxCodepages__0;
void cATEncodingFamilyNamesInit( )
{
  cATEncodingFamilyNames[0] = "";
  cATEncodingFamilyNames[1] = "Western European";
  cATEncodingFamilyNames[2] = "Central European";
  cATEncodingFamilyNames[3] = "Baltic";
  cATEncodingFamilyNames[4] = "Cyrillic";
  cATEncodingFamilyNames[5] = "United States";
  cATEncodingFamilyNames[6] = "Greek";
  cATEncodingFamilyNames[7] = "Latin 3";
  cATEncodingFamilyNames[8] = "Turkish";
  cATEncodingFamilyNames[9] = "Arabic";
  cATEncodingFamilyNames[10] = "Hebrew";
  cATEncodingFamilyNames[11] = "Thai";
  cATEncodingFamilyNames[12] = "Vietnamese";
  cATEncodingFamilyNames[13] = "IBM EBCDIC";
  cATEncodingFamilyNames[14] = "Unicode";
  cATEncodingFamilyNames[15] = "Unicode";
}
AnsiString cATEncodingFamilyNames[ 16 /*# TATEncodingFamily */ ];;
System::Set < TATEncoding, vEncANSI, vEncUnicodeBE > cATUnicodeEncodings = ( System::Set < TATEncoding, vEncANSI, vEncUnicodeBE >()
                     << TATEncoding ( 74 ) << TATEncoding ( 75 ) );
TATEncodingRec cATEncodings [ 76 /*# TATEncoding */ ];
void cATEncodingsInit( )
{
  cATEncodings[0].id = - 1;
  cATEncodings[0].Family = EncFamSystem;
  cATEncodings[0].Name = "ANSI (Windows)";
  cATEncodings[1].id = CP_OEMCP;
  cATEncodings[1].Family = EncFamSystem;
  cATEncodings[1].Name = "OEM (DOS)";
  cATEncodings[2].id = - 1;
  cATEncodings[2].Family = EncFamSystem;
  cATEncodings[2].Name = "EBCDIC";
  cATEncodings[3].id = - 1;
  cATEncodings[3].Family = EncFamSystem;
  cATEncodings[3].Name = "KOI8";
  cATEncodings[4].id = - 1;
  cATEncodings[4].Family = EncFamSystem;
  cATEncodings[4].Name = "ISO";
  cATEncodings[5].id = CP_MACCP;
  cATEncodings[5].Family = EncFamSystem;
  cATEncodings[5].Name = "Mac";
  cATEncodings[6].id = 850;
  cATEncodings[6].Family = EncFamWEuropean;
  cATEncodings[6].Name = "IBM-850";
  cATEncodings[7].id = 28591;
  cATEncodings[7].Family = EncFamWEuropean;
  cATEncodings[7].Name = "ISO 8859-1";
  cATEncodings[8].id = 28605;
  cATEncodings[8].Family = EncFamWEuropean;
  cATEncodings[8].Name = "ISO 8859-15";
  cATEncodings[9].id = 10000;
  cATEncodings[9].Family = EncFamWEuropean;
  cATEncodings[9].Name = "MacRoman";
  cATEncodings[10].id = 1252;
  cATEncodings[10].Family = EncFamWEuropean;
  cATEncodings[10].Name = "Windows-1252";
  cATEncodings[11].id = 852;
  cATEncodings[11].Family = EncFamCEuropean;
  cATEncodings[11].Name = "IBM-852";
  cATEncodings[12].id = 28592;
  cATEncodings[12].Family = EncFamCEuropean;
  cATEncodings[12].Name = "ISO 8859-2";
  cATEncodings[13].id = 10029;
  cATEncodings[13].Family = EncFamCEuropean;
  cATEncodings[13].Name = "MacCE";
  cATEncodings[14].id = 1250;
  cATEncodings[14].Family = EncFamCEuropean;
  cATEncodings[14].Name = "Windows-1250";
  cATEncodings[15].id = 775;
  cATEncodings[15].Family = EncFamBaltic;
  cATEncodings[15].Name = "IBM-775";
  cATEncodings[16].id = 28594;
  cATEncodings[16].Family = EncFamBaltic;
  cATEncodings[16].Name = "ISO 8859-4";
  cATEncodings[17].id = 28603;
  cATEncodings[17].Family = EncFamBaltic;
  cATEncodings[17].Name = "ISO 8859-13";
  cATEncodings[18].id = 1257;
  cATEncodings[18].Family = EncFamBaltic;
  cATEncodings[18].Name = "Windows-1257";
  cATEncodings[19].id = 866;
  cATEncodings[19].Family = EncFamCyrillic;
  cATEncodings[19].Name = "IBM-866";
  cATEncodings[20].id = 28595;
  cATEncodings[20].Family = EncFamCyrillic;
  cATEncodings[20].Name = "ISO 8859-5";
  cATEncodings[21].id = 20866;
  cATEncodings[21].Family = EncFamCyrillic;
  cATEncodings[21].Name = "KOI8-R";
  cATEncodings[22].id = 21866;
  cATEncodings[22].Family = EncFamCyrillic;
  cATEncodings[22].Name = "KOI8-U";
  cATEncodings[23].id = 10007;
  cATEncodings[23].Family = EncFamCyrillic;
  cATEncodings[23].Name = "MacCyrillic";
  cATEncodings[24].id = 10017;
  cATEncodings[24].Family = EncFamCyrillic;
  cATEncodings[24].Name = "MacUkrainian";
  cATEncodings[25].id = 1251;
  cATEncodings[25].Family = EncFamCyrillic;
  cATEncodings[25].Name = "Windows-1251";
  cATEncodings[26].id = 437;
  cATEncodings[26].Family = EncFamUS;
  cATEncodings[26].Name = "US OEM";
  cATEncodings[27].id = 737;
  cATEncodings[27].Family = EncFamGreek;
  cATEncodings[27].Name = "IBM-737";
  cATEncodings[28].id = 28597;
  cATEncodings[28].Family = EncFamGreek;
  cATEncodings[28].Name = "ISO 8859-7";
  cATEncodings[29].id = 10006;
  cATEncodings[29].Family = EncFamGreek;
  cATEncodings[29].Name = "MacGreek";
  cATEncodings[30].id = 1253;
  cATEncodings[30].Family = EncFamGreek;
  cATEncodings[30].Name = "Windows-1253";
  cATEncodings[31].id = 28593;
  cATEncodings[31].Family = EncFamLatin3;
  cATEncodings[31].Name = "ISO 8859-3";
  cATEncodings[32].id = 857;
  cATEncodings[32].Family = EncFamTurkish;
  cATEncodings[32].Name = "IBM-857";
  cATEncodings[33].id = 28599;
  cATEncodings[33].Family = EncFamTurkish;
  cATEncodings[33].Name = "ISO 8859-9";
  cATEncodings[34].id = 10081;
  cATEncodings[34].Family = EncFamTurkish;
  cATEncodings[34].Name = "MacTurkish";
  cATEncodings[35].id = 1254;
  cATEncodings[35].Family = EncFamTurkish;
  cATEncodings[35].Name = "Windows-1254";
  cATEncodings[36].id = 708;
  cATEncodings[36].Family = EncFamArabic;
  cATEncodings[36].Name = "ASMO-708";
  cATEncodings[37].id = 720;
  cATEncodings[37].Family = EncFamArabic;
  cATEncodings[37].Name = "DOS-720";
  cATEncodings[38].id = 864;
  cATEncodings[38].Family = EncFamArabic;
  cATEncodings[38].Name = "IBM-864";
  cATEncodings[39].id = 28596;
  cATEncodings[39].Family = EncFamArabic;
  cATEncodings[39].Name = "ISO 8859-6";
  cATEncodings[40].id = 10004;
  cATEncodings[40].Family = EncFamArabic;
  cATEncodings[40].Name = "MacArabic";
  cATEncodings[41].id = 1256;
  cATEncodings[41].Family = EncFamArabic;
  cATEncodings[41].Name = "Windows-1256";
  cATEncodings[42].id = 862;
  cATEncodings[42].Family = EncFamHebrew;
  cATEncodings[42].Name = "IBM-862";
  cATEncodings[43].id = 38598;
  cATEncodings[43].Family = EncFamHebrew;
  cATEncodings[43].Name = "ISO 8859-8, ISO-Logical";
  cATEncodings[44].id = 28598;
  cATEncodings[44].Family = EncFamHebrew;
  cATEncodings[44].Name = "ISO 8859-8, ISO-Visual";
  cATEncodings[45].id = 10005;
  cATEncodings[45].Family = EncFamHebrew;
  cATEncodings[45].Name = "MacHebrew";
  cATEncodings[46].id = 1255;
  cATEncodings[46].Family = EncFamHebrew;
  cATEncodings[46].Name = "Windows-1255";
  cATEncodings[47].id = 874;
  cATEncodings[47].Family = EncFamThai;
  cATEncodings[47].Name = "Windows-874";
  cATEncodings[48].id = 1258;
  cATEncodings[48].Family = EncFamVietnam;
  cATEncodings[48].Name = "Windows-1258";
  cATEncodings[49].id = 37;
  cATEncodings[49].Family = EncFamEBCDIC;
  cATEncodings[49].Name = "US-Canada";
  cATEncodings[50].id = 500;
  cATEncodings[50].Family = EncFamEBCDIC;
  cATEncodings[50].Name = "International";
  cATEncodings[51].id = 1047;
  cATEncodings[51].Family = EncFamEBCDIC;
  cATEncodings[51].Name = "Latin 1/Open System";
  cATEncodings[52].id = 870;
  cATEncodings[52].Family = EncFamEBCDIC;
  cATEncodings[52].Name = "Multilingual Latin 2";
  cATEncodings[53].id = 20423;
  cATEncodings[53].Family = EncFamEBCDIC;
  cATEncodings[53].Name = "Greek";
  cATEncodings[54].id = 875;
  cATEncodings[54].Family = EncFamEBCDIC;
  cATEncodings[54].Name = "Greek Modern";
  cATEncodings[55].id = 20273;
  cATEncodings[55].Family = EncFamEBCDIC;
  cATEncodings[55].Name = "Germany";
  cATEncodings[56].id = 20277;
  cATEncodings[56].Family = EncFamEBCDIC;
  cATEncodings[56].Name = "Denmark-Norway";
  cATEncodings[57].id = 20278;
  cATEncodings[57].Family = EncFamEBCDIC;
  cATEncodings[57].Name = "Finland-Sweden";
  cATEncodings[58].id = 20285;
  cATEncodings[58].Family = EncFamEBCDIC;
  cATEncodings[58].Name = "United Kingdom";
  cATEncodings[59].id = 20297;
  cATEncodings[59].Family = EncFamEBCDIC;
  cATEncodings[59].Name = "France";
  cATEncodings[60].id = 20871;
  cATEncodings[60].Family = EncFamEBCDIC;
  cATEncodings[60].Name = "Icelandic";
  cATEncodings[61].id = 20880;
  cATEncodings[61].Family = EncFamEBCDIC;
  cATEncodings[61].Name = "Cyrillic Russian";
  cATEncodings[62].id = 21025;
  cATEncodings[62].Family = EncFamEBCDIC;
  cATEncodings[62].Name = "Cyrillic Serbian-Bulgarian";
  cATEncodings[63].id = 20280;
  cATEncodings[63].Family = EncFamEBCDIC;
  cATEncodings[63].Name = "Italy";
  cATEncodings[64].id = 20284;
  cATEncodings[64].Family = EncFamEBCDIC;
  cATEncodings[64].Name = "Latin America-Spain";
  cATEncodings[65].id = 20290;
  cATEncodings[65].Family = EncFamEBCDIC;
  cATEncodings[65].Name = "Japanese Katakana Extended";
  cATEncodings[66].id = 20833;
  cATEncodings[66].Family = EncFamEBCDIC;
  cATEncodings[66].Name = "Korean Extended";
  cATEncodings[67].id = 20420;
  cATEncodings[67].Family = EncFamEBCDIC;
  cATEncodings[67].Name = "Arabic";
  cATEncodings[68].id = 20424;
  cATEncodings[68].Family = EncFamEBCDIC;
  cATEncodings[68].Name = "Hebrew";
  cATEncodings[69].id = 20838;
  cATEncodings[69].Family = EncFamEBCDIC;
  cATEncodings[69].Name = "Thai";
  cATEncodings[70].id = 20905;
  cATEncodings[70].Family = EncFamEBCDIC;
  cATEncodings[70].Name = "Turkish";
  cATEncodings[71].id = 1026;
  cATEncodings[71].Family = EncFamEBCDIC;
  cATEncodings[71].Name = "Turkish (Latin 5)";
  cATEncodings[72].id = 65000;
  cATEncodings[72].Family = EncFamUTF;
  cATEncodings[72].Name = "UTF-7";
  cATEncodings[73].id = 65001;
  cATEncodings[73].Family = EncFamUTF;
  cATEncodings[73].Name = "UTF-8";
  cATEncodings[74].id = - 1;
  cATEncodings[74].Family = EncFamUnicode;
  cATEncodings[74].Name = "UTF-16 LE";
  cATEncodings[75].id = - 1;
  cATEncodings[75].Family = EncFamUnicode;
  cATEncodings[75].Name = "UTF-16 BE";
}



bool CodepagesSupported[ 76 /*# TATEncoding */ ];

//-------------------------------------------------



int __fastcall CodepageID( TATEncoding Enc )
{
  int result = 0;
  result = cATEncodings[Enc].id;
  Assert( result >= 0, "Invalid codepage specified: CodepageID" );
  return result;
}

//-------------------------------------------------



AnsiString __fastcall CodepageName( TATEncoding Enc )
{
  AnsiString result;
  /*# with cATEncodings[Enc] do */
  {
    TATEncodingRec& with0 = cATEncodings[Enc];
    if ( with0.Family == EncFamSystem )
      result = with0.Name;
    else
      result = cATEncodingFamilyNames[with0.Family] + " (" + with0.Name + ")";
  }
  return result;
}

//-------------------------------------------------



int __stdcall EnumCodePagesProc( char* S )
{
  int result = 0;
  int id = 0;
  TATEncoding Enc;
  result = 1;
  id = StrToIntDef( S, 0 );
  for ( int stop = /*# High(TATEncoding) */ 75, Enc = /*# Low(TATEncoding) */ 0; Enc <= stop; Inc( Enc ) )
    if ( cATEncodings[Enc].id == id )
    {
      CodepagesSupported[Enc] = true;
      break;
    }
  return result;
}


void __fastcall InitCodepagesSupported( )
{
  FillChar( CodepagesSupported, sizeof( CodepagesSupported ), 0 );
  EnumSystemCodePagesA( (CODEPAGE_ENUMPROCA) EnumCodePagesProc, CP_INSTALLED );
  CodepagesSupported[vEncANSI] = true;
  CodepagesSupported[vEncOEM] = true;
  CodepagesSupported[vEncEBCDIC] = true;
  CodepagesSupported[vEncKOI8] = true;
  CodepagesSupported[vEncISO] = true;
  CodepagesSupported[vEncMac] = true;
}

//-------------------------------------------------



bool __fastcall IsCodepageSupported( TATEncoding Enc )
{
  bool result = false;
  result = CodepagesSupported[Enc];
  return result;
}

//-------------------------------------------------



bool __fastcall IsCodepageID1Byte( int id )
{
  bool result = false;
  TCPInfo info;
  result = true;
  if ( GetCPInfo( id, &info ) )
    result = info.MaxCharSize == 1;
  return result;
}

//-------------------------------------------------



WideString __fastcall SCodepageToUnicodeAPI( const AnsiString S, TATEncoding Enc )
{
  WideString result;
  WideString ws;
  int n = 0;
  int id = 0;
  result = L"?";
  if ( IsCodepageSupported( Enc ) )
    switch ( Enc )
    {
      case vEncANSI:
      {
        result = S;
      }
      break;
    default:
    {
      ws.Empty();
      id = CodepageID( Enc );
      n = MultiByteToWideChar( id, 0, S.c_str(), S.Length( ), NULL, 0 );
      if ( n == 0 )
        return result;
      ws.SetLength( n );
      n = MultiByteToWideChar( id, 0, S.c_str(), S.Length( ), ((PWChar) ws.c_bstr()), ws.Length( ) );
      if ( n == 0 )
        return result;
      result = ws;
    }
    }
  return result;
}

//-------------------------------------------------



AnsiString __fastcall SUnicodeToCodepage( const WideString ws, TATEncoding Enc )
{
  AnsiString result;
  AnsiString RS;
  int n = 0;
  int id = 0;
  result = "?";
  if ( IsCodepageSupported( Enc ) )
    switch ( Enc )
    {
      case vEncANSI:
      {
        result = ws;
      }
      break;
    default:
    {
      RS = "";
      id = CodepageID( Enc );
      n = WideCharToMultiByte( id, 0, ((PWChar) ws.c_bstr()), ws.Length( ), NULL, 0, NULL, NULL );
      if ( n == 0 )
        return result;
      RS.SetLength( n );
      n = WideCharToMultiByte( id, 0, ((PWChar) ws.c_bstr()), ws.Length( ), RS.c_str(), RS.Length( ), NULL, NULL );
      if ( n == 0 )
        return result;
      result = RS;
    }
    }
  return result;
}

//-------------------------------------------------



AnsiString __fastcall SConvertOEMToANSI( const AnsiString S )
{
  AnsiString result;
  result.SetLength( S.Length( ) );
  OemToCharBuffA( S.c_str(), result.c_str(), S.Length( ) );
  return result;
}

//--------------------------------------------------




typedef char TCodepageMap128 [ 128/*# range 0..127*/ ];
typedef char TCodepageMap256 [ 256/*# range 0..255*/ ];


AnsiString __fastcall SConvertByMap128( const AnsiString S, const TCodepageMap128& Map )
{
  AnsiString result;
  int i = 0;
  result = S;
  for ( int stop = S.Length( ), i = 1; i <= stop; i++)
    if ( int( S[i] ) >= 128 )
      result[i] = Map[int( S[i] ) - 128];
  return result;
}


AnsiString __fastcall SConvertByMap256( const AnsiString S, const TCodepageMap256& Map )
{
  AnsiString result;
  int i = 0;
  result = S;
  for ( int stop = S.Length( ), i = 1; i <= stop; i++)
    result[i] = Map[int( S[i] )];
  return result;
}
  //Cyrillic (KOI8-R) --> Cyrillic (Windows-1251)



TCodepageMap128 cMapKOI8ToANSI;
void cMapKOI8ToANSIInit( )
{
  cMapKOI8ToANSI[0] = '\x2d';
  cMapKOI8ToANSI[1] = '\xa6';
  cMapKOI8ToANSI[2] = '\x2d';
  cMapKOI8ToANSI[3] = '\xac';
  cMapKOI8ToANSI[4] = '\x4c';
  cMapKOI8ToANSI[5] = '\x2d';
  cMapKOI8ToANSI[6] = '\x2b';
  cMapKOI8ToANSI[7] = '\x2b';
  cMapKOI8ToANSI[8] = '\x54';
  cMapKOI8ToANSI[9] = '\x2b';
  cMapKOI8ToANSI[10] = '\x2b';
  cMapKOI8ToANSI[11] = '\x2d';
  cMapKOI8ToANSI[12] = '\x2d';
  cMapKOI8ToANSI[13] = '\x2d';
  cMapKOI8ToANSI[14] = '\xa6';
  cMapKOI8ToANSI[15] = '\xa6';
  cMapKOI8ToANSI[16] = '\x2d';
  cMapKOI8ToANSI[17] = '\x2d';
  cMapKOI8ToANSI[18] = '\x2d';
  cMapKOI8ToANSI[19] = '\x3f';
  cMapKOI8ToANSI[20] = '\xa6';
  cMapKOI8ToANSI[21] = '\x95';
  cMapKOI8ToANSI[22] = '\x76';
  cMapKOI8ToANSI[23] = '\x3f';
  cMapKOI8ToANSI[24] = '\x3f';
  cMapKOI8ToANSI[25] = '\x3f';
  cMapKOI8ToANSI[26] = '\xa0';
  cMapKOI8ToANSI[27] = '\x3f';
  cMapKOI8ToANSI[28] = '\xb0';
  cMapKOI8ToANSI[29] = '\x3f';
  cMapKOI8ToANSI[30] = '\xb7';
  cMapKOI8ToANSI[31] = '\x3f';
  cMapKOI8ToANSI[32] = '\x3d';
  cMapKOI8ToANSI[33] = '\xa6';
  cMapKOI8ToANSI[34] = '\x2d';
  cMapKOI8ToANSI[35] = '\xb8';
  cMapKOI8ToANSI[36] = '\xe3';
  cMapKOI8ToANSI[37] = '\xe3';
  cMapKOI8ToANSI[38] = '\xac';
  cMapKOI8ToANSI[39] = '\xac';
  cMapKOI8ToANSI[40] = '\xac';
  cMapKOI8ToANSI[41] = '\x4c';
  cMapKOI8ToANSI[42] = '\x4c';
  cMapKOI8ToANSI[43] = '\x4c';
  cMapKOI8ToANSI[44] = '\x2d';
  cMapKOI8ToANSI[45] = '\x2d';
  cMapKOI8ToANSI[46] = '\x2d';
  cMapKOI8ToANSI[47] = '\xa6';
  cMapKOI8ToANSI[48] = '\xa6';
  cMapKOI8ToANSI[49] = '\xa6';
  cMapKOI8ToANSI[50] = '\xa6';
  cMapKOI8ToANSI[51] = '\xa8';
  cMapKOI8ToANSI[52] = '\xa6';
  cMapKOI8ToANSI[53] = '\xa6';
  cMapKOI8ToANSI[54] = '\x54';
  cMapKOI8ToANSI[55] = '\x54';
  cMapKOI8ToANSI[56] = '\x54';
  cMapKOI8ToANSI[57] = '\xa6';
  cMapKOI8ToANSI[58] = '\xa6';
  cMapKOI8ToANSI[59] = '\xa6';
  cMapKOI8ToANSI[60] = '\x2b';
  cMapKOI8ToANSI[61] = '\x2b';
  cMapKOI8ToANSI[62] = '\x2b';
  cMapKOI8ToANSI[63] = '\xa9';
  cMapKOI8ToANSI[64] = '\xfe';
  cMapKOI8ToANSI[65] = '\xe0';
  cMapKOI8ToANSI[66] = '\xe1';
  cMapKOI8ToANSI[67] = '\xf6';
  cMapKOI8ToANSI[68] = '\xe4';
  cMapKOI8ToANSI[69] = '\xe5';
  cMapKOI8ToANSI[70] = '\xf4';
  cMapKOI8ToANSI[71] = '\xe3';
  cMapKOI8ToANSI[72] = '\xf5';
  cMapKOI8ToANSI[73] = '\xe8';
  cMapKOI8ToANSI[74] = '\xe9';
  cMapKOI8ToANSI[75] = '\xea';
  cMapKOI8ToANSI[76] = '\xeb';
  cMapKOI8ToANSI[77] = '\xec';
  cMapKOI8ToANSI[78] = '\xed';
  cMapKOI8ToANSI[79] = '\xee';
  cMapKOI8ToANSI[80] = '\xef';
  cMapKOI8ToANSI[81] = '\xff';
  cMapKOI8ToANSI[82] = '\xf0';
  cMapKOI8ToANSI[83] = '\xf1';
  cMapKOI8ToANSI[84] = '\xf2';
  cMapKOI8ToANSI[85] = '\xf3';
  cMapKOI8ToANSI[86] = '\xe6';
  cMapKOI8ToANSI[87] = '\xe2';
  cMapKOI8ToANSI[88] = '\xfc';
  cMapKOI8ToANSI[89] = '\xfb';
  cMapKOI8ToANSI[90] = '\xe7';
  cMapKOI8ToANSI[91] = '\xf8';
  cMapKOI8ToANSI[92] = '\xfd';
  cMapKOI8ToANSI[93] = '\xf9';
  cMapKOI8ToANSI[94] = '\xf7';
  cMapKOI8ToANSI[95] = '\xfa';
  cMapKOI8ToANSI[96] = '\xde';
  cMapKOI8ToANSI[97] = '\xc0';
  cMapKOI8ToANSI[98] = '\xc1';
  cMapKOI8ToANSI[99] = '\xd6';
  cMapKOI8ToANSI[100] = '\xc4';
  cMapKOI8ToANSI[101] = '\xc5';
  cMapKOI8ToANSI[102] = '\xd4';
  cMapKOI8ToANSI[103] = '\xc3';
  cMapKOI8ToANSI[104] = '\xd5';
  cMapKOI8ToANSI[105] = '\xc8';
  cMapKOI8ToANSI[106] = '\xc9';
  cMapKOI8ToANSI[107] = '\xca';
  cMapKOI8ToANSI[108] = '\xcb';
  cMapKOI8ToANSI[109] = '\xcc';
  cMapKOI8ToANSI[110] = '\xcd';
  cMapKOI8ToANSI[111] = '\xce';
  cMapKOI8ToANSI[112] = '\xcf';
  cMapKOI8ToANSI[113] = '\xdf';
  cMapKOI8ToANSI[114] = '\xd0';
  cMapKOI8ToANSI[115] = '\xd1';
  cMapKOI8ToANSI[116] = '\xd2';
  cMapKOI8ToANSI[117] = '\xd3';
  cMapKOI8ToANSI[118] = '\xc6';
  cMapKOI8ToANSI[119] = '\xc2';
  cMapKOI8ToANSI[120] = '\xdc';
  cMapKOI8ToANSI[121] = '\xdb';
  cMapKOI8ToANSI[122] = '\xc7';
  cMapKOI8ToANSI[123] = '\xd8';
  cMapKOI8ToANSI[124] = '\xdd';
  cMapKOI8ToANSI[125] = '\xd9';
  cMapKOI8ToANSI[126] = '\xd7';
  cMapKOI8ToANSI[127] = '\xda';
}

  //From recode 3.5

TCodepageMap128 cMapMacToANSI;
void cMapMacToANSIInit( )
{
  cMapMacToANSI[0] = '\xc4';
  cMapMacToANSI[1] = '\xc5';
  cMapMacToANSI[2] = '\xc7';
  cMapMacToANSI[3] = '\xc9';
  cMapMacToANSI[4] = '\xd1';
  cMapMacToANSI[5] = '\xd6';
  cMapMacToANSI[6] = '\xdc';
  cMapMacToANSI[7] = '\xe1';
  cMapMacToANSI[8] = '\xe0';
  cMapMacToANSI[9] = '\xe2';
  cMapMacToANSI[10] = '\xe4';
  cMapMacToANSI[11] = '\xe3';
  cMapMacToANSI[12] = '\xe5';
  cMapMacToANSI[13] = '\xe7';
  cMapMacToANSI[14] = '\xe9';
  cMapMacToANSI[15] = '\xe8';
  cMapMacToANSI[16] = '\xea';
  cMapMacToANSI[17] = '\xeb';
  cMapMacToANSI[18] = '\xed';
  cMapMacToANSI[19] = '\xec';
  cMapMacToANSI[20] = '\xee';
  cMapMacToANSI[21] = '\xef';
  cMapMacToANSI[22] = '\xf1';
  cMapMacToANSI[23] = '\xf3';
  cMapMacToANSI[24] = '\xf2';
  cMapMacToANSI[25] = '\xf4';
  cMapMacToANSI[26] = '\xf6';
  cMapMacToANSI[27] = '\xf5';
  cMapMacToANSI[28] = '\xfa';
  cMapMacToANSI[29] = '\xf9';
  cMapMacToANSI[30] = '\xfb';
  cMapMacToANSI[31] = '\xfc';
  cMapMacToANSI[32] = '\xa0';
  cMapMacToANSI[33] = '\xb0';
  cMapMacToANSI[34] = '\xa2';
  cMapMacToANSI[35] = '\xa3';
  cMapMacToANSI[36] = '\xa7';
  cMapMacToANSI[37] = '\xb4';
  cMapMacToANSI[38] = '\xb6';
  cMapMacToANSI[39] = '\xdf';
  cMapMacToANSI[40] = '\xae';
  cMapMacToANSI[41] = '\xa9';
  cMapMacToANSI[42] = '\x8e';
  cMapMacToANSI[43] = '\x82';
  cMapMacToANSI[44] = '\x8c';
  cMapMacToANSI[45] = '\xad';
  cMapMacToANSI[46] = '\xc6';
  cMapMacToANSI[47] = '\xd8';
  cMapMacToANSI[48] = '\x8d';
  cMapMacToANSI[49] = '\xb1';
  cMapMacToANSI[50] = '\xb2';
  cMapMacToANSI[51] = '\xb3';
  cMapMacToANSI[52] = '\xa5';
  cMapMacToANSI[53] = '\xb5';
  cMapMacToANSI[54] = '\xa6';
  cMapMacToANSI[55] = '\xb7';
  cMapMacToANSI[56] = '\xb8';
  cMapMacToANSI[57] = '\xb9';
  cMapMacToANSI[58] = '\xbc';
  cMapMacToANSI[59] = '\xaa';
  cMapMacToANSI[60] = '\xba';
  cMapMacToANSI[61] = '\xbd';
  cMapMacToANSI[62] = '\xe6';
  cMapMacToANSI[63] = '\xf8';
  cMapMacToANSI[64] = '\xbf';
  cMapMacToANSI[65] = '\xa1';
  cMapMacToANSI[66] = '\xac';
  cMapMacToANSI[67] = '\x92';
  cMapMacToANSI[68] = '\x80';
  cMapMacToANSI[69] = '\x81';
  cMapMacToANSI[70] = '\xa8';
  cMapMacToANSI[71] = '\xab';
  cMapMacToANSI[72] = '\xbb';
  cMapMacToANSI[73] = '\x83';
  cMapMacToANSI[74] = '\xbe';
  cMapMacToANSI[75] = '\xc0';
  cMapMacToANSI[76] = '\xc3';
  cMapMacToANSI[77] = '\xd5';
  cMapMacToANSI[78] = '\x91';
  cMapMacToANSI[79] = '\x93';
  cMapMacToANSI[80] = '\xd0';
  cMapMacToANSI[81] = '\x84';
  cMapMacToANSI[82] = '\x96';
  cMapMacToANSI[83] = '\x94';
  cMapMacToANSI[84] = '\x95';
  cMapMacToANSI[85] = '\x90';
  cMapMacToANSI[86] = '\xf7';
  cMapMacToANSI[87] = '\xd7';
  cMapMacToANSI[88] = '\xff';
  cMapMacToANSI[89] = '\xdd';
  cMapMacToANSI[90] = '\x98';
  cMapMacToANSI[91] = '\x97';
  cMapMacToANSI[92] = '\x86';
  cMapMacToANSI[93] = '\x99';
  cMapMacToANSI[94] = '\xde';
  cMapMacToANSI[95] = '\xa4';
  cMapMacToANSI[96] = '\x88';
  cMapMacToANSI[97] = '\x87';
  cMapMacToANSI[98] = '\x89';
  cMapMacToANSI[99] = '\x8b';
  cMapMacToANSI[100] = '\x8a';
  cMapMacToANSI[101] = '\xc2';
  cMapMacToANSI[102] = '\xca';
  cMapMacToANSI[103] = '\xc1';
  cMapMacToANSI[104] = '\xcb';
  cMapMacToANSI[105] = '\xc8';
  cMapMacToANSI[106] = '\xcd';
  cMapMacToANSI[107] = '\xce';
  cMapMacToANSI[108] = '\xcf';
  cMapMacToANSI[109] = '\xcc';
  cMapMacToANSI[110] = '\xd3';
  cMapMacToANSI[111] = '\xd4';
  cMapMacToANSI[112] = '\xf0';
  cMapMacToANSI[113] = '\xd2';
  cMapMacToANSI[114] = '\xda';
  cMapMacToANSI[115] = '\xdb';
  cMapMacToANSI[116] = '\xd9';
  cMapMacToANSI[117] = '\x9b';
  cMapMacToANSI[118] = '\x9a';
  cMapMacToANSI[119] = '\x85';
  cMapMacToANSI[120] = '\x8f';
  cMapMacToANSI[121] = '\x9d';
  cMapMacToANSI[122] = '\x9c';
  cMapMacToANSI[123] = '\x9e';
  cMapMacToANSI[124] = '\x9f';
  cMapMacToANSI[125] = '\xfd';
  cMapMacToANSI[126] = '\xfe';
  cMapMacToANSI[127] = '\xaf';
}

  //From recode 3.5

TCodepageMap256 cMapEBCDICToANSI;
void cMapEBCDICToANSIInit( )
{
  cMapEBCDICToANSI[0] = '\x00';
  cMapEBCDICToANSI[1] = '\x01';
  cMapEBCDICToANSI[2] = '\x02';
  cMapEBCDICToANSI[3] = '\x03';
  cMapEBCDICToANSI[4] = '\xf7';
  cMapEBCDICToANSI[5] = '\x09';
  cMapEBCDICToANSI[6] = '\xd2';
  cMapEBCDICToANSI[7] = '\x7f';
  cMapEBCDICToANSI[8] = '\xf2';
  cMapEBCDICToANSI[9] = '\xa8';
  cMapEBCDICToANSI[10] = '\x93';
  cMapEBCDICToANSI[11] = '\x0b';
  cMapEBCDICToANSI[12] = '\x0c';
  cMapEBCDICToANSI[13] = '\x0d';
  cMapEBCDICToANSI[14] = '\x0e';
  cMapEBCDICToANSI[15] = '\x0f';
  cMapEBCDICToANSI[16] = '\x10';
  cMapEBCDICToANSI[17] = '\x11';
  cMapEBCDICToANSI[18] = '\x12';
  cMapEBCDICToANSI[19] = '\x13';
  cMapEBCDICToANSI[20] = '\xd3';
  cMapEBCDICToANSI[21] = '\xa1';
  cMapEBCDICToANSI[22] = '\x08';
  cMapEBCDICToANSI[23] = '\xd7';
  cMapEBCDICToANSI[24] = '\x18';
  cMapEBCDICToANSI[25] = '\x19';
  cMapEBCDICToANSI[26] = '\x96';
  cMapEBCDICToANSI[27] = '\xd0';
  cMapEBCDICToANSI[28] = '\x1c';
  cMapEBCDICToANSI[29] = '\x1d';
  cMapEBCDICToANSI[30] = '\x1e';
  cMapEBCDICToANSI[31] = '\x1f';
  cMapEBCDICToANSI[32] = '\x7c';
  cMapEBCDICToANSI[33] = '\xd6';
  cMapEBCDICToANSI[34] = '\x81';
  cMapEBCDICToANSI[35] = '\xc0';
  cMapEBCDICToANSI[36] = '\xd1';
  cMapEBCDICToANSI[37] = '\x0a';
  cMapEBCDICToANSI[38] = '\x17';
  cMapEBCDICToANSI[39] = '\x1b';
  cMapEBCDICToANSI[40] = '\xd4';
  cMapEBCDICToANSI[41] = '\xe9';
  cMapEBCDICToANSI[42] = '\xe0';
  cMapEBCDICToANSI[43] = '\xd5';
  cMapEBCDICToANSI[44] = '\x92';
  cMapEBCDICToANSI[45] = '\x05';
  cMapEBCDICToANSI[46] = '\x06';
  cMapEBCDICToANSI[47] = '\x07';
  cMapEBCDICToANSI[48] = '\xf0';
  cMapEBCDICToANSI[49] = '\xf1';
  cMapEBCDICToANSI[50] = '\x16';
  cMapEBCDICToANSI[51] = '\xf3';
  cMapEBCDICToANSI[52] = '\xf4';
  cMapEBCDICToANSI[53] = '\xf5';
  cMapEBCDICToANSI[54] = '\xf6';
  cMapEBCDICToANSI[55] = '\x04';
  cMapEBCDICToANSI[56] = '\xf8';
  cMapEBCDICToANSI[57] = '\xf9';
  cMapEBCDICToANSI[58] = '\xa9';
  cMapEBCDICToANSI[59] = '\x94';
  cMapEBCDICToANSI[60] = '\x14';
  cMapEBCDICToANSI[61] = '\x15';
  cMapEBCDICToANSI[62] = '\x95';
  cMapEBCDICToANSI[63] = '\x1a';
  cMapEBCDICToANSI[64] = '\x20';
  cMapEBCDICToANSI[65] = '\xc1';
  cMapEBCDICToANSI[66] = '\xc2';
  cMapEBCDICToANSI[67] = '\xc3';
  cMapEBCDICToANSI[68] = '\xc4';
  cMapEBCDICToANSI[69] = '\xc5';
  cMapEBCDICToANSI[70] = '\xc6';
  cMapEBCDICToANSI[71] = '\xc7';
  cMapEBCDICToANSI[72] = '\xc8';
  cMapEBCDICToANSI[73] = '\xc9';
  cMapEBCDICToANSI[74] = '\x5b';
  cMapEBCDICToANSI[75] = '\x2e';
  cMapEBCDICToANSI[76] = '\x3c';
  cMapEBCDICToANSI[77] = '\x28';
  cMapEBCDICToANSI[78] = '\x2b';
  cMapEBCDICToANSI[79] = '\x21';
  cMapEBCDICToANSI[80] = '\x26';
  cMapEBCDICToANSI[81] = '\xd8';
  cMapEBCDICToANSI[82] = '\xd9';
  cMapEBCDICToANSI[83] = '\xe2';
  cMapEBCDICToANSI[84] = '\xe3';
  cMapEBCDICToANSI[85] = '\xe4';
  cMapEBCDICToANSI[86] = '\xe5';
  cMapEBCDICToANSI[87] = '\xe6';
  cMapEBCDICToANSI[88] = '\xe7';
  cMapEBCDICToANSI[89] = '\xe8';
  cMapEBCDICToANSI[90] = '\x5d';
  cMapEBCDICToANSI[91] = '\x24';
  cMapEBCDICToANSI[92] = '\x2a';
  cMapEBCDICToANSI[93] = '\x29';
  cMapEBCDICToANSI[94] = '\x3b';
  cMapEBCDICToANSI[95] = '\x5e';
  cMapEBCDICToANSI[96] = '\x2d';
  cMapEBCDICToANSI[97] = '\x2f';
  cMapEBCDICToANSI[98] = '\x82';
  cMapEBCDICToANSI[99] = '\x83';
  cMapEBCDICToANSI[100] = '\x84';
  cMapEBCDICToANSI[101] = '\x85';
  cMapEBCDICToANSI[102] = '\x86';
  cMapEBCDICToANSI[103] = '\x87';
  cMapEBCDICToANSI[104] = '\x88';
  cMapEBCDICToANSI[105] = '\x89';
  cMapEBCDICToANSI[106] = '\xa6';
  cMapEBCDICToANSI[107] = '\x2c';
  cMapEBCDICToANSI[108] = '\x25';
  cMapEBCDICToANSI[109] = '\x5f';
  cMapEBCDICToANSI[110] = '\x3e';
  cMapEBCDICToANSI[111] = '\x3f';
  cMapEBCDICToANSI[112] = '\x97';
  cMapEBCDICToANSI[113] = '\x98';
  cMapEBCDICToANSI[114] = '\x99';
  cMapEBCDICToANSI[115] = '\xa2';
  cMapEBCDICToANSI[116] = '\xa3';
  cMapEBCDICToANSI[117] = '\xa4';
  cMapEBCDICToANSI[118] = '\xa5';
  cMapEBCDICToANSI[119] = '\x91';
  cMapEBCDICToANSI[120] = '\xa7';
  cMapEBCDICToANSI[121] = '\x60';
  cMapEBCDICToANSI[122] = '\x3a';
  cMapEBCDICToANSI[123] = '\x23';
  cMapEBCDICToANSI[124] = '\x40';
  cMapEBCDICToANSI[125] = '\x27';
  cMapEBCDICToANSI[126] = '\x3d';
  cMapEBCDICToANSI[127] = '\x22';
  cMapEBCDICToANSI[128] = '\x80';
  cMapEBCDICToANSI[129] = '\x61';
  cMapEBCDICToANSI[130] = '\x62';
  cMapEBCDICToANSI[131] = '\x63';
  cMapEBCDICToANSI[132] = '\x64';
  cMapEBCDICToANSI[133] = '\x65';
  cMapEBCDICToANSI[134] = '\x66';
  cMapEBCDICToANSI[135] = '\x67';
  cMapEBCDICToANSI[136] = '\x68';
  cMapEBCDICToANSI[137] = '\x69';
  cMapEBCDICToANSI[138] = '\x8a';
  cMapEBCDICToANSI[139] = '\x8b';
  cMapEBCDICToANSI[140] = '\x8c';
  cMapEBCDICToANSI[141] = '\x8d';
  cMapEBCDICToANSI[142] = '\x8e';
  cMapEBCDICToANSI[143] = '\x8f';
  cMapEBCDICToANSI[144] = '\x90';
  cMapEBCDICToANSI[145] = '\x6a';
  cMapEBCDICToANSI[146] = '\x6b';
  cMapEBCDICToANSI[147] = '\x6c';
  cMapEBCDICToANSI[148] = '\x6d';
  cMapEBCDICToANSI[149] = '\x6e';
  cMapEBCDICToANSI[150] = '\x6f';
  cMapEBCDICToANSI[151] = '\x70';
  cMapEBCDICToANSI[152] = '\x71';
  cMapEBCDICToANSI[153] = '\x72';
  cMapEBCDICToANSI[154] = '\x9a';
  cMapEBCDICToANSI[155] = '\x9b';
  cMapEBCDICToANSI[156] = '\x9c';
  cMapEBCDICToANSI[157] = '\x9d';
  cMapEBCDICToANSI[158] = '\x9e';
  cMapEBCDICToANSI[159] = '\x9f';
  cMapEBCDICToANSI[160] = '\xa0';
  cMapEBCDICToANSI[161] = '\x7e';
  cMapEBCDICToANSI[162] = '\x73';
  cMapEBCDICToANSI[163] = '\x74';
  cMapEBCDICToANSI[164] = '\x75';
  cMapEBCDICToANSI[165] = '\x76';
  cMapEBCDICToANSI[166] = '\x77';
  cMapEBCDICToANSI[167] = '\x78';
  cMapEBCDICToANSI[168] = '\x79';
  cMapEBCDICToANSI[169] = '\x7a';
  cMapEBCDICToANSI[170] = '\xaa';
  cMapEBCDICToANSI[171] = '\xab';
  cMapEBCDICToANSI[172] = '\xac';
  cMapEBCDICToANSI[173] = '\xad';
  cMapEBCDICToANSI[174] = '\xae';
  cMapEBCDICToANSI[175] = '\xaf';
  cMapEBCDICToANSI[176] = '\xb0';
  cMapEBCDICToANSI[177] = '\xb1';
  cMapEBCDICToANSI[178] = '\xb2';
  cMapEBCDICToANSI[179] = '\xb3';
  cMapEBCDICToANSI[180] = '\xb4';
  cMapEBCDICToANSI[181] = '\xb5';
  cMapEBCDICToANSI[182] = '\xb6';
  cMapEBCDICToANSI[183] = '\xb7';
  cMapEBCDICToANSI[184] = '\xb8';
  cMapEBCDICToANSI[185] = '\xb9';
  cMapEBCDICToANSI[186] = '\xba';
  cMapEBCDICToANSI[187] = '\xbb';
  cMapEBCDICToANSI[188] = '\xbc';
  cMapEBCDICToANSI[189] = '\xbd';
  cMapEBCDICToANSI[190] = '\xbe';
  cMapEBCDICToANSI[191] = '\xbf';
  cMapEBCDICToANSI[192] = '\x7b';
  cMapEBCDICToANSI[193] = '\x41';
  cMapEBCDICToANSI[194] = '\x42';
  cMapEBCDICToANSI[195] = '\x43';
  cMapEBCDICToANSI[196] = '\x44';
  cMapEBCDICToANSI[197] = '\x45';
  cMapEBCDICToANSI[198] = '\x46';
  cMapEBCDICToANSI[199] = '\x47';
  cMapEBCDICToANSI[200] = '\x48';
  cMapEBCDICToANSI[201] = '\x49';
  cMapEBCDICToANSI[202] = '\xca';
  cMapEBCDICToANSI[203] = '\xcb';
  cMapEBCDICToANSI[204] = '\xcc';
  cMapEBCDICToANSI[205] = '\xcd';
  cMapEBCDICToANSI[206] = '\xce';
  cMapEBCDICToANSI[207] = '\xcf';
  cMapEBCDICToANSI[208] = '\x7d';
  cMapEBCDICToANSI[209] = '\x4a';
  cMapEBCDICToANSI[210] = '\x4b';
  cMapEBCDICToANSI[211] = '\x4c';
  cMapEBCDICToANSI[212] = '\x4d';
  cMapEBCDICToANSI[213] = '\x4e';
  cMapEBCDICToANSI[214] = '\x4f';
  cMapEBCDICToANSI[215] = '\x50';
  cMapEBCDICToANSI[216] = '\x51';
  cMapEBCDICToANSI[217] = '\x52';
  cMapEBCDICToANSI[218] = '\xda';
  cMapEBCDICToANSI[219] = '\xdb';
  cMapEBCDICToANSI[220] = '\xdc';
  cMapEBCDICToANSI[221] = '\xdd';
  cMapEBCDICToANSI[222] = '\xde';
  cMapEBCDICToANSI[223] = '\xdf';
  cMapEBCDICToANSI[224] = '\x5c';
  cMapEBCDICToANSI[225] = '\xe1';
  cMapEBCDICToANSI[226] = '\x53';
  cMapEBCDICToANSI[227] = '\x54';
  cMapEBCDICToANSI[228] = '\x55';
  cMapEBCDICToANSI[229] = '\x56';
  cMapEBCDICToANSI[230] = '\x57';
  cMapEBCDICToANSI[231] = '\x58';
  cMapEBCDICToANSI[232] = '\x59';
  cMapEBCDICToANSI[233] = '\x5a';
  cMapEBCDICToANSI[234] = '\xea';
  cMapEBCDICToANSI[235] = '\xeb';
  cMapEBCDICToANSI[236] = '\xec';
  cMapEBCDICToANSI[237] = '\xed';
  cMapEBCDICToANSI[238] = '\xee';
  cMapEBCDICToANSI[239] = '\xef';
  cMapEBCDICToANSI[240] = '\x30';
  cMapEBCDICToANSI[241] = '\x31';
  cMapEBCDICToANSI[242] = '\x32';
  cMapEBCDICToANSI[243] = '\x33';
  cMapEBCDICToANSI[244] = '\x34';
  cMapEBCDICToANSI[245] = '\x35';
  cMapEBCDICToANSI[246] = '\x36';
  cMapEBCDICToANSI[247] = '\x37';
  cMapEBCDICToANSI[248] = '\x38';
  cMapEBCDICToANSI[249] = '\x39';
  cMapEBCDICToANSI[250] = '\xfa';
  cMapEBCDICToANSI[251] = '\xfb';
  cMapEBCDICToANSI[252] = '\xfc';
  cMapEBCDICToANSI[253] = '\xfd';
  cMapEBCDICToANSI[254] = '\xfe';
  cMapEBCDICToANSI[255] = '\xff';
}
  //Western European (ISO 8859-1) --> Western European (Windows-1252)



TCodepageMap128 cMapISOToANSI;
void cMapISOToANSIInit( )
{
  cMapISOToANSI[0] = '\x3f';
  cMapISOToANSI[1] = '\x81';
  cMapISOToANSI[2] = '\x3f';
  cMapISOToANSI[3] = '\x3f';
  cMapISOToANSI[4] = '\x3f';
  cMapISOToANSI[5] = '\x3f';
  cMapISOToANSI[6] = '\x3f';
  cMapISOToANSI[7] = '\x3f';
  cMapISOToANSI[8] = '\x3f';
  cMapISOToANSI[9] = '\x3f';
  cMapISOToANSI[10] = '\x3f';
  cMapISOToANSI[11] = '\x3f';
  cMapISOToANSI[12] = '\x3f';
  cMapISOToANSI[13] = '\x8d';
  cMapISOToANSI[14] = '\x3f';
  cMapISOToANSI[15] = '\x8f';
  cMapISOToANSI[16] = '\x90';
  cMapISOToANSI[17] = '\x3f';
  cMapISOToANSI[18] = '\x3f';
  cMapISOToANSI[19] = '\x3f';
  cMapISOToANSI[20] = '\x3f';
  cMapISOToANSI[21] = '\x3f';
  cMapISOToANSI[22] = '\x3f';
  cMapISOToANSI[23] = '\x3f';
  cMapISOToANSI[24] = '\x3f';
  cMapISOToANSI[25] = '\x3f';
  cMapISOToANSI[26] = '\x3f';
  cMapISOToANSI[27] = '\x3f';
  cMapISOToANSI[28] = '\x3f';
  cMapISOToANSI[29] = '\x9d';
  cMapISOToANSI[30] = '\x3f';
  cMapISOToANSI[31] = '\x3f';
  cMapISOToANSI[32] = '\xa0';
  cMapISOToANSI[33] = '\xa1';
  cMapISOToANSI[34] = '\xa2';
  cMapISOToANSI[35] = '\xa3';
  cMapISOToANSI[36] = '\xa4';
  cMapISOToANSI[37] = '\xa5';
  cMapISOToANSI[38] = '\xa6';
  cMapISOToANSI[39] = '\xa7';
  cMapISOToANSI[40] = '\xa8';
  cMapISOToANSI[41] = '\xa9';
  cMapISOToANSI[42] = '\xaa';
  cMapISOToANSI[43] = '\xab';
  cMapISOToANSI[44] = '\xac';
  cMapISOToANSI[45] = '\xad';
  cMapISOToANSI[46] = '\xae';
  cMapISOToANSI[47] = '\xaf';
  cMapISOToANSI[48] = '\xb0';
  cMapISOToANSI[49] = '\xb1';
  cMapISOToANSI[50] = '\xb2';
  cMapISOToANSI[51] = '\xb3';
  cMapISOToANSI[52] = '\xb4';
  cMapISOToANSI[53] = '\xb5';
  cMapISOToANSI[54] = '\xb6';
  cMapISOToANSI[55] = '\xb7';
  cMapISOToANSI[56] = '\xb8';
  cMapISOToANSI[57] = '\xb9';
  cMapISOToANSI[58] = '\xba';
  cMapISOToANSI[59] = '\xbb';
  cMapISOToANSI[60] = '\xbc';
  cMapISOToANSI[61] = '\xbd';
  cMapISOToANSI[62] = '\xbe';
  cMapISOToANSI[63] = '\xbf';
  cMapISOToANSI[64] = '\xc0';
  cMapISOToANSI[65] = '\xc1';
  cMapISOToANSI[66] = '\xc2';
  cMapISOToANSI[67] = '\xc3';
  cMapISOToANSI[68] = '\xc4';
  cMapISOToANSI[69] = '\xc5';
  cMapISOToANSI[70] = '\xc6';
  cMapISOToANSI[71] = '\xc7';
  cMapISOToANSI[72] = '\xc8';
  cMapISOToANSI[73] = '\xc9';
  cMapISOToANSI[74] = '\xca';
  cMapISOToANSI[75] = '\xcb';
  cMapISOToANSI[76] = '\xcc';
  cMapISOToANSI[77] = '\xcd';
  cMapISOToANSI[78] = '\xce';
  cMapISOToANSI[79] = '\xcf';
  cMapISOToANSI[80] = '\xd0';
  cMapISOToANSI[81] = '\xd1';
  cMapISOToANSI[82] = '\xd2';
  cMapISOToANSI[83] = '\xd3';
  cMapISOToANSI[84] = '\xd4';
  cMapISOToANSI[85] = '\xd5';
  cMapISOToANSI[86] = '\xd6';
  cMapISOToANSI[87] = '\xd7';
  cMapISOToANSI[88] = '\xd8';
  cMapISOToANSI[89] = '\xd9';
  cMapISOToANSI[90] = '\xda';
  cMapISOToANSI[91] = '\xdb';
  cMapISOToANSI[92] = '\xdc';
  cMapISOToANSI[93] = '\xdd';
  cMapISOToANSI[94] = '\xde';
  cMapISOToANSI[95] = '\xdf';
  cMapISOToANSI[96] = '\xe0';
  cMapISOToANSI[97] = '\xe1';
  cMapISOToANSI[98] = '\xe2';
  cMapISOToANSI[99] = '\xe3';
  cMapISOToANSI[100] = '\xe4';
  cMapISOToANSI[101] = '\xe5';
  cMapISOToANSI[102] = '\xe6';
  cMapISOToANSI[103] = '\xe7';
  cMapISOToANSI[104] = '\xe8';
  cMapISOToANSI[105] = '\xe9';
  cMapISOToANSI[106] = '\xea';
  cMapISOToANSI[107] = '\xeb';
  cMapISOToANSI[108] = '\xec';
  cMapISOToANSI[109] = '\xed';
  cMapISOToANSI[110] = '\xee';
  cMapISOToANSI[111] = '\xef';
  cMapISOToANSI[112] = '\xf0';
  cMapISOToANSI[113] = '\xf1';
  cMapISOToANSI[114] = '\xf2';
  cMapISOToANSI[115] = '\xf3';
  cMapISOToANSI[116] = '\xf4';
  cMapISOToANSI[117] = '\xf5';
  cMapISOToANSI[118] = '\xf6';
  cMapISOToANSI[119] = '\xf7';
  cMapISOToANSI[120] = '\xf8';
  cMapISOToANSI[121] = '\xf9';
  cMapISOToANSI[122] = '\xfa';
  cMapISOToANSI[123] = '\xfb';
  cMapISOToANSI[124] = '\xfc';
  cMapISOToANSI[125] = '\xfd';
  cMapISOToANSI[126] = '\xfe';
  cMapISOToANSI[127] = '\xff';
}

//-------------------------------------------------



AnsiString __fastcall SConvertKOI8ToANSI( const AnsiString S )
{
  AnsiString result;
  result = SConvertByMap128( S, cMapKOI8ToANSI );
  return result;
}


AnsiString __fastcall SConvertMacToANSI( const AnsiString S )
{
  AnsiString result;
  result = SConvertByMap128( S, cMapMacToANSI );
  return result;
}


AnsiString __fastcall SConvertEBCDICToANSI( const AnsiString S )
{
  AnsiString result;
  result = SConvertByMap256( S, cMapEBCDICToANSI );
  return result;
}


AnsiString __fastcall SConvertISOToANSI( const AnsiString S )
{
  AnsiString result;
  result = SConvertByMap128( S, cMapISOToANSI );
  return result;
}

//-------------------------------------------------



WideString __fastcall SCodepageToUnicode( const AnsiString S, TATEncoding Enc )
{
  WideString result;
  TATEncoding IsoEnc;
  result.Empty();
  Assert( ! ( cATUnicodeEncodings.Contains(Enc ) ), "Unicode encodings can't be passed to CodepageToUnicode" );
  if ( !S.IsEmpty())
    switch ( Enc )
    {
      case vEncANSI:
        result = S;
      break;
      case vEncEBCDIC:
        if ( IsCodepageSupported( vEncEBUSCanada ) )
          result = SCodepageToUnicodeAPI( S, vEncEBUSCanada );
        else
          result = SConvertEBCDICToANSI( S );
      break;
      case vEncKOI8:
        if ( IsCodepageSupported( vEncCyrKOI8R ) )
          result = SCodepageToUnicodeAPI( S, vEncCyrKOI8R );
        else
          result = SConvertKOI8ToANSI( S );
      break;
      case vEncISO:
      {
          //Since we don't have CP_ISOCP Windows constant,
          //we need to determine ISO codepage by hands:
        switch ( GetACP() )
        {
          case 1250:
            IsoEnc = vEncCEuroISO;
          break;  //Eastern European 

          case 1251:
            IsoEnc = vEncCyrISO;
          break;    //Cyrillic

          case 1252:
            IsoEnc = vEncWEuroISO1;
          break; //US, Western Europe

          case 1253:
            IsoEnc = vEncGreekISO;
          break;  //Greek

          case 1254:
            IsoEnc = vEncTurISO;
          break;    //Turkish

          case 1255:
            IsoEnc = vEncHebISO1;
          break;   //Hebrew

          case 1256:
            IsoEnc = vEncArISO;
          break;     //Arabic

          case 1257:
            IsoEnc = vEncBalISO1;
          break;   //Baltic
        default:
          IsoEnc = vEncWEuroISO1;
        }
        if ( IsCodepageSupported( IsoEnc ) )
          result = SCodepageToUnicodeAPI( S, IsoEnc );
        else
          result = SConvertISOToANSI( S );
      }
      break;
      case vEncMac:
      {
          //CP_MACCP codepage supported only under NT:
        if ( Win32Platform == VER_PLATFORM_WIN32_NT )
          result = SCodepageToUnicodeAPI( S, vEncMac );
        else
          result = SConvertMacToANSI( S );
      }
      break;

      /*
      vEncUTF8:
        Result := UTF8Decode(S);
        */
    default:
      result = SCodepageToUnicodeAPI( S, Enc );
    }
  return result;
}

void ATxCodepages_initialization()
{
  InitCodepagesSupported();
}

class ATxCodepages_unit
{
public:
ATxCodepages_unit()
{
  ATxCodepages_initialization();
  cATEncodingFamilyNamesInit();
  cATEncodingsInit();
  cMapKOI8ToANSIInit();
  cMapMacToANSIInit();
  cMapEBCDICToANSIInit();
  cMapISOToANSIInit();
}
};
ATxCodepages_unit _ATxCodepages_unit;
