
#include <vcl.h>
#pragma hdrstop

#include "ATxSHex.h"



#include <sysutils.hpp>
#include "ATxSProc.h"



#include "d2c_system.h"


typedef unsigned int unsignedint;



bool __fastcall SHexDigitToInt( Char Hex, unsignedint& Int )
{
  bool result = false;
  Char Ch = '\0';
  result = true;
  Int = 0;
  Ch = UpCase( Hex );
  switch ( Ch )
  {
    case /*# '0' .. '9' */ '0' :
     case '1': case '2': case '3': case '4': case '5': case '6': case '7': case '8': case '9':
      Int = int( Ch ) - int( '0' );
    break;
    case /*# 'A' .. 'F' */ 'A' :
     case 'B': case 'C': case 'D': case 'E': case 'F':
      Int = int( Ch ) - int( 'A' ) + 10;
    break;
  default:
    result = false;
  }
  return result;
}


bool __fastcall SHexWordToInt( const String Hex, unsignedint& Int )
{
  bool result = false;
  unsigned int Int1 = 0, Int2 = 0;
  result = false;
  if ( Hex.Length( ) == 1 )
    result = SHexDigitToInt( Hex[1], Int );
  else
    if ( Hex.Length( ) == 2 )
    {
      result = SHexDigitToInt( Hex[1], Int1 ) && SHexDigitToInt( Hex[2], Int2 );
      if ( result )
        Int = Int1 * 16 + Int2;
    }
  return result;
}


bool __fastcall SHexToNormal( const String HexStr, String& ResStr )
{
  bool result = false;
  String S;
  unsigned int Int = 0;
  int i = 0;
  ResStr = "";
  result = false;
  S = HexStr;
  SReplaceAll( S, " ", "" );
  if ( ( S.Length( ) % 2 ) > 0 )
    return result;
  for ( int stop = S.Length( ) / 2, i = 1; i <= stop; i++)
  {
    if ( ! SHexWordToInt( String( S[2 * i - 1] ) + S[2 * i], Int ) )
      return result;
    ResStr = ResStr + Char( Int );
  }
  result = true;
  return result;
}


AnsiString __fastcall SToHex( const AnsiString S )
{
  AnsiString result;
  int i = 0;
  result = "";
  for ( int stop = S.Length( ), i = 1; i <= stop; i++)
    result = result + IntToHex( int( S[i] ), 2 ) + " ";
  if ( !result.IsEmpty())
    result.Delete( result.Length( ), 1 );
  return result;
}


__int64 __fastcall HexToIntDef( const String S, const __int64 Default )
{
  __int64 result = 0;
  int i = 0;
  unsigned int n = 0;
  result = 0;
  for ( int stop = S.Length( ), i = 1; i <= stop; i++)
  {
    if ( ! SHexDigitToInt( S[i], n ) )
    {
      result = Default;
      return result;
    }
    result = result * 0x10 + n;
  }
  return result;
}
